// access.cpp

#include <windows.h>
#include <stdlib.h>
#include <string.h>
#include "msc.h"
#include "access.h"
#include "filename.h"
#include "stringex.h"


// ˂̂ FILE_TYPE_REMOTE (0x8000) ͂
#define GetFileType(h)   ( GetFileType ( h ) & ~ FILE_TYPE_REMOTE )


#define FILE_ACCESS_TESTSHARE    ( FILE_ACCESS_EXIST | FILE_ACCESS_READ | FILE_ACCESS_WRITE | FILE_ACCESS_VALID )
#define FILE_ACCESS_TESTTYPE     ( FILE_ACCESS_FILE | FILE_ACCESS_DIRECTORY | FILE_ACCESS_DEVICE )



/////////////////////////////
//         ANSI          //
/////////////////////////////



static int IsReservedDeviceNameA ( const char *szFileName ) ;



// t@C̃ANZX (ANSI)
// dwFlags Ɏw肳ꂽɍȂ 0 ȊOԂ
int IsFileAccessibleA ( const char *szFileName, unsigned long dwFlags ) {


   if ( ( dwFlags & FILE_ACCESS_TESTTYPE ) == 0 ) dwFlags |= FILE_ACCESS_TESTTYPE ;
   if ( ( dwFlags & FILE_ACCESS_TESTSHARE ) == 0 ) dwFlags |= FILE_ACCESS_EXIST ;


   // foCX
   if ( IsReservedDeviceNameA ( szFileName ) ) {
      if ( dwFlags & FILE_ACCESS_DEVICE ) {
         return 1 ;
      }
   }
   else {
      unsigned long dwFileAttributes = GetFileAttributesA ( szFileName ) ;
      if ( dwFileAttributes != (unsigned long) -1 ) {
         // fBNg
         if ( dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY ) {
            if ( dwFlags & FILE_ACCESS_DIRECTORY ) {
               if ( dwFlags & ( FILE_ACCESS_EXIST | FILE_ACCESS_VALID ) ) {
                  return 1 ;
               }
               if ( dwFlags & FILE_ACCESS_READ ) {
                  return 1 ;
               }
               if ( dwFlags & FILE_ACCESS_WRITE ) {
                  if ( ! ( dwFileAttributes & FILE_ATTRIBUTE_READONLY ) ) return 1 ;
               }
            }
         }
         // t@C
         else {
            if ( dwFlags & FILE_ACCESS_FILE ) {
               if ( dwFlags & ( FILE_ACCESS_EXIST | FILE_ACCESS_VALID ) ) {
                  return 1 ;
               }
               if ( dwFlags & FILE_ACCESS_READ ) {
                  HANDLE hFile ;
                  if ( ( hFile = CreateFileA ( szFileName, GENERIC_READ, FILE_SHARE_READ | FILE_SHARE_WRITE, NULL, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, NULL ) ) != INVALID_HANDLE_VALUE ) {
                     unsigned long dwFileType = GetFileType ( hFile ) ;
                     CloseHandle ( hFile ) ;
                     if ( dwFileType == FILE_TYPE_DISK ) return 1 ;
                  }
               }
               if ( dwFlags & FILE_ACCESS_WRITE ) {
                  HANDLE hFile ;
                  if ( ( hFile = CreateFileA ( szFileName, GENERIC_WRITE, FILE_SHARE_READ | FILE_SHARE_WRITE, NULL, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, NULL ) ) != INVALID_HANDLE_VALUE ) {
                     unsigned long dwFileType = GetFileType ( hFile ) ;
                     CloseHandle ( hFile ) ;
                     if ( dwFileType == FILE_TYPE_DISK ) return 1 ;
                  }
               }
            }
         }
      }
      // fBNg܂̓t@C݂Ȃ
      else {
         if ( dwFlags & ( FILE_ACCESS_FILE | FILE_ACCESS_DIRECTORY ) ) {
            if ( dwFlags & ( FILE_ACCESS_WRITE | FILE_ACCESS_VALID ) ) {
               HANDLE hFile ;
               if ( ( hFile = CreateFileA ( szFileName, GENERIC_READ, 0, NULL, CREATE_NEW, FILE_ATTRIBUTE_TEMPORARY | FILE_FLAG_DELETE_ON_CLOSE, NULL ) ) != INVALID_HANDLE_VALUE ) {
                  unsigned long dwFileType = GetFileType ( hFile ) ;
                  CloseHandle ( hFile ) ;
                  if ( dwFileType == FILE_TYPE_DISK ) return 1 ;
               }
            }
         }
      }
   }


   return 0 ;
}



// \񂳂ꂽfoCXǂԂ
static int IsReservedDeviceNameA ( const char *szFileName ) {

   szFileName = GetFileNameA ( szFileName ) ;
   if ( ! szFileName ) return 0 ;

   char szTmp [ MAX_PATH ] ;
   strlcpy ( szTmp, szFileName, MAX_PATH ) ;

   while ( GetExtensionA ( szTmp ) ) ChangeExtensionA ( szTmp, NULL ) ;

   if ( ! stricmp ( szTmp, "CON" ) ) return 1 ;
   if ( ! stricmp ( szTmp, "PRN" ) ) return 1 ;
   if ( ! stricmp ( szTmp, "AUX" ) ) return 1 ;
   if ( ! stricmp ( szTmp, "CLOCK$" ) ) return 1 ;
   if ( ! stricmp ( szTmp, "NUL" ) ) return 1 ;

   if ( ! strheadicmp ( szTmp, "COM" ) && szTmp [ 3 ] >= '1' && szTmp [ 3 ] <= '9' && ! szTmp [ 4 ] ) return 1 ;
   if ( ! strheadicmp ( szTmp, "LPT" ) && szTmp [ 3 ] >= '1' && szTmp [ 3 ] <= '9' && ! szTmp [ 4 ] ) return 1 ;

   return 0 ;
}



/////////////////////////////
//       UNICODE         //
/////////////////////////////



static int IsReservedDeviceNameW ( const wchar_t *szFileName ) ;



// t@C̃ANZX (UNICODE)
// dwFlags Ɏw肳ꂽɍȂ 0 ȊOԂ
int IsFileAccessibleW ( const wchar_t *szFileName, unsigned long dwFlags ) {


   if ( ( dwFlags & FILE_ACCESS_TESTTYPE ) == 0 ) dwFlags |= FILE_ACCESS_TESTTYPE ;
   if ( ( dwFlags & FILE_ACCESS_TESTSHARE ) == 0 ) dwFlags |= FILE_ACCESS_EXIST ;


   // foCX
   if ( IsReservedDeviceNameW ( szFileName ) ) {
      if ( dwFlags & FILE_ACCESS_DEVICE ) {
         return 1 ;
      }
   }
   else {
      unsigned long dwFileAttributes = GetFileAttributesW ( szFileName ) ;
      if ( dwFileAttributes != (unsigned long) -1 ) {
         // fBNg
         if ( dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY ) {
            if ( dwFlags & FILE_ACCESS_DIRECTORY ) {
               if ( dwFlags & ( FILE_ACCESS_EXIST | FILE_ACCESS_VALID ) ) {
                  return 1 ;
               }
               if ( dwFlags & FILE_ACCESS_READ ) {
                  return 1 ;
               }
               if ( dwFlags & FILE_ACCESS_WRITE ) {
                  if ( ! ( dwFileAttributes & FILE_ATTRIBUTE_READONLY ) ) return 1 ;
               }
            }
         }
         // t@C
         else {
            if ( dwFlags & FILE_ACCESS_FILE ) {
               if ( dwFlags & ( FILE_ACCESS_EXIST | FILE_ACCESS_VALID ) ) {
                  return 1 ;
               }
               if ( dwFlags & FILE_ACCESS_READ ) {
                  HANDLE hFile ;
                  if ( ( hFile = CreateFileW ( szFileName, GENERIC_READ, FILE_SHARE_READ | FILE_SHARE_WRITE, NULL, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, NULL ) ) != INVALID_HANDLE_VALUE ) {
                     unsigned long dwFileType = GetFileType ( hFile ) ;
                     CloseHandle ( hFile ) ;
                     if ( dwFileType == FILE_TYPE_DISK ) return 1 ;
                  }
               }
               if ( dwFlags & FILE_ACCESS_WRITE ) {
                  HANDLE hFile ;
                  if ( ( hFile = CreateFileW ( szFileName, GENERIC_WRITE, FILE_SHARE_READ | FILE_SHARE_WRITE, NULL, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, NULL ) ) != INVALID_HANDLE_VALUE ) {
                     unsigned long dwFileType = GetFileType ( hFile ) ;
                     CloseHandle ( hFile ) ;
                     if ( dwFileType == FILE_TYPE_DISK ) return 1 ;
                  }
               }
            }
         }
      }
      // fBNg܂̓t@C݂Ȃ
      else {
         if ( dwFlags & ( FILE_ACCESS_FILE | FILE_ACCESS_DIRECTORY ) ) {
            if ( dwFlags & ( FILE_ACCESS_WRITE | FILE_ACCESS_VALID ) ) {
               HANDLE hFile ;
               if ( ( hFile = CreateFileW ( szFileName, GENERIC_READ, 0, NULL, CREATE_NEW, FILE_ATTRIBUTE_TEMPORARY | FILE_FLAG_DELETE_ON_CLOSE, NULL ) ) != INVALID_HANDLE_VALUE ) {
                  unsigned long dwFileType = GetFileType ( hFile ) ;
                  CloseHandle ( hFile ) ;
                  if ( dwFileType == FILE_TYPE_DISK ) return 1 ;
               }
            }
         }
      }
   }


   return 0 ;
}



// \񂳂ꂽfoCXǂԂ
// pXȂ̃t@Cw肷
static int IsReservedDeviceNameW ( const wchar_t *szFileName ) {

   szFileName = GetFileNameW ( szFileName ) ;
   if ( ! szFileName ) return 0 ;

   wchar_t szTmp [ MAX_PATH ] ;
   wcslcpy ( szTmp, szFileName, MAX_PATH ) ;

   while ( GetExtensionW ( szTmp ) ) ChangeExtensionW ( szTmp, NULL ) ;

   if ( ! wcsicmp ( szTmp, L"CON" ) ) return 1 ;
   if ( ! wcsicmp ( szTmp, L"PRN" ) ) return 1 ;
   if ( ! wcsicmp ( szTmp, L"AUX" ) ) return 1 ;
   if ( ! wcsicmp ( szTmp, L"CLOCK$" ) ) return 1 ;
   if ( ! wcsicmp ( szTmp, L"NUL" ) ) return 1 ;

   if ( ! wcsheadicmp ( szTmp, L"COM" ) && szTmp [ 3 ] >= '1' && szTmp [ 3 ] <= '9' && ! szTmp [ 4 ] ) return 1 ;
   if ( ! wcsheadicmp ( szTmp, L"LPT" ) && szTmp [ 3 ] >= '1' && szTmp [ 3 ] <= '9' && ! szTmp [ 4 ] ) return 1 ;

   return 0 ;
}



