// cnvfname.cpp

#include <windows.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#include <mbctype.h>
#include "msc.h"
#include "cnvfname.h"
#include "osver.h"


// pX؂蕶ǂԂ
#define IsPathSeparator(c)          ( (c) == '\\' || (c) == '/' )

// MAX_PATH 𒴂pX
#define MAX_LONG_PATH   0x7FFF   // max len of "\\?\C:\<path>", "\\?\UNC\<server>\<share>"



/////////////////////////////
//         ANSI          //
/////////////////////////////



static char *NextPathSeparatorA ( char *szString ) ;
static int IsValidAnsiLongFileName ( const char *szLongPathName, const char *szShortFileName ) ;



// pX̃Ot@CƃV[gt@Cϊ (ANSI)
// IsConvertToShortName  0 Ȃ烍Ot@CɁA0 ȊOȂV[gt@C
// ݂Ȃt@ĆÂ܂܂̖Oɂ, ϊ
//  szDstFileName  NULL ȂϊsȂ킸ɕKvȃTCYԂiI[k܂܂Ȃj
// o͂̒ԂiI[k܂܂Ȃj
// TCYȂ 0 Ԃ
size_t ConvertFileNameA ( const char *szSrcFileName, char *szDstFileName, size_t nMaxLen, int IsConvertToShortName ) {

   int nCountDepth = 0 ;
   int IsError = 0 ;

   size_t nSrcFileNameTmpSize = strlen ( szSrcFileName ) + 1 ;
   if ( nSrcFileNameTmpSize > MAX_PATH ) return 0 ;

   char *szSrcFileNameTmp = (char*) malloc ( nSrcFileNameTmpSize * sizeof(char) ) ;
   if ( ! szSrcFileNameTmp ) return 0 ;
   strcpy ( szSrcFileNameTmp, szSrcFileName ) ;

   char *szSrc = szSrcFileNameTmp ;
   char *szDst = szDstFileName ;


   // pX̍ŏhCuȂ
   if ( *szSrc && *( szSrc + 1 ) == ':' ) nCountDepth -= 1 ;
   // pX̍ŏlbg[NȂ
   else if ( IsPathSeparator ( *szSrc ) && IsPathSeparator ( *( szSrc + 1 ) ) ) nCountDepth -= 2 ;


   while ( *szSrc ) {

      if ( IsPathSeparator ( *szSrc ) ) {
         if ( szDstFileName ) {
            if ( szDst - szDstFileName + (size_t) 1 < nMaxLen ) *szDst = *szSrc ;
            else                                                IsError = 1 ;
         }
         szSrc ++ ;
         szDst ++ ;
         continue ;
      }

      nCountDepth ++ ;

      // \[X|C^̈̕ʒu֐i߂
      char *szNextPathSeparator = NextPathSeparatorA ( szSrc ) ;
      if ( szNextPathSeparator ) *szNextPathSeparator = 0 ;

      char *szFavorite = szSrc ;

      if ( ! (
         // ChJ[h܂܂ĂÂ܂
         strchr ( szSrc, '?' ) || strchr ( szSrc, '*' ) ||
         // '.' Ȃǂ́Â܂
         strspn ( szSrc, "." ) == strlen ( szSrc ) ||
         // hCuA}V{LtH_́Â܂
         nCountDepth <= 0
      ) ) {

         // t@C擾
         WIN32_FIND_DATAA FindData ;
         HANDLE hFindFile = FindFirstFileA ( szSrcFileNameTmp, & FindData ) ;
         if ( hFindFile != INVALID_HANDLE_VALUE ) {

            FindClose ( hFindFile ) ;

            if ( IsConvertToShortName ) {
               if ( *FindData.cAlternateFileName ) szFavorite = FindData.cAlternateFileName ;
               else                                szFavorite = FindData.cFileName ;
            }
            else {
               if ( *FindData.cFileName ) szFavorite = FindData.cFileName ;
               else                       szFavorite = FindData.cAlternateFileName ;
            }

            if ( szFavorite == FindData.cFileName && strchr ( szFavorite, '?' ) ) {
               if ( *FindData.cAlternateFileName ) szFavorite = FindData.cAlternateFileName ;
               else                                szFavorite = szSrc ;
            }
            if ( szFavorite == FindData.cFileName && ! IsNT () && strchr ( szFavorite, '_' ) ) {
               szFavorite = szSrc ;
               if ( strlen ( szSrcFileNameTmp ) < MAX_PATH && strlen ( szSrcFileNameTmp ) - strlen ( szSrc ) + strlen ( FindData.cFileName ) < MAX_PATH ) {
                  char szTmp [ MAX_PATH ] ;
                  strcpy ( szTmp, szSrcFileNameTmp ) ;
                  strcpy ( szTmp + ( szSrc - szSrcFileNameTmp ), FindData.cFileName ) ;
                  if ( ! IsValidAnsiLongFileName ( szTmp, FindData.cAlternateFileName ) ) szFavorite = FindData.cAlternateFileName ;
               }
            }
         }
      }

      size_t nCopyLength = strlen ( szFavorite ) ;
      if ( szDstFileName ) {
         if ( szDst - szDstFileName + nCopyLength < nMaxLen ) strcpy ( szDst, szFavorite ) ;
         else                                                 IsError = 1 ;
      }
      szSrc = ( szNextPathSeparator ) ? *szNextPathSeparator = '\\', szNextPathSeparator : strend ( szSrc ) ;
      szDst += nCopyLength ;
   }

   if ( szDstFileName ) {
      if ( szDst - szDstFileName + (size_t) 1 <= nMaxLen ) *szDst = 0 ;
      else {
         szDstFileName [ nMaxLen -1 ] = 0 ;
         IsError = 1 ;
      }
   }

   free ( szSrcFileNameTmp ) ;

   if ( IsError ) return 0 ;

   return szDst - szDstFileName ;
}



// ̃pX؂蕶T (ANSI)
// Ȃ NULL Ԃ
static char *NextPathSeparatorA ( char *szString ) {

   for ( ; *szString ; szString ++ ) {
      if ( IsPathSeparator ( *szString ) ) return szString ;
      if ( ismbblead ( (unsigned char) *szString ) && *( szString + 1 ) ) szString ++ ;
   }
   return NULL ;
}



// Ot@CLǂ
// szPathName ̓pXtŁAszShortFileName ̓t@Ĉ݂Ŏw
static int IsValidAnsiLongFileName ( const char *szLongPathName, const char *szShortFileName ) {

   WIN32_FIND_DATAA FindData ;
   int nRetValue = 0 ;

   HANDLE hFindFile = FindFirstFileA ( szLongPathName, & FindData ) ;
   if ( hFindFile != INVALID_HANDLE_VALUE ) {
      if ( ! strcmp ( FindData.cAlternateFileName, szShortFileName ) ) nRetValue = 1 ;
      if ( FindNextFileA ( hFindFile, & FindData ) ) nRetValue = 0 ;
      FindClose ( hFindFile ) ;
   }

   return nRetValue ;
}



/////////////////////////////
//       UNICODE         //
/////////////////////////////



static wchar_t *NextPathSeparatorW ( wchar_t *szString ) ;



// pX̃Ot@CƃV[gt@Cϊ (UNICODE)
// IsConvertToShortName  0 Ȃ烍Ot@CɁA0 ȊOȂV[gt@C
// ݂Ȃt@ĆÂ܂܂̖Oɂ, ϊ
//  szDstFileName  NULL ȂϊsȂ킸ɕKvȃTCYԂiI[k܂܂Ȃj
// o͂̒ԂiI[k܂܂Ȃj
// TCYȂ 0 Ԃ
size_t ConvertFileNameW ( const wchar_t *szSrcFileName, wchar_t *szDstFileName, size_t nMaxLen, int IsConvertToShortName ) {

   int nCountDepth = 0 ;
   int IsError = 0 ;

   size_t nSrcFileNameTmpSize = wcslen ( szSrcFileName ) + 1 ;
   if ( nSrcFileNameTmpSize > MAX_LONG_PATH ) return 0 ;

   wchar_t *szSrcFileNameTmp = (wchar_t*) malloc ( nSrcFileNameTmpSize * sizeof(wchar_t) ) ;
   if ( ! szSrcFileNameTmp ) return 0 ;
   wcscpy ( szSrcFileNameTmp, szSrcFileName ) ;

   wchar_t *szSrc = szSrcFileNameTmp ;
   wchar_t *szDst = szDstFileName ;


   // pX̍ŏhCuȂ
   if ( *szSrc && *( szSrc + 1 ) == ':' ) nCountDepth -= 1 ;
   // pX̍ŏlbg[NȂ
   else if ( IsPathSeparator ( *szSrc ) && IsPathSeparator ( *( szSrc + 1 ) ) ) nCountDepth -= 2 ;


   while ( *szSrc ) {

      if ( IsPathSeparator ( *szSrc ) ) {
         if ( szDstFileName ) {
            if ( szDst - szDstFileName + (size_t) 1 < nMaxLen ) *szDst = *szSrc ;
            else                                                IsError = 1 ;
         }
         szSrc ++ ;
         szDst ++ ;
         continue ;
      }

      nCountDepth ++ ;

      // \[X|C^̈̕ʒu֐i߂
      wchar_t *szNextPathSeparator = NextPathSeparatorW ( szSrc ) ;
      if ( szNextPathSeparator ) *szNextPathSeparator = 0 ;

      wchar_t *szFavorite = szSrc ;

      if ( ! (
         // ChJ[h܂܂ĂÂ܂
         wcschr ( szSrc, '?' ) || wcschr ( szSrc, '*' ) ||
         // '.' Ȃǂ́Â܂
         wcsspn ( szSrc, L"." ) == wcslen ( szSrc ) ||
         // hCuA}V{LtH_́Â܂
         nCountDepth <= 0
      ) ) {

         // t@C擾
         WIN32_FIND_DATAW FindData ;
         HANDLE hFindFile = FindFirstFileW ( szSrcFileNameTmp, & FindData ) ;
         if ( hFindFile != INVALID_HANDLE_VALUE ) {

            FindClose ( hFindFile ) ;

            if ( IsConvertToShortName ) {
               if ( *FindData.cAlternateFileName ) szFavorite = FindData.cAlternateFileName ;
               else                                szFavorite = FindData.cFileName ;
            }
            else {
               if ( *FindData.cFileName ) szFavorite = FindData.cFileName ;
               else                       szFavorite = FindData.cAlternateFileName ;
            }
         }
      }

      size_t nCopyLength = wcslen ( szFavorite ) ;
      if ( szDstFileName ) {
         if ( szDst - szDstFileName + nCopyLength < nMaxLen ) wcscpy ( szDst, szFavorite ) ;
         else                                                 IsError = 1 ;
      }
      szSrc = ( szNextPathSeparator ) ? *szNextPathSeparator = '\\', szNextPathSeparator : wcsend ( szSrc ) ;
      szDst += nCopyLength ;
   }

   if ( szDstFileName ) {
      if ( szDst - szDstFileName + (size_t) 1 <= nMaxLen ) *szDst = 0 ;
      else {
         szDstFileName [ nMaxLen -1 ] = 0 ;
         IsError = 1 ;
      }
   }

   free ( szSrcFileNameTmp ) ;

   if ( IsError ) return 0 ;

   return szDst - szDstFileName ;
}



// ̃pX؂蕶T (UNICODE)
// Ȃ NULL Ԃ
static wchar_t *NextPathSeparatorW ( wchar_t *szString ) {

   for ( ; *szString ; szString ++ ) {
      if ( IsPathSeparator ( *szString ) ) return szString ;
   }
   return NULL ;
}



