// delete.cpp : t@C폜S~ɓ

#include <windows.h>
#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>
#include <errno.h>
#include <signal.h>
#include "msc.h"

#include "access.h"
#include "cnvfname.h"
#include "filename.h"
#include "oemio.h"
#include "osver.h"
#include "res.h"
#include "resource.h"
#include "shfileop.h"
#include "wildcard.h"
#include "winmain.h"


// R}h
static const wchar_t szCommandName [] = L"DELETE.EXE" ;


static int IsOsUnicode ;
static int IsDeleteDirectory ;
static int IsDeleteHidden ;
static int IsDeleteReadOnly ;
static int IsSearchSubdirectory ;
static int IsNoRecycleBin ;
static int IsNotDisplay ;
static int IsNotDisplayTotalNumber ;
static volatile int IsAborted ;
static int IsTooLongNameError ;
static int IsCriticalError ;
static int IsOutputUnicode ;

#ifdef NT_ONLY
#define IsOsUnicode 1
#endif


#define ShellDeleteFileA(hwnd,path,flag) ( *(strend(path)+1)=0, ShellDeleteMultipleFilesA(hwnd,path,flag) )
#define ShellDeleteFileW(hwnd,path,flag) ( *(wcsend(path)+1)=0, ShellDeleteMultipleFilesW(hwnd,path,flag) )


int DeleteFilesA ( const char *szFileName, int nSearchDepth ) ;
int DeleteFilesW ( const wchar_t *szFileName, int nSearchDepth ) ;
int GatherFileNameFromListFileA ( const char *szFileName, int nSearchDepth ) ;
int GatherFileNameFromListFileW ( const wchar_t *szFileName, int nSearchDepth ) ;
void __cdecl AbortProc ( int nSignal ) ;
int Help ( void ) ;



int main ( int argc, char *argv [] ) {

   int IsDisplayHelp = 0 ;
   int nDeletedFile = 0 ;
   int nSearchDepth = 0 ;
   int nError = 0 ;
   int IsFilenameSpecified = 0 ;


#ifndef NT_ONLY
   if ( IsNT () ) IsOsUnicode = 1 ;
#endif


   // IvV̎擾
   for ( int nCountArgv = 1 ; nCountArgv < argc ; nCountArgv ++ ) {

      char *szArgv = argv [ nCountArgv ] ;

      if ( *szArgv == '/' || *szArgv == '-' ) {
         switch ( *( szArgv + 1 ) ) {
            case 'D' :
            case 'd' :
               IsDeleteDirectory = 1 ;
               break ;
            case 'H' :
            case 'h' :
               IsDeleteHidden = 1 ;
               break ;
            case 'R' :
            case 'r' :
               IsDeleteReadOnly = 1 ;
               break ;
            case 'S' :
            case 's' :
               IsSearchSubdirectory = 1 ;
               if ( *( szArgv + 2 ) == ':' && isascii ( *( szArgv + 3 ) ) && isdigit ( *( szArgv + 3 ) ) ) {
                  char *szString ;
                  errno = 0 ;
                  nSearchDepth = strtoul ( szArgv + 3, & szString, 10 ) ;
                  if ( errno == ERANGE || *szString ) nError = nCountArgv ;
                  if ( ! nSearchDepth ) IsSearchSubdirectory = 0 ;
                  continue ;
               }
               break ;
            case 'N' :
            case 'n' :
               IsNotDisplay = 1 ;
               break ;
            case 'U' :
            case 'u' :
               IsNoRecycleBin = 1 ;
               break ;
            case 'W' :
            case 'w' :
               IsOutputUnicode = 1 ;
               break ;
            case 'Z' :
            case 'z' :
               IsNotDisplayTotalNumber = 1 ;
               break ;
#ifndef NT_ONLY
            case '9' :
               IsOsUnicode = 0 ;
               break ;
#endif
            case '?' :
               IsDisplayHelp = 1 ;
               break ;
            default :
               nError = nCountArgv ;
               break ;
         }
         if ( *( szArgv + 2 ) ) nError = nCountArgv ;
         continue ;
      }

      IsFilenameSpecified = 1 ;
   }


   // G[o͂ UNICODE 
   if ( IsOutputUnicode ) fsetmode_unicode ( stderr, 1 ) ;


   // wv\
   if ( IsDisplayHelp || argc <= 1 ) {
      Help () ;
      return 1 ;
   }

   // G[\
   if ( nError ) {
      fwprintf ( stderr, L"%s%s\n", GetStringW ( IDS_PARAERROR ), GetArgumentW ( nError ) ) ;
      return 1 ;
   }

   // t@Cw肳ĂȂ
   if ( ! IsFilenameSpecified ) {
      fputws ( GetStringW ( IDS_FILENOTSPECIFIED ), stderr ) ;
      return 1 ;
   }


   // VOi֐w
   signal ( SIGINT, AbortProc ) ;


   // t@C̏
   for ( int nCountArgv = 1 ; nCountArgv < argc ; nCountArgv ++ ) {

      if ( IsAborted ) break ;
      if ( IsCriticalError ) break ;
      if ( IsTooLongNameError ) break ;

      if ( IsOsUnicode ) {
         wchar_t *szArgv = GetArgumentW ( nCountArgv ) ;
         if ( *szArgv == '/' || *szArgv == '-' ) continue ;
         if ( *szArgv == '@' ) nDeletedFile += GatherFileNameFromListFileW ( szArgv + 1, nSearchDepth ) ;
         else                  nDeletedFile += DeleteFilesW ( szArgv, nSearchDepth ) ;
      }
      else {
         char *szArgv = argv [ nCountArgv ] ;
         if ( *szArgv == '/' || *szArgv == '-' ) continue ;
         if ( *szArgv == '@' ) nDeletedFile += GatherFileNameFromListFileA ( szArgv + 1, nSearchDepth ) ;
         else                  nDeletedFile += DeleteFilesA ( szArgv, nSearchDepth ) ;
      }
   }


   if ( IsAborted ) {
      fputws ( GetStringW ( IDS_ABORTED ), stderr ) ;
      return 1 ;
   }


   if ( IsTooLongNameError ) {
      fputws ( GetStringW ( IDS_TOOLONGNAME ), stderr ) ;
      return 1 ;
   }


   if ( IsCriticalError ) {
      fputws ( GetStringW ( IDS_UNKNOWNERROR ), stderr ) ;
      return 1 ;
   }


   if ( ! IsNotDisplay && ! IsNotDisplayTotalNumber ) {
      if ( IsDeleteDirectory ) printf ( "%d File%s/Folder%s Deleted\n", nDeletedFile, ( nDeletedFile == 1 ) ?"":"s", ( nDeletedFile == 1 ) ?"":"s" ) ;
      else                     printf ( "%d File%s Deleted\n", nDeletedFile, ( nDeletedFile == 1 ) ?"":"s" ) ;
   }

   return 0 ;
}



// ChJ[h̃R[obN֐
// TufBNg̐[𐧌䂷
int CALLBACK WildcardCallbackA ( const char *szSearchPath, WIN32_FIND_DATAA *pFindData, int nDepth, LPARAM lParam ) {
   if ( lParam ) if ( nDepth > lParam ) return -1 ;
   return 1 ;
}



// ChJ[h̃R[obN֐
// TufBNg̐[𐧌䂷
int CALLBACK WildcardCallbackW ( const wchar_t *szSearchPath, WIN32_FIND_DATAW *pFindData, int nDepth, LPARAM lParam ) {
   if ( lParam ) if ( nDepth > lParam ) return -1 ;
   return 1 ;
}



////////////////////////////////////
//         ANSI VERSION           //
////////////////////////////////////



int DisplayNowA ( const char *szFileName ) ;
int DisplaySuccessA ( const char *szFileName ) ;
int DisplayAccessErrorA ( const char *szFileName ) ;



// t@Cw肵č폜iChJ[hj
// ۂɍ폜t@C̐Ԃ
int DeleteFilesA ( const char *szSearchPath, int nSearchDepth ) {

   int nCount = 0 ;
   unsigned long dwSearchMode = WILD_SEARCH_FILE | WILD_SORT ;

   if ( IsDeleteDirectory ) dwSearchMode |= WILD_SEARCH_FOLDER ;
   if ( IsDeleteHidden ) dwSearchMode |= WILD_SEARCH_HIDDEN | WILD_SEARCH_HIDDENSUB ;
   if ( IsSearchSubdirectory ) dwSearchMode |= WILD_SEARCH_SUB ;

   if ( IsAborted ) return 0 ;

   // foCXr
   if ( IsFileAccessibleA ( szSearchPath, FILE_ACCESS_DEVICE | FILE_ACCESS_EXIST ) ) return 0 ;

   // t@Cɕϊ
   char szSearchPathLongName [ MAX_PATH ] ;
   if ( ! ConvertFileNameA ( szSearchPath, szSearchPathLongName, MAX_PATH, 0 ) ) {
      DisplayAccessErrorA ( szSearchPath ) ;
      return 0 ;
   }
   szSearchPath = szSearchPathLongName ;


   // ChJ[hWJ
   WILDCARDA *Wildcard = SearchWildcardA ( NULL, szSearchPath, dwSearchMode, WildcardCallbackA, nSearchDepth ) ;
   if ( Wildcard == NULL || Wildcard == (WILDCARDA*) -1 ) return 0 ;


   char *szDirName = NULL ;
   char *szFileName ;
   char *szString ;


   for ( szString = GetFirstFileA ( Wildcard ) ; szString ; szString = GetNextFileA ( Wildcard ) ) {

      if ( IsAborted ) break ;

      // tH_̎擾
      if ( ! GetFileNameA ( szString ) ) {
         free ( szDirName ) ;
         szDirName = (char*) malloc ( ( strlen ( szString ) + MAX_PATH ) * sizeof(char) ) ;
         if ( ! szDirName ) { IsCriticalError = 1 ; break ; }
         strcpy ( szDirName, szString ) ;
         continue ;
      }

      // t@C̎擾
      if ( szDirName ) szFileName = ChangeFileNameA ( szDirName, szString ) ;
      else             szFileName = szString ;

      // tpX̎擾
      char szFullPathName [ MAX_PATH + 8 ] ;
      if ( ! GetFullPathNameA ( szFileName, MAX_PATH, szFullPathName, & szString ) ) {
         DisplayAccessErrorA ( szFileName ) ;
         continue ;
      }

      // t@CANZX
      unsigned long dwAttributes = GetFileAttributesA ( szFileName ) ;
      if ( dwAttributes == (unsigned long) -1 ) continue ;
      if ( ! IsDeleteDirectory && ( dwAttributes & FILE_ATTRIBUTE_DIRECTORY ) ) continue ;
      if ( ! IsDeleteReadOnly && ( dwAttributes & FILE_ATTRIBUTE_READONLY ) ) {
         DisplayAccessErrorA ( szFileName ) ;
         continue ;
      }

      DisplayNowA ( szFileName ) ;

      // 폜s
      if ( ShellDeleteFileA ( NULL, szFullPathName, IsNoRecycleBin ) ) {
         DisplayAccessErrorA ( szFileName ) ;
         continue ;
      }

      DisplaySuccessA ( szFileName ) ;
      nCount ++ ;
   }


   free ( szDirName ) ;

   // ChJ[hnh
   CloseWildcardA ( Wildcard ) ;
   return nCount ;
}



int DisplayNowA ( const char *szFileName ) {

   if ( ! IsNotDisplay ) {
      fputs_line ( "Deleting  ", stdout ) ;
      fputs_line ( szFileName, stdout ) ;
   }

   return 0 ;
}



int DisplaySuccessA ( const char *szFileName ) {

   if ( ! IsNotDisplay ) {

      fputs_line ( "\r", stdout ) ;

      printf ( "Deleted   %s\n", szFileName ) ;
   }

   return 0 ;
}



int DisplayAccessErrorA ( const char *szFileName ) {

   if ( ! IsNotDisplay ) {

      fputs_line ( "\r", stdout ) ;

      printf ( "%s%s\n", szFileName, GetStringA ( IDS_ACCESSDENIED ) ) ;
   }

   return 0 ;
}



////////////////////////////////////
//       UNICODE VERSION          //
////////////////////////////////////



int DisplayNowW ( const wchar_t *szFileName ) ;
int DisplaySuccessW ( const wchar_t *szFileName ) ;
int DisplayAccessErrorW ( const wchar_t *szFileName ) ;



// t@Cw肵č폜iChJ[hj
// ۂɍ폜t@C̐Ԃ
int DeleteFilesW ( const wchar_t *szSearchPath, int nSearchDepth ) {

   int nCount = 0 ;
   unsigned long dwSearchMode = WILD_SEARCH_FILE | WILD_SORT ;

   if ( IsDeleteDirectory ) dwSearchMode |= WILD_SEARCH_FOLDER ;
   if ( IsDeleteHidden ) dwSearchMode |= WILD_SEARCH_HIDDEN | WILD_SEARCH_HIDDENSUB ;
   if ( IsSearchSubdirectory ) dwSearchMode |= WILD_SEARCH_SUB ;

   if ( IsAborted ) return 0 ;

   // foCXr
   if ( IsFileAccessibleW ( szSearchPath, FILE_ACCESS_DEVICE | FILE_ACCESS_EXIST ) ) return 0 ;

   // t@Cɕϊ
   wchar_t szSearchPathLongName [ MAX_PATH ] ;
   if ( ! ConvertFileNameW ( szSearchPath, szSearchPathLongName, MAX_PATH, 0 ) ) {
      DisplayAccessErrorW ( szSearchPath ) ;
      return 0 ;
   }
   szSearchPath = szSearchPathLongName ;


   // ChJ[hWJ
   WILDCARDW *Wildcard = SearchWildcardW ( NULL, szSearchPath, dwSearchMode, WildcardCallbackW, nSearchDepth ) ;
   if ( Wildcard == NULL || Wildcard == (WILDCARDW*) -1 ) return 0 ;


   wchar_t *szDirName = NULL ;
   wchar_t *szFileName ;
   wchar_t *szString ;


   for ( szString = GetFirstFileW ( Wildcard ) ; szString ; szString = GetNextFileW ( Wildcard ) ) {

      if ( IsAborted ) break ;

      // tH_̎擾
      if ( ! GetFileNameW ( szString ) ) {
         free ( szDirName ) ;
         szDirName = (wchar_t*) malloc ( ( wcslen ( szString ) + MAX_PATH ) * sizeof(wchar_t) ) ;
         if ( ! szDirName ) { IsCriticalError = 1 ; break ; }
         wcscpy ( szDirName, szString ) ;
         continue ;
      }

      // t@C̎擾
      if ( szDirName ) szFileName = ChangeFileNameW ( szDirName, szString ) ;
      else             szFileName = szString ;

      // tpX̎擾
      wchar_t szFullPathName [ MAX_PATH + 8 ] ;
      if ( ! GetFullPathNameW ( szFileName, MAX_PATH, szFullPathName, & szString ) ) {
         DisplayAccessErrorW ( szFileName ) ;
         continue ;
      }

      // t@CANZX
      unsigned long dwAttributes = GetFileAttributesW ( szFileName ) ;
      if ( dwAttributes == (unsigned long) -1 ) continue ;
      if ( ! IsDeleteDirectory && ( dwAttributes & FILE_ATTRIBUTE_DIRECTORY ) ) continue ;
      if ( ! IsDeleteReadOnly && ( dwAttributes & FILE_ATTRIBUTE_READONLY ) ) {
         DisplayAccessErrorW ( szFileName ) ;
         continue ;
      }

      DisplayNowW ( szFileName ) ;

      // 폜s
      if ( ShellDeleteFileW ( NULL, szFullPathName, IsNoRecycleBin ) ) {
         DisplayAccessErrorW ( szFileName ) ;
         continue ;
      }

      DisplaySuccessW ( szFileName ) ;
      nCount ++ ;
   }


   free ( szDirName ) ;

   // ChJ[hnh
   CloseWildcardW ( Wildcard ) ;
   return nCount ;
}



int DisplayNowW ( const wchar_t *szFileName ) {

   if ( ! IsNotDisplay ) {
      fputws_line ( L"Deleting  ", stdout ) ;
      fputws_line ( szFileName, stdout ) ;
   }

   return 0 ;
}



int DisplaySuccessW ( const wchar_t *szFileName ) {

   if ( ! IsNotDisplay ) {

      fputws_line ( L"\r", stdout ) ;

      wprintf ( L"Deleted   %s\n", szFileName ) ;
   }

   return 0 ;
}



int DisplayAccessErrorW ( const wchar_t *szFileName ) {

   if ( ! IsNotDisplay ) {

      fputws_line ( L"\r", stdout ) ;

      wprintf ( L"%s%s\n", szFileName, GetStringW ( IDS_ACCESSDENIED ) ) ;
   }

   return 0 ;
}



////////////////////////////////////
//              MISC              //
////////////////////////////////////



#define LINE_BUFFER_SIZE      ( MAX_PATH + 8 )



int GatherFileNameFromListFileA ( const char *szListFileName, int nSearchDepth ) {

   FILE *Fin = fopen ( szListFileName, "r" ) ;
   if ( Fin == NULL ) {
      fprintf ( stderr, "Warning : Response File \"%s\" Not Found\n", szListFileName ) ;
      return 0 ;
   }
   fsetmode_unicode_auto ( Fin ) ;

   int nCount = 0 ;

   char *szString ;
   char szFileName [ LINE_BUFFER_SIZE ] ;
   while ( fgets ( szFileName, LINE_BUFFER_SIZE, Fin ) ) {
      if ( ( szString = strchr ( szFileName, '\n' ) ) ) *szString = 0 ;
      if ( ! *szFileName ) continue ;
      if ( strlen ( szFileName ) >= MAX_PATH ) { fputs ( szFileName, stderr ) ; IsTooLongNameError = 1 ; break ; }
      UnquoteFileNameA ( szFileName ) ;
      nCount += DeleteFilesA ( szFileName, nSearchDepth ) ;
   }

   fclose ( Fin ) ;

   return nCount ;
}



int GatherFileNameFromListFileW ( const wchar_t *szListFileName, int nSearchDepth ) {

   FILE *Fin = wfopen ( szListFileName, L"r" ) ;
   if ( Fin == NULL ) {
      fwprintf ( stderr, L"Warning : Response File \"%s\" Not Found\n", szListFileName ) ;
      return 0 ;
   }
   fsetmode_unicode_auto ( Fin ) ;

   int nCount = 0 ;

   wchar_t *szString ;
   wchar_t szFileName [ LINE_BUFFER_SIZE ] ;
   while ( fgetws ( szFileName, LINE_BUFFER_SIZE, Fin ) ) {
      if ( ( szString = wcschr ( szFileName, L'\n' ) ) ) *szString = 0 ;
      if ( ! *szFileName ) continue ;
      if ( wcslen ( szFileName ) >= MAX_PATH ) { fputws ( szFileName, stderr ) ; IsTooLongNameError = 1 ; break ; }
      UnquoteFileNameW ( szFileName ) ;
      nCount += DeleteFilesW ( szFileName, nSearchDepth ) ;
   }

   fclose ( Fin ) ;

   return nCount ;
}



// I֐
void __cdecl AbortProc ( int nSignal ) {
   IsAborted = 1 ;
   AbortWildcard () ;
   signal ( nSignal, AbortProc ) ;
}



////////////////////////////////////////
//             wv                 //
////////////////////////////////////////



int Help ( void ) {

   // Wo͂ UNICODE 
   if ( IsOutputUnicode ) fsetmode_unicode ( stdout, 1 ) ;

   int nVersion ;
   FILEVERSION FileVersion ;
   if ( GetFileVersion ( & FileVersion ) ) nVersion = 0 ;
   else {
      if ( FileVersion.wMinor > 9 ) FileVersion.wMinor = 9 ;
      if ( FileVersion.wBuild > 9 ) FileVersion.wBuild = 9 ;
      nVersion = FileVersion.wMajor * 100 + FileVersion.wMinor * 10 + FileVersion.wBuild ;
   }

   fwprintf ( stdout, L" %s   version %d.%02d   %s\n\n", szCommandName, nVersion / 100, nVersion % 100, GetVersionCopyrightW () ) ;
   fputws ( GetStringW ( IDS_HELP ), stdout ) ;

   return 0 ;
}



