// filename.cpp

#include <string.h>
#include <ctype.h>
#include <mbctype.h>
#include "msc.h"

#undef DEBUG_CONST_STRING
#include "filename.h"


// pX؂蕶ǂԂ
#define IsPathSeparator(c)          ( (c) == '\\' || (c) == '/' )
#define IsPathOrDriveSeparator(c)   ( (c) == '\\' || (c) == ':' || (c) == '/' )

// ̐擪r
#define strheadcmp(s,h)    strncmp(s,h,strlen(h))
#define wcsheadcmp(s,h)    wcsncmp(s,h,wcslen(h))



////////////////////////////////////////////
//              gq擾              //
////////////////////////////////////////////



// pXgq (ANSI)
// gq '.' ܂܂Ȃ
// Ȃ NULL Ԃ
char *GetExtensionA ( const char *szPathName ) {

   const char *szExtension = NULL ;

   for ( const char *szString = szPathName ; *szString ; szString ++ ) {
      if ( *szString == '.' ) szExtension = szString + 1 ;
      if ( IsPathOrDriveSeparator ( *szString ) ) szExtension = NULL ;
      if ( ismbblead ( (unsigned char) *szString ) && *( szString + 1 ) ) szString ++ ;
   }

   return (char*) szExtension ;
}



// pXgq (UNICODE)
// gq '.' ܂܂Ȃ
// Ȃ NULL Ԃ
wchar_t *GetExtensionW ( const wchar_t *szPathName ) {

   const wchar_t *szExtension = NULL ;

   for ( const wchar_t *szString = szPathName ; *szString ; szString ++ ) {
      if ( *szString == '.' ) szExtension = szString + 1 ;
      if ( IsPathOrDriveSeparator ( *szString ) ) szExtension = NULL ;
   }

   return (wchar_t*) szExtension ;
}



////////////////////////////////////////////
//              gqύX              //
////////////////////////////////////////////



// pX̊gqύX (ANSI)
// gq '.' ܂܂Ȃ
// gq NULL w肷ƁAgq폜
// pXԂ
char *ChangeExtensionA ( char *szPathName, const char *szExtension ) {

   char *szString = GetExtensionA ( szPathName ) ;

   if ( szString ) {
      if ( szExtension ) strcpy ( szString, szExtension ) ;
      else               *( szString - 1 ) = 0 ;
   }
   else {
      if ( szExtension ) {
         szString = strend ( szPathName ) ;
         *szString = '.' ;
         strcpy ( szString + 1, szExtension ) ;
      }
   }

   return szPathName ;
}



// pX̊gqύX (UNICODE)
// gq '.' ܂܂Ȃ
// gq NULL w肷ƁAgq폜
// pXԂ
wchar_t *ChangeExtensionW ( wchar_t *szPathName, const wchar_t *szExtension ) {

   wchar_t *szString = GetExtensionW ( szPathName ) ;

   if ( szString ) {
      if ( szExtension ) wcscpy ( szString, szExtension ) ;
      else               *( szString - 1 ) = 0 ;
   }
   else {
      if ( szExtension ) {
         szString = wcsend ( szPathName ) ;
         *szString = '.' ;
         wcscpy ( szString + 1, szExtension ) ;
      }
   }

   return szPathName ;
}



////////////////////////////////////////////
//            t@C擾            //
////////////////////////////////////////////



// pXt@C (ANSI)
// Ȃ NULL Ԃ
char *GetFileNameA ( const char *szPathName ) {

   for ( const char *szString = szPathName ; *szString ; szString ++ ) {
      if ( IsPathOrDriveSeparator ( *szString ) ) szPathName = szString + 1 ;
      if ( ismbblead ( (unsigned char) *szString ) && *( szString + 1 ) ) szString ++ ;
   }

   if ( ! *szPathName ) szPathName = NULL ;

   return (char*) szPathName ;
}



// pXt@C (UNICODE)
// Ȃ NULL Ԃ
wchar_t *GetFileNameW ( const wchar_t *szPathName ) {

   for ( const wchar_t *szString = szPathName ; *szString ; szString ++ ) {
      if ( IsPathOrDriveSeparator ( *szString ) ) szPathName = szString + 1 ;
   }

   if ( ! *szPathName ) szPathName = NULL ;

   return (wchar_t*) szPathName ;
}



////////////////////////////////////////////
//            t@CύX            //
////////////////////////////////////////////



// pX̃t@CύX (ANSI)
// t@C NULL w肷ƁAt@C폜
// pXԂ
char *ChangeFileNameA ( char *szPathName, const char *szFileName ) {

   char *szString = GetFileNameA ( szPathName ) ;
   if ( ! szString ) szString = strend ( szPathName ) ;

   if ( ! szFileName ) szFileName = "" ;
   strcpy ( szString, szFileName ) ;

   return szPathName ;
}



// pX̃t@CύX (UNICODE)
// t@C NULL w肷ƁAt@C폜
// pXԂ
wchar_t *ChangeFileNameW ( wchar_t *szPathName, const wchar_t *szFileName ) {

   wchar_t *szString = GetFileNameW ( szPathName ) ;
   if ( ! szString ) szString = wcsend ( szPathName ) ;

   if ( ! szFileName ) szFileName = L"" ;
   wcscpy ( szString, szFileName ) ;

   return szPathName ;
}



////////////////////////////////////////////
//            tpX            //
////////////////////////////////////////////



// tpX (UNC܂)  (ANSI)
int IsFullPathNameA ( const char *szPathName ) {

   if ( isascii ( *szPathName ) && isalpha ( *szPathName ) ) {
      if ( *( szPathName + 1 ) == ':' && IsPathSeparator ( *( szPathName + 2 ) ) ) return 1 ;
   }

   if ( *szPathName == '\\' && *( szPathName + 1 ) == '\\' ) return 1 ;

   return 0 ;
}



// tpX (UNC܂)  (UNICODE)
int IsFullPathNameW ( const wchar_t *szPathName ) {

   if ( isascii ( *szPathName ) && isalpha ( *szPathName ) ) {
      if ( *( szPathName + 1 ) == ':' && IsPathSeparator ( *( szPathName + 2 ) ) ) return 1 ;
   }

   if ( *szPathName == '\\' && *( szPathName + 1 ) == '\\' ) return 1 ;

   return 0 ;
}



////////////////////////////////////////////
//               UNC                //
////////////////////////////////////////////



// UNC (ANSI)
int IsFileNameUncA ( const char *szPathName ) {

   if ( *szPathName == '\\' && *( szPathName + 1 ) == '\\' ) return 1 ;

   return 0 ;
}



// UNC (UNICODE)
int IsFileNameUncW ( const wchar_t *szPathName ) {

   if ( *szPathName == '\\' && *( szPathName + 1 ) == '\\' ) return 1 ;

   return 0 ;
}



////////////////////////////////////////////
//               URL                //
////////////////////////////////////////////



// URL (ANSI)
int IsFileNameUrlA ( const char *szPathName ) {

   const char *szString = szPathName ;
   while ( isascii ( *szString ) && isalpha ( *szString ) ) szString ++ ;
   if ( *szString == ':' && IsPathSeparator ( *( szString + 1 ) ) && szString - szPathName > 1 ) return 1 ;

   return 0 ;
}



// URL (UNICODE)
int IsFileNameUrlW ( const wchar_t *szPathName ) {

   const wchar_t *szString = szPathName ;
   while ( isascii ( *szString ) && isalpha ( *szString ) ) szString ++ ;
   if ( *szString == ':' && IsPathSeparator ( *( szString + 1 ) ) && szString - szPathName > 1 ) return 1 ;

   return 0 ;
}



////////////////////////////////////////////
//            pX𒲐            //
////////////////////////////////////////////



// pX̖ \ 𒲐 (ANSI)
//  IsAddSeparator  REMOVE_SEPARATOR_ALWAYS Ȃ \ 
//  IsAddSeparator  ADD_SEPARATOR_ALWAYS Ȃ \ t
//  IsAddSeparator  ADD_SEPARATOR_ONLY_ROOT Ȃ΃[gfBNĝ \ t
// pXԂ
char *SetPathSeparatorA ( char *szPathName, int IsAddSeparator ) {

   for ( char *szString = szPathName ; *szString ; szString ++ ) {
      if ( IsPathSeparator ( *szString ) && *( szString + 1 ) == 0 ) {
         *szString = 0 ;
         break ;
      }
      if ( ismbblead ( (unsigned char) *szString ) && *( szString + 1 ) ) szString ++ ;
   }

   if ( IsAddSeparator == ADD_SEPARATOR_ONLY_ROOT ) {

      char *szStart = szPathName ;

      static const char szLongPathHead [] = "\\\\?\\" ;     // for "\\?\C:\<path>", "\\?\UNC\<server>\<share>"
      if ( ! strheadcmp ( szStart, szLongPathHead ) ) szStart += strlen ( szLongPathHead ) ;

      if ( ! *szStart || isascii ( *szStart ) && isalpha ( *szStart ) && *( szStart + 1 ) == ':' && *( szStart + 2 ) == 0 ) IsAddSeparator = ADD_SEPARATOR_ALWAYS ;
   }

   if ( IsAddSeparator == ADD_SEPARATOR_ALWAYS ) strcat ( szPathName, "\\" ) ;

   return szPathName ;
}



// pX̖ \ 𒲐 (UNICODE)
//  IsAddSeparator  REMOVE_SEPARATOR_ALWAYS Ȃ \ 
//  IsAddSeparator  ADD_SEPARATOR_ALWAYS Ȃ \ t
//  IsAddSeparator  ADD_SEPARATOR_ONLY_ROOT Ȃ΃[gfBNĝ \ t
// pXԂ
wchar_t *SetPathSeparatorW ( wchar_t *szPathName, int IsAddSeparator ) {

   for ( wchar_t *szString = szPathName ; *szString ; szString ++ ) {
      if ( IsPathSeparator ( *szString ) && *( szString + 1 ) == 0 ) {
         *szString = 0 ;
         break ;
      }
   }

   if ( IsAddSeparator == ADD_SEPARATOR_ONLY_ROOT ) {

      wchar_t *szStart = szPathName ;

      static const wchar_t szLongPathHead [] = L"\\\\?\\" ;    // for "\\?\C:\<path>", "\\?\UNC\<server>\<share>"
      if ( ! wcsheadcmp ( szStart, szLongPathHead ) ) szStart += wcslen ( szLongPathHead ) ;

      if ( ! *szStart || isascii ( *szStart ) && isalpha ( *szStart ) && *( szStart + 1 ) == ':' && *( szStart + 2 ) == 0 ) IsAddSeparator = ADD_SEPARATOR_ALWAYS ;
   }

   if ( IsAddSeparator == ADD_SEPARATOR_ALWAYS ) wcscat ( szPathName, L"\\" ) ;

   return szPathName ;
}



////////////////////////////////////////////
//            dpt            //
////////////////////////////////////////////



// 󔒂Γdpň͂ށiANSIŁj
char *QuoteFileNameA ( char *szPathName ) {

   if ( strchr ( szPathName, 0x20 ) || strchr ( szPathName, '\t' ) ) {
      size_t nLength = strlen ( szPathName ) ;
      memmove ( szPathName + 1, szPathName, ( nLength + 1 ) * sizeof(char) ) ;
      *szPathName = '\"' ;
      *( szPathName + nLength + 1 ) = '\"' ;
      *( szPathName + nLength + 2 ) = 0 ;
   }

   return szPathName ;
}



// 󔒂Γdpň͂ށiUNICODEŁj
wchar_t *QuoteFileNameW ( wchar_t *szPathName ) {

   if ( wcschr ( szPathName, 0x20 ) || wcschr ( szPathName, '\t' ) ) {
      size_t nLength = wcslen ( szPathName ) ;
      memmove ( szPathName + 1, szPathName, ( nLength + 1 ) * sizeof(wchar_t) ) ;
      *szPathName = '\"' ;
      *( szPathName + nLength + 1 ) = '\"' ;
      *( szPathName + nLength + 2 ) = 0 ;
   }

   return szPathName ;
}



////////////////////////////////////////////
//            dp폜            //
////////////////////////////////////////////



// dpɈ͂܂ꂽt@Cdp菜iANSIŁj
char *UnquoteFileNameA ( char *szPathName ) {

   if ( *szPathName == '\"' ) {
      size_t nLength = strlen ( szPathName + 1 ) ;
      memmove ( szPathName, szPathName + 1, ( nLength + 1 ) * sizeof(char) ) ;
      if ( *( szPathName + nLength - 1 ) == '\"' ) *( szPathName + nLength - 1 ) = 0 ;
   }

   return szPathName ;
}



// dpɈ͂܂ꂽt@Cdp菜iUNICODEŁj
wchar_t *UnquoteFileNameW ( wchar_t *szPathName ) {

   if ( *szPathName == '\"' ) {
      size_t nLength = wcslen ( szPathName + 1 ) ;
      memmove ( szPathName, szPathName + 1, ( nLength + 1 ) * sizeof(wchar_t) ) ;
      if ( *( szPathName + nLength - 1 ) == '\"' ) *( szPathName + nLength - 1 ) = 0 ;
   }

   return szPathName ;
}



