// MSC.H

#ifndef MSC_H
#define MSC_H



////////////////////////////////////////////
//             NON-ANSI NAMES             //
////////////////////////////////////////////



// Non-ANSI names for compatibility


// <stdio.h>
#define wfopen _wfopen
#define fsopen _fsopen
#define wfsopen _wfsopen
#define snprintf _snprintf
#define snwprintf _snwprintf
#define vsnprintf _vsnprintf
#define vsnwprintf _vsnwprintf

// <conio.h>
#define outp _outp
#define inp _inp

// <stdlib.h>
#define wtoi _wtoi
#define wtol _wtol
#define wtof _wtof

// <ctype.h>
#ifndef isascii
#define isascii __isascii
#endif

// <string.h>
#define strrev _strrev
#define wcsrev _wcsrev
#define strdup _strdup
#define wcsdup _wcsdup

// <mbctype.h>
#define ismbblead _ismbblead
#define ismbbtrail _ismbbtrail
#define ismbbkana _ismbbkana

// <process.h>
#define beginthread _beginthread

#ifndef __cplusplus
#define inline __inline
#endif



////////////////////////////////////////////
//                BORLAND                 //
////////////////////////////////////////////



// for Borland C++ 5.5.1
#if defined __BORLANDC__

#pragma option -w-8008
#pragma option -w-8027
#pragma option -w-8057
#pragma option -w-8060


// <stdio.h>
#define _base buffer    // inside of FILE
#define _ptr  curp      // inside of FILE
#define _NFILE _NFILE_

// <io.h>
#define _isatty isatty
#define _setmode setmode

// <share.h>
#define _SH_DENYNO SH_DENYNO
#define _SH_DENYWR SH_DENYWR

// <stdlib.h>
#define _ultoa ultoa

// <string.h>
#define _strrev strrev
#define _strdup strdup

// "stringex.h"
#undef stricmp
#define stricmp stricmp_by_stringex
#undef strnicmp
#define strnicmp strnicmp_by_stringex
#undef strlwr
#define strlwr strlwr_by_stringex
#undef strupr
#define strupr strupr_by_stringex
#undef memicmp
#define memicmp memicmp_by_stringex

#ifdef FILENAME_MAX  // stdio.h
#include <stdarg.h>
#endif

#endif // __BORLANDC__



////////////////////////////////////////////
//              DIGITAL MARS              //
////////////////////////////////////////////



// for Digital Mars C++ 8.36
#if defined __DMC__

// variable arguments functions
#ifdef FILENAME_MAX  // stdio.h
#include <stdarg.h>
static int __cdecl swprintf_ ( wchar_t *buffer, const wchar_t *format,... ) {
   va_list args ;
   va_start ( args, format ) ;
   int result = vswprintf ( buffer, 0x7FFFFFFF, format, args ) ;
   va_end ( args ) ;
   return result ;
}
#define swprintf swprintf_
#define vswprintf(s,f,a) vswprintf(s,0x7FFFFFFF,f,a)
#endif

// "stringex.h"
#undef wmemchr
#define wmemchr wmemchr_by_stringex
#undef wmemset
#define wmemset wmemset_by_stringex

#endif // __DMC__



////////////////////////////////////////////
//                WATCOM C                //
////////////////////////////////////////////



// for Watcom C++ 1.4
#if defined __WATCOMC__

#define __cdecl

// <stdio.h>
#define _base _ptr      // inside of FILE
#define _NFILE _NFILES

// <io.h>
#define _isatty isatty
#define _setmode setmode
#define _fileno fileno

// <conio.h>
#define _outp outp
#define _inp inp

// <share.h>
#define _SH_DENYNO SH_DENYNO
#define _SH_DENYWR SH_DENYWR

// variable arguments functions
#ifdef FILENAME_MAX  // stdio.h
#include <stdarg.h>
static int __cdecl swprintf_ ( wchar_t *buffer, const wchar_t *format,... ) {
   va_list args ;
   va_start ( args, format ) ;
   int result = vswprintf ( buffer, 0x7FFFFFFF, format, args ) ;
   va_end ( args ) ;
   return result ;
}
#define swprintf swprintf_
#define vswprintf(s,f,a) vswprintf(s,0x7FFFFFFF,f,a)
#endif

#endif // __WATCOMC__



////////////////////////////////////////////
//              STDIO.H/IO.H              //
////////////////////////////////////////////



#ifdef FILENAME_MAX  // stdio.h
#include <io.h>
#include <fcntl.h>
#include <share.h>
#endif


#ifdef FILENAME_MAX  // stdio.h
#ifndef MAX_PATH
#define MAX_PATH FILENAME_MAX
#endif
#endif


// Xg[[ǂ
// [Ȃ 1 A[łȂ 0 Ԃ
// is associated with tele-typewriter
#define fisatty(stream) _isatty(_fileno(stream))

// Xg[̕ϊ[hύX
// O̕ϊ[hԂ
#define fsetmode(stream,mode) _setmode(_fileno(stream),mode)

// OS̃t@CnhԂ
#define fget_osfhandle(stream) ((void*)_get_osfhandle(_fileno(stream)))


#ifdef __cplusplus
extern "C" {
#endif

#ifdef FILENAME_MAX  // stdio.h
#if defined _MSC_VER
int __cdecl _fseeki64 ( FILE *stream, __int64 offset, int origin ) ;
__int64 __cdecl _ftelli64 ( FILE *stream ) ;
#define fseek64 _fseeki64
#define ftell64 _ftelli64
#else
#define fseek64 fseek
#define ftell64 ftell
#endif
#endif

#ifdef __cplusplus
}
#endif


// oemio.cpp

#define wprintf oem_wprintf
#define fwprintf oem_fwprintf
#define vfwprintf oem_vfwprintf
#define fputws oem_fputws
#define fgetws oem_fgetws



////////////////////////////////////////////
//                 CTYPE.H                //
////////////////////////////////////////////



#define toupper toupper_inline
#define tolower tolower_inline
static inline int toupper ( int c ) { return (c>='a' && c<='z') ? (c - 'a' + 'A') : c ; }
static inline int tolower ( int c ) { return (c>='A' && c<='Z') ? (c - 'A' + 'a') : c ; }

#define isblank isblank_inline
static inline int isblank ( int c ) { return c == 0x20 || c == '\t' ; }


// for MSC or DMC
#if defined _MSC_VER || defined __DMC__


#undef isctype
#undef isalpha
#undef isupper
#undef islower
#undef isdigit
#undef isxdigit
#undef isspace
#undef ispunct
#undef isalnum
#undef isprint
#undef isgraph
#undef iscntrl

// These macros are faster than functions in MSC's <ctype.h>.

#define isctype(c,type)    ( _pctype[c] & (type) )
#define isalpha(c)   isctype ( c, (_UPPER|_LOWER) )
#define isupper(c)   isctype ( c, _UPPER )
#define islower(c)   isctype ( c, _LOWER )
#define isdigit(c)   isctype ( c, _DIGIT )
#define isxdigit(c)  isctype ( c, _HEX )
#define isspace(c)   isctype ( c, _SPACE )
#define ispunct(c)   isctype ( c, _PUNCT )
#define isalnum(c)   isctype ( c, (_UPPER|_LOWER|_DIGIT) )
#define isprint(c)   isctype ( c, (_BLANK|_PUNCT|_UPPER|_LOWER|_DIGIT) )
#define isgraph(c)   isctype ( c, (_PUNCT|_UPPER|_LOWER|_DIGIT) )
#define iscntrl(c)   isctype ( c, _CONTROL )


// for Borland C++ 5.5.1
#elif defined __BORLANDC__


#define _UPPER    _IS_UPP
#define _LOWER    _IS_LOW
#define _DIGIT    _IS_DIG
#define _SPACE    _IS_SP
#define _PUNCT    _IS_PUN
#define _CONTROL  _IS_CTL
#define _BLANK    _IS_BLK
#define _HEX      _IS_HEX
#define _ALPHA    _IS_ALPHA

#define isctype(c,type)    ( (_chartype+1)[c] & (type) )


// for others than MSC, DMC or BCC
#else


#ifndef _UPPER
#define _UPPER    0x10000
#endif
#ifndef _LOWER
#define _LOWER    0x20000
#endif
#ifndef _DIGIT
#define _DIGIT    0x40000
#endif
#ifndef _SPACE
#define _SPACE    0x80000
#endif
#ifndef _PUNCT
#define _PUNCT    0x100000
#endif
#ifndef _CONTROL
#define _CONTROL  0x200000
#endif
#ifndef _BLANK
#define _BLANK    0x400000
#endif
#ifndef _HEX
#define _HEX      0x800000
#endif
#ifndef _ALPHA
#define _ALPHA    0x1000000
#endif

#undef isctype

// for compatibility with MSC
#define isctype(c,type) (                 \
   ( type & _UPPER && isupper(c) ) ||     \
   ( type & _LOWER && islower(c) ) ||     \
   ( type & _DIGIT && isdigit(c) ) ||     \
   ( type & _SPACE && isspace(c) ) ||     \
   ( type & _PUNCT && ispunct(c) ) ||     \
   ( type & _CONTROL && iscntrl(c) ) ||   \
   ( type & _HEX && isxdigit(c) ) ||      \
   0                                      \
)


#endif // MSC, DMC, BCC or others



////////////////////////////////////////////
//                STRING.H                //
////////////////////////////////////////////



// ̖ikjԂ
#if defined _MSC_VER && ! defined DEBUG_CONST_STRING
static inline char *strend ( const char *s ) { while ( *s ) s ++ ; return (char*) s ; }
static inline wchar_t *wcsend ( const wchar_t *s ) { while ( *s ) s ++ ; return (wchar_t*) s ; }
#else
#define strend(s)    strchr ( s, 0 )
#define wcsend(s)    wcschr ( s, 0 )
#endif


#ifdef DEBUG_CONST_STRING     // for debug
#if defined _INC_STRING && defined __cplusplus


#define FUNC_STR_STR(func,type)  \
   static inline const type *func##_ ( const type *s1, const type *s2 ) { return func ( s1, s2 ) ; } \
   static inline       type *func##_ (       type *s1, const type *s2 ) { return func ( s1, s2 ) ; }

#define FUNC_STR_INT(func,type)  \
   static inline const type *func##_ ( const type *s, int c ) { return func ( s, c ) ; } \
   static inline       type *func##_ (       type *s, int c ) { return func ( s, c ) ; }

#define FUNC_STR_INT_SIZET(func,type)  \
   static inline const type *func##_ ( const type *s, int c, size_t i ) { return func ( s, c, i ) ; } \
   static inline       type *func##_ (       type *s, int c, size_t i ) { return func ( s, c, i ) ; }


FUNC_STR_STR ( strstr, char )
FUNC_STR_STR ( wcsstr, wchar_t )
FUNC_STR_STR ( strpbrk, char )
FUNC_STR_STR ( wcspbrk, wchar_t )
FUNC_STR_INT ( strchr, char )
FUNC_STR_INT ( wcschr, wchar_t )
FUNC_STR_INT ( strrchr, char )
FUNC_STR_INT ( wcsrchr, wchar_t )
FUNC_STR_INT_SIZET ( memchr, void )


#undef FUNC_STR_STR
#undef FUNC_STR_INT
#undef FUNC_STR_INT_SIZET


#define strstr strstr_
#define wcsstr wcsstr_
#define strchr strchr_
#define wcschr wcschr_
#define strrchr strrchr_
#define wcsrchr wcsrchr_


#endif // defined _INC_STRING && defined __cplusplus
#endif // DEBUG_CONST_STRING



////////////////////////////////////////////
//                STDDEF.H                //
////////////////////////////////////////////



#include <stddef.h>


#if defined _MSC_VER && _MSC_VER < 1300 || defined __BORLANDC__ && __BORLANDC__ < 1370
typedef int intptr_t ;
typedef unsigned int uintptr_t ;
#elif defined __BORLANDC__ || defined __DMC__ || defined __WATCOMC__
#include <stdint.h>
#endif



////////////////////////////////////////////
//                LIMITS.H                //
////////////////////////////////////////////



#ifdef INT_MAX

#ifndef SIZE_MAX
#define SIZE_MAX        ((size_t)-1)
#endif
#ifndef PTRDIFF_MAX
#define PTRDIFF_MAX     ((ptrdiff_t)(((size_t)-1)>>1))
#endif
#ifndef PTRDIFF_MIN
#define PTRDIFF_MIN     ((ptrdiff_t)(~(((size_t)-1)>>1)))
#endif

#ifndef UINTPTR_MAX
#define UINTPTR_MAX     ((uintptr_t)-1)
#endif
#ifndef INTPTR_MAX
#define INTPTR_MAX      ((intptr_t)(((uintptr_t)-1)>>1))
#endif
#ifndef INTPTR_MIN
#define INTPTR_MIN      ((intptr_t)(~(((uintptr_t)-1)>>1)))
#endif

#ifndef WCHAR_MAX
#define WCHAR_MAX       ((wchar_t)-1)
#endif
#ifndef WCHAR_MIN
#define WCHAR_MIN       0
#endif

#endif // INT_MAX



////////////////////////////////////////////
//                STDARG.H                //
////////////////////////////////////////////



#ifdef va_start

#ifndef va_copy
#define va_copy(dst,src)   ((void)((dst)=(src)))
#endif

#endif // va_start



////////////////////////////////////////////
//                STDLIB.H                //
////////////////////////////////////////////


// execute.cpp

#define system ExecuteViaComspecA
#define wsystem ExecuteViaComspecW
#define _wsystem ExecuteViaComspecW


// environ.cpp

#define getenv GetEnvA
#define wgetenv GetEnvW
#define _wgetenv GetEnvW

#define putenv PutEnvA
#define _putenv PutEnvA
#define wputenv PutEnvW
#define _wputenv PutEnvW

#define setenv SetEnvA
#define _setenv SetEnvA
#define wsetenv SetEnvW
#define _wsetenv SetEnvW



////////////////////////////////////////////
//                 TIME.H                 //
////////////////////////////////////////////


// clock.cpp

#define clock clock_nt



////////////////////////////////////////////
//               WINDOWS API              //
////////////////////////////////////////////



#if defined _INC_WINDOWS || defined _WINDOWS_H

#include <commctrl.h>

#if ! defined _MSC_VER || _MSC_VER < 1300
#include <shlobj.h>
#else
#include <shtypes.h>
#endif

#if ! defined _MSC_VER || _MSC_VER < 1300
#define InterlockedExchange(Target,Value) InterlockedExchange((long*)(Target),Value)
#endif

#endif // defined _INC_WINDOWS || defined _WINDOWS_H



////////////////////////////////////////////
//                  WIN64                 //
////////////////////////////////////////////



#if defined _INC_WINDOWS || defined _WINDOWS_H

#ifndef INT_PTR
#define INT_PTR   INT
#define UINT_PTR  UINT
#define LONG_PTR  LONG
#define ULONG_PTR ULONG
#define DWORD_PTR DWORD
#endif

#ifndef GetWindowLongPtr
#define GetWindowLongPtrA  GetWindowLongA
#define GetWindowLongPtrW  GetWindowLongW
#define SetWindowLongPtrA  SetWindowLongA
#define SetWindowLongPtrW  SetWindowLongW
#ifdef UNICODE
#define GetWindowLongPtr   GetWindowLongPtrW
#define SetWindowLongPtr   SetWindowLongPtrW
#else
#define GetWindowLongPtr   GetWindowLongPtrA
#define SetWindowLongPtr   SetWindowLongPtrA
#endif
#endif

#ifndef GWLP_WNDPROC
#define GWLP_WNDPROC       GWL_WNDPROC
#define GWLP_HINSTANCE     GWL_HINSTANCE
#define GWLP_HWNDPARENT    GWL_HWNDPARENT
#define GWLP_USERDATA      GWL_USERDATA
#define GWLP_ID            GWL_ID
#endif

#endif // defined _INC_WINDOWS || defined _WINDOWS_H



////////////////////////////////////////////
//             WINDOWS VERSION            //
////////////////////////////////////////////



#ifdef _MSC_VER

#if defined WINVER && WINVER > 0x0400
#error Error: Not defined WINVER 0x0400
#endif

#if defined _WIN32_WINNT && _WIN32_WINNT > 0x0400
#error Error: Not defined _WIN32_WINNT 0x0400
#endif

#if defined _WIN32_WINDOWS && _WIN32_WINDOWS > 0x0400
#error Error: Not defined _WIN32_WINDOWS 0x0400
#endif

#if defined _WIN32_IE && _WIN32_IE > 0x0200
#error Error: Not defined _WIN32_IE 0x0200
#endif

#endif // _MSC_VER



////////////////////////////////////////////
//              STRING LOCALE             //
////////////////////////////////////////////



#pragma setlocale ("japanese")



////////////////////////////////////////////
//               CONFORMANCE              //
////////////////////////////////////////////



#ifdef _MSC_VER

#if _MSC_VER >= 1400
#pragma warning ( disable: 4996 )   // function was declared deprecated
#endif

#if _MSC_VER >= 1300
#pragma conform ( forScope, on )
#else
#define for if (0) {} else for
#endif

#if ! defined __STDC__
#error Error: Not defined __STDC__
#endif

#endif // _MSC_VER



////////////////////////////////////////////
//                 THE END                //
////////////////////////////////////////////



#endif // MSC_H


