// oemio.cpp

#include <windows.h>
#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>
#include <stdarg.h>
#include <limits.h>
#include <mbctype.h>
#include "msc.h"
#include "oemio.h"
#include "osver.h"


// Unicode  OEM ɑΉXg[o͏

// \n  \r\n ϊ CTRL-Z ւ̑Ή
// ANSI/OEM Xg[Ȃ烉Cu[ɏ
// Unicode Xg[Ȃ玩Oŏ


// fsetmode_unicode () ̑Ή
//    "r" ͑Ή
//    "w" ͑Ή
//    "a", "a+", "r+", "w+" ͖Ή
//    stdin, stdout, stderr ̃R\[o͂͑Ή (Ȃ)
//    stdout, stderr ̃_CNg ">" ͑Ή
//    stdout, stderr ̒ǉ_CNg ">>" ͑Ή
//    stdin ̃_CNg "<" ͑Ή
//    pCv͑Ή


// fsetmode_unicode_auto ̑Ή
//    "r" ͑Ή
//    "w" ͑Ή (Ȃ)
//    "a", "a+", "r+", "w+" ͖Ή
//    stdin, stdout, stderr ̃R\[o͂͑Ή (Ȃ)
//    stdout, stderr ̃_CNg ">" ͑Ή (Ȃ)
//    stdout, stderr ̒ǉ_CNg ">>" ͑Ή (Ȃ)
//    stdin ̃_CNg "<" ͑Ή
//    pCv͑Ή


// 
//
// fopen()  "r+", "a+" Ńt@CJƂAeLXgt@CȂAt@CI[̕𒲂ׁA
// ^Z ȂABt@CJƂ "b" w肳Ă΁A̓łB
// Ƃ _setmode() Ń[hύX邩ǂ́A̓Ɋ֌WȂBUnicode ͂QoCg
//  ^Z 邱Ƃ̂ŁA "r+", "a+" ̎gpɂ͒ӂKvB



/////////////////////////////
//        f[^       //
/////////////////////////////
#if defined _MSC_VER || defined __DMC__ || defined __WATCOMC__


#define OEM_STREAM_UNICODE_MODE  0x00010000
#define OEM_STREAM_TEXT_MODE     0x00020000
#define OEM_STREAM_BOM_MODE      0x00040000


#define get_unicode_mode(stream)       ( stream->_flag & OEM_STREAM_UNICODE_MODE )
#define set_unicode_mode(stream,mode)  ( (mode) ? ( stream->_flag |= OEM_STREAM_UNICODE_MODE ) : ( stream->_flag &= ~ OEM_STREAM_UNICODE_MODE ) )

#define get_text_mode(stream)          ( stream->_flag & OEM_STREAM_TEXT_MODE )
#define set_text_mode(stream,mode)     ( (mode) ? ( stream->_flag |= OEM_STREAM_TEXT_MODE ) : ( stream->_flag &= ~ OEM_STREAM_TEXT_MODE ) )

#define get_bom_mode(stream)           ( stream->_flag & OEM_STREAM_BOM_MODE )
#define set_bom_mode(stream,mode)      ( (mode) ? ( stream->_flag |= OEM_STREAM_BOM_MODE ) : ( stream->_flag &= ~ OEM_STREAM_BOM_MODE ) )



#else // defined _MSC_VER || defined __DMC__ || defined __WATCOMC__


#define get_unicode_mode(stream)       0
#define set_unicode_mode(stream,mode)  0

#define get_text_mode(stream)          0
#define set_text_mode(stream,mode)     0

#define get_bom_mode(stream)           0
#define set_bom_mode(stream,mode)      0


#endif // else of defined _MSC_VER || defined __DMC__ || defined __WATCOMC__



/////////////////////////////
//        f[^       //
/////////////////////////////


#if defined _MSC_VER
#define is_read_stream(stream)   ( ! ( stream->_flag & _IOWRT ) )
#elif defined __DMC__
#define is_read_stream(stream)   ( ! ( stream->_flag & _F_READ ) )
#elif defined __WATCOMC__
#define is_read_stream(stream)   ( ! ( stream->_flag & _READ ) )
#else
#define is_read_stream(stream)   0
#endif



/////////////////////////////
//         ʊ֐        //
/////////////////////////////



static int fsetmode_unicode_internal ( FILE *stream, int mode ) ;
static int fgetwc_straight ( FILE *stream ) ;


#define fispipe(stream)    ( GetFileType ( fget_osfhandle ( stream ) ) == FILE_TYPE_PIPE )

// ˂̂ FILE_TYPE_REMOTE (0x8000) ͂
#define GetFileType(h)   ( GetFileType ( h ) & ~ FILE_TYPE_REMOTE )



// Xg[ Unicode [hɂ
// mode  0 ȊOȂ Unicode [hɁA0 Ȃ Ansi [h
// Unicode [hȂ 0 ȊOAAnsi [hȂ 0 Ԃ
// t@C̐擪ł̂ݎwł
int fsetmode_unicode ( FILE *stream, int mode ) {

   if ( fisatty ( stream ) ) return IsNT () ;

   if ( stream->_base != stream->_ptr ) return get_unicode_mode ( stream ) ;

   return fsetmode_unicode_internal ( stream, mode ) ;
}



// Xg[ BYTE_ORDER_MARK 画f Unicode [hɂ
// Unicode [hȂ 0 ȊOAAnsi [hȂ 0 Ԃ
// t@C̐擪ł̂ݎwł
int fsetmode_unicode_auto ( FILE *stream ) {

   if ( fisatty ( stream ) ) return IsNT () ;
   if ( ! is_read_stream ( stream ) ) return 0 ;   // if not to read, cannot escape loop

   int mode = 0 ;

   if ( fispipe ( stream ) ) {

      if ( stream->_base != stream->_ptr ) return get_unicode_mode ( stream ) ;

      wchar_t wsz [ 1 ] ;
      unsigned long dwByte ;
      int result ;
      HANDLE hFile = fget_osfhandle ( stream ) ;
      while ( ( result = PeekNamedPipe ( hFile, wsz, sizeof(wchar_t), & dwByte, NULL, NULL ) ) && ! dwByte ) Sleep ( 100 ) ;
      if ( result && dwByte == sizeof(wchar_t) && *wsz == BYTE_ORDER_MARK ) mode = 1 ;

   }
   else {

      if ( ftell64 ( stream ) ) return get_unicode_mode ( stream ) ;
      fseek64 ( stream, 0, SEEK_SET ) ;

      int oldmode = fsetmode ( stream, _O_BINARY ) ;
      if ( fgetwc_straight ( stream ) == BYTE_ORDER_MARK ) mode = 1 ;

      fseek64 ( stream, 0, SEEK_SET ) ;
      fsetmode ( stream, oldmode ) ;
   }

   return fsetmode_unicode_internal ( stream, mode ) ;
}



static int fsetmode_unicode_internal ( FILE *stream, int mode ) {

   if ( mode ) {
      if ( ! get_unicode_mode ( stream ) ) {
         set_unicode_mode ( stream, 1 ) ;
         if ( fsetmode ( stream, _O_BINARY ) == _O_TEXT ) {
            set_text_mode ( stream, 1 ) ;
            if ( is_read_stream ( stream ) || fispipe ( stream ) || ! ftell64 ( stream ) ) set_bom_mode ( stream, 1 ) ;
            else                                                                           set_bom_mode ( stream, 0 ) ;
         }
         else {
            set_text_mode ( stream, 0 ) ;
            set_bom_mode ( stream, 0 ) ;
         }
      }
   }
   else {
      if ( get_unicode_mode ( stream ) ) {
         if ( get_text_mode ( stream ) ) fsetmode ( stream, _O_TEXT ) ;
         set_unicode_mode ( stream, 0 ) ;
         set_text_mode ( stream, 0 ) ;
         set_bom_mode ( stream, 0 ) ;
      }
   }

   return mode ;
}



// Xg[ Unicode [h擾
// Unicode [hȂ 0 ȊOAAnsi [hȂ 0 Ԃ
int fgetmode_unicode ( FILE *stream ) {

   if ( fisatty ( stream ) ) return IsNT () ;

   return get_unicode_mode ( stream ) ;
}



// Xg[ Unicode [hݒ/擾
// mode   Ȃ Ansi [h
//          Ȃ Unicode [h
//         0 Ȃ ݂̃[h擾
// ߂ĺAAnsi [hȂ畉Ԃ
//           Unicode [hȂ琳Ԃ
// t@C̐擪ł̂ݐݒłiȊOł̐ݒ͖`j
int fwide ( FILE *stream, int mode ) {

   if ( mode < 0 ) fsetmode_unicode ( stream, 0 ) ;
   if ( mode > 0 ) fsetmode_unicode ( stream, 1 ) ;

   return fgetmode_unicode ( stream ) ? 1 : -1 ;
}



// Xg[̃eLXg[hݒ肷
// ȑÕ[heLXg[hȂ 0 ȊOAeLXgȂ 0 Ԃ
int fsetmode_text ( FILE *stream, int mode ) {

   if ( get_unicode_mode ( stream ) ) {
      int oldmode = get_text_mode ( stream ) ;
      set_text_mode ( stream, mode ) ;
      return oldmode ;
   }
   else {
      int oldmode = fsetmode ( stream, mode ? _O_TEXT : _O_BINARY ) ;
      return ( oldmode == _O_TEXT ) ;
   }
}



// Xg[̃eLXg[h擾
// eLXg[hȂ 0 ȊOAeLXgȂ 0 Ԃ
int fgetmode_text ( FILE *stream ) {

   if ( get_unicode_mode ( stream ) ) {
      return get_text_mode ( stream ) ;
   }
   else {
      int mode = fsetmode ( stream, _O_TEXT ) ;
      fsetmode ( stream, mode ) ;
      return ( mode == _O_TEXT ) ;
   }
}



/////////////////////////////
//     o̓[eB      //
/////////////////////////////



// eLXg[h   { Ansi [h   FLFCR+LF
//                  { Console [hFLFCR+LF
//                  { Unicode [hFLFCR+LF, 擪 BOM o
// oCi[[h { Ansi [h   FLF}}
//                  { Console [hFLF}}
//                  { Unicode [hFLF}}, 擪 BOM o͂



#if ! defined _MSC_VER || _MSC_VER < 1300
static int __cdecl vscprintf ( const char *format, va_list args ) ;
static int __cdecl vscwprintf ( const wchar_t *format, va_list args ) ;
#else
#define vscprintf _vscprintf
#define vscwprintf _vscwprintf
#endif


static size_t fwrites_internal ( const char *string, size_t count, FILE *stream ) ;
static size_t fwritews_internal ( const wchar_t *string, size_t count, FILE *stream ) ;

#define TMP_BUFFER_SIZE    ( MAX_PATH + 0x10 )


#undef printf
#undef fprintf
#undef vfprintf
#undef fputs

#undef wprintf
#undef fwprintf
#undef vfwprintf
#undef fputws



/////////////////////////////
//         ANSI          //
/////////////////////////////



// ߂l fwrite Ɠ (Ԃ)
size_t __cdecl oem_fwrites ( const char *string, size_t len, FILE *stream ) {

   if ( fisatty ( stream ) ? GetACP () == GetConsoleOutputCP () : ! get_unicode_mode ( stream ) ) return fwrite ( string, sizeof(char), len, stream ) / sizeof(char) ;

   return fwrites_internal ( string, len, stream ) ;
}



// ߂l fputs Ɠ
int __cdecl oem_fputs ( const char *string, FILE *stream ) {

   size_t len = strlen ( string ) ;

   if ( oem_fwrites ( string, len, stream ) != len ) return EOF ;

   return 0 ;
}



// ߂l printf Ɠ
int __cdecl oem_printf ( const char *format,... ) {

   va_list args ;
   va_start ( args, format ) ;

   int retvalue = oem_vfprintf ( stdout, format, args ) ;

   va_end ( args ) ;
   return retvalue ;
}



// ߂l fprintf Ɠ
int __cdecl oem_fprintf ( FILE *stream, const char *format,... ) {

   va_list args ;
   va_start ( args, format ) ;

   int retvalue = oem_vfprintf ( stream, format, args ) ;

   va_end ( args ) ;
   return retvalue ;
}



// ߂l fprintf Ɠ
int __cdecl oem_vfprintf ( FILE *stream, const char *format, va_list args ) {

   if ( fisatty ( stream ) ? GetACP () == GetConsoleOutputCP () : ! get_unicode_mode ( stream ) ) return vfprintf ( stream, format, args ) ;

   char buffer [ TMP_BUFFER_SIZE ] ;
   int len ;

   if ( ( len = vsnprintf ( buffer, TMP_BUFFER_SIZE, format, args ) ) >= 0 ) {
      if ( fwrites_internal ( buffer, len, stream ) == (size_t) len ) return len ;
      else                                                            return EOF ;
   }

   char *string = NULL ;
   int retvalue = EOF ;

   va_list args1 ;
   va_list args2 ;
   va_copy ( args1, args ) ;
   va_copy ( args2, args ) ;

   if ( ( len = vscprintf ( format, args1 ) ) < 0 ) goto CAUGHT_ERROR ;
   if ( ! ( string = (char *) malloc ( ( len + 1 ) * sizeof(char) ) ) ) goto CAUGHT_ERROR ;
   if ( ( len = vsnprintf ( string, len, format, args2 ) ) < 0 ) goto CAUGHT_ERROR ;

   if ( fwrites_internal ( buffer, len, stream ) == (size_t) len ) retvalue = len ;

   CAUGHT_ERROR :
   free ( string ) ;
   va_end ( args1 ) ;
   va_end ( args2 ) ;
   return retvalue ;
}



#if ! defined _MSC_VER || _MSC_VER < 1300
// Printfϊ̏o͂ɕKvȃobt@̒擾
// ԂiI[ NULL ܂܂Ȃj
static int __cdecl vscprintf ( const char *format, va_list args ) {

   FILE *stdnul = fopen ( "NUL", "wb" ) ;
   if ( ! stdnul ) return EOF ;

   int retvalue = vfprintf ( stdnul, format, args ) ;

   fclose ( stdnul ) ;
   return retvalue ;
}
#endif



/////////////////////////////
//       UNICODE         //
/////////////////////////////



// ߂l fwrite Ɠ (Ԃ)
size_t __cdecl oem_fwritews ( const wchar_t *string, size_t len, FILE *stream ) {

   if ( get_unicode_mode ( stream ) && ! get_text_mode ( stream ) ) return fwrite ( string, sizeof(wchar_t), len, stream ) / sizeof(wchar_t) ;

   return fwritews_internal ( string, len, stream ) ;
}



// ߂l fputws Ɠ
int __cdecl oem_fputws ( const wchar_t *string, FILE *stream ) {

   size_t len = wcslen ( string ) ;

   if ( oem_fwritews ( string, len, stream ) != len ) return EOF ;

   return 0 ;
}



// ߂l wprintf Ɠ
int __cdecl oem_wprintf ( const wchar_t *format,... ) {

   va_list args ;
   va_start ( args, format ) ;

   int retvalue = oem_vfwprintf ( stdout, format, args ) ;

   va_end ( args ) ;
   return retvalue ;
}



// ߂l fwprintf Ɠ
int __cdecl oem_fwprintf ( FILE *stream, const wchar_t *format,... ) {

   va_list args ;
   va_start ( args, format ) ;

   int retvalue = oem_vfwprintf ( stream, format, args ) ;

   va_end ( args ) ;
   return retvalue ;
}



// ߂l fwprintf Ɠ
int __cdecl oem_vfwprintf ( FILE *stream, const wchar_t *format, va_list args ) {

   if ( get_unicode_mode ( stream ) && ! get_text_mode ( stream ) ) return vfwprintf ( stream, format, args ) ;

   wchar_t buffer [ TMP_BUFFER_SIZE ] ;
   int len ;

   if ( ( len = vsnwprintf ( buffer, TMP_BUFFER_SIZE, format, args ) ) >= 0 ) {
      if ( fwritews_internal ( buffer, len, stream ) == (size_t) len ) return len ;
      else                                                             return EOF ;
   }

   wchar_t *string = NULL ;
   int retvalue = EOF ;

   va_list args1 ;
   va_list args2 ;
   va_copy ( args1, args ) ;
   va_copy ( args2, args ) ;

   if ( ( len = vscwprintf ( format, args1 ) ) < 0 ) goto CAUGHT_ERROR ;
   if ( ! ( string = (wchar_t *) malloc ( ( len + 1 ) * sizeof(wchar_t) ) ) ) goto CAUGHT_ERROR ;
   if ( ( len = vsnwprintf ( string, len, format, args2 ) ) < 0 ) goto CAUGHT_ERROR ;

   if ( fwritews_internal ( string, len, stream ) == (size_t) len ) retvalue = len ;

   CAUGHT_ERROR :
   free ( string ) ;
   va_end ( args1 ) ;
   va_end ( args2 ) ;
   return retvalue ;
}



#if ! defined _MSC_VER || _MSC_VER < 1300
// Printfϊ̏o͂ɕKvȃobt@̒擾
// ԂiI[ NULL ܂܂Ȃj
static int __cdecl vscwprintf ( const wchar_t *format, va_list args ) {

   FILE *stdnul = fopen ( "NUL", "wb" ) ;
   if ( ! stdnul ) return EOF ;

   int retvalue = vfwprintf ( stdnul, format, args ) ;

   fclose ( stdnul ) ;
   return retvalue ;
}
#endif



/////////////////////////////
//         ֐        //
/////////////////////////////



static int fputwc_straight ( int c, FILE *stream ) ;
static inline void fseterror ( FILE *stream ) ;



static size_t fwrites_internal ( const char *string, size_t count, FILE *stream ) {

   size_t count_saved = count ;

   for ( ; count ; string ++, count -- ) {

      wchar_t wsz [ 1 ] ;
      int len = 1 ;

      if ( isascii ( *string ) ) {     // ̂
         wsz [ 0 ] = (unsigned char) *string ;
      }
      else {
         if ( ismbblead ( (unsigned char) *string ) && *( string + 1 ) ) len = 2 ;
         if ( ! MultiByteToWideChar ( CP_ACP, 0, string, len, wsz, 1 ) ) break ;
      }

      if ( ! fwritews_internal ( wsz, 1, stream ) ) break ;
      if ( len > 1 ) string ++, count -- ;
   }

   return count_saved - count ;
}



static size_t fwritews_internal ( const wchar_t *string, size_t count, FILE *stream ) {

   int codepage = CP_ACP ;

   if ( fisatty ( stream ) ) {
      if ( IsNT () ) {

         HANDLE hConsole = fget_osfhandle ( stream ) ;
         unsigned long dwDummy ;

         if ( GetConsoleMode ( hConsole, & dwDummy ) ) {

            fflush ( stream ) ;
            size_t count_saved = count ;

            while ( count ) {
               unsigned long dwCharToWrite = ( count == (size_t) (unsigned char) count ) ? (unsigned char) count : ( UCHAR_MAX + 1 ) ;
               unsigned long dwCharWritten = 0 ;
               if ( ! WriteConsoleW ( hConsole, string, dwCharToWrite, & dwCharWritten, NULL ) || ! dwCharWritten || count < dwCharWritten ) {
                  fseterror ( stream ) ;
                  break ;
               }
               count -= dwCharWritten ;
               string += dwCharWritten ;
            }

            return count_saved - count ;
         }

      }
      codepage = GetConsoleOutputCP () ;
   }


   if ( get_unicode_mode ( stream ) ) {

      size_t count_saved = count ;

      if ( count && get_bom_mode ( stream ) ) {
         if ( fputwc_straight ( BYTE_ORDER_MARK, stream ) < 0 ) return 0 ;
         set_bom_mode ( stream, 0 ) ;
      }

      for ( ; count ; string ++, count -- ) {
         if ( *string == '\n' && get_text_mode ( stream ) ) fputwc_straight ( '\r', stream ) ;
         if ( fputwc_straight ( *string, stream ) < 0 ) break ;
      }

      return count_saved - count ;
   }


   size_t count_saved = count ;

   for ( ; count ; string ++, count -- ) {

      char sz [ MB_LEN_MAX ] ;
      int len ;

      if ( isascii ( *string ) ) {     // ̂
         sz [ 0 ] = (unsigned char) *string ;
         len = 1 ;
      }
      else {
         if ( ! ( len = WideCharToMultiByte ( codepage, 0, string, 1, sz, MB_LEN_MAX, NULL, NULL ) ) ) break ;
      }

      for ( int i = 0 ; i < len ; i ++ ) {
         if ( fputc ( (unsigned char) sz [ i ], stream ) < 0 ) goto EXIT_LOOP ;
      }
   }

   EXIT_LOOP :

   return count_saved - count ;
}



/////////////////////////////
//     ̓[eB      //
/////////////////////////////



// eLXg[h   { Ansi [h   FCR+LFLF, CTRL-Z Ńt@CI[
//                  { Console [hFCR+LFLF, s CTRL-Z Ńt@CI[
//                  { Unicode [hFCR+LFLF,  BOM 𖳎
// oCi[[h { Ansi [h   FCR+LF}}, CTRL-Z ̓}}
//                  { Console [hFCR+LF}}, s CTRL-Z Ńt@CI[
//                  { Unicode [hFCR+LF}}, BOM ̓}}



static size_t freads_internal ( char *string, size_t count, int stop_char, FILE *stream ) ;
static size_t freadws_internal ( wchar_t *string, size_t count, int stop_char, FILE *stream ) ;
static int fgetc_internal ( FILE *stream, int is_unicode_mode, int codepage ) ;
static int fgetwc_internal ( FILE *stream, int is_unicode_mode, int codepage ) ;

#define CTRLZ     0x1A

#undef fgets
#undef fgetws



/////////////////////////////
//         ANSI          //
/////////////////////////////



// ߂l fread Ɠ (oCgԂ)
// eLXg[h܂͂QoCgł͂P`QȂƂ
// obt@EłQoCgQɊ邱Ƃ͂Ȃ
// eLXg[hł̓k폜
size_t __cdecl oem_freads ( char *string, size_t count, FILE *stream ) {
   return freads_internal ( string, count, EOF, stream ) ;
}



// ߂l fgets Ɠ
// eLXg[h܂͂QoCgł͂P`QȂƂ
// obt@EłQoCgQɊ邱Ƃ͂Ȃ
// eLXg[hł̓k폜
char *__cdecl oem_fgets ( char *string, int count, FILE *stream ) {

   if ( count <= 0 ) return NULL ;

   size_t retvalue = freads_internal ( string, count - 1, '\n', stream ) ;
   string [ retvalue ] = 0 ;

   if ( ! retvalue && feof ( stream ) ) return NULL ;
   return string ;
}



/////////////////////////////
//       UNICODE         //
/////////////////////////////



// ߂l fread Ɠ ([hԂ)
// eLXg[hł͂PȂƂ
// eLXg[hł̓k폜
size_t __cdecl oem_freadws ( wchar_t *string, size_t count, FILE *stream ) {
   return freadws_internal ( string, count, EOF, stream ) ;
}



// ߂l fgetws Ɠ
// eLXg[hł͂PȂƂ
// eLXg[hł̓k폜
wchar_t *__cdecl oem_fgetws ( wchar_t *string, int count, FILE *stream ) {

   if ( count <= 0 ) return NULL ;

   size_t retvalue = freadws_internal ( string, count - 1, '\n', stream ) ;
   string [ retvalue ] = 0 ;

   if ( ! retvalue && feof ( stream ) ) return NULL ;
   return string ;
}



/////////////////////////////
//         ֐        //
/////////////////////////////



#define getmbcp _getmbcp   // if single-byte cp, then return 0
static inline void fseteof ( FILE *stream ) ;



static size_t freads_internal ( char *string, size_t count, int stop_char, FILE *stream ) {

   int is_unicode_mode = get_unicode_mode ( stream ) ;
   int is_text_mode = is_unicode_mode ? get_text_mode ( stream ) : 0 ;

   int codepage = CP_ACP ;
   if ( fisatty ( stream ) && GetACP () != GetConsoleCP () ) codepage = GetConsoleCP () ;


   char *current = string ;
   char *end = string + count ;
   int is_first_in_line = 1 ;


   // R\[ȂꎞIɃoCi[[h
   int old_mode = 0 ;
   if ( fisatty ( stream ) ) {
      old_mode = fsetmode ( stream, _O_BINARY ) ;
      if ( old_mode == _O_TEXT ) is_text_mode = 1 ;
   }


   // \r ܂ trail byte ޏꍇɔ
   if ( is_text_mode ) end -- ;
   if ( getmbcp () ) end -- ;


   while ( current < end ) {

      int c ;

      if ( ( c = fgetc_internal ( stream, is_unicode_mode, codepage ) ) < 0 ) break ;

      if ( c == CTRLZ && is_first_in_line && fisatty ( stream ) ) {
         while ( ( c = fgetc_internal ( stream, is_unicode_mode, codepage ) ) >= 0 && c != '\n' ) ;
         fseteof ( stream ) ;
         break ;
      }

      if ( c == 0 && is_text_mode ) continue ;

      if ( c == '\r' && is_text_mode ) {
         c = fgetc_internal ( stream, is_unicode_mode, codepage ) ;
         if ( c != '\n' ) *current ++ = '\r' ;
         if ( c < 0 ) break ;
      }

      if ( c > 0x100 ) {
         *current ++ = (unsigned char) ( c >> 8 ) ;
         *current ++ = (unsigned char) c ;
      }
      else {
         *current ++ = c ;
      }

      if ( c == '\n' ) is_first_in_line = 1 ;
      else             is_first_in_line = 0 ;

      if ( c == stop_char ) break ;
   }


   if ( fisatty ( stream ) ) fsetmode ( stream, old_mode ) ;
   return current - string ;
}



static size_t freadws_internal ( wchar_t *string, size_t count, int stop_char, FILE *stream ) {

   int is_unicode_mode = get_unicode_mode ( stream ) ;
   int is_text_mode = is_unicode_mode ? get_text_mode ( stream ) : 0 ;

   int codepage = CP_ACP ;
   if ( fisatty ( stream ) && GetACP () != GetConsoleCP () ) codepage = GetConsoleCP () ;


   wchar_t *current = string ;
   wchar_t *end = string + count ;
   int is_first_in_line = 1 ;


   // R\[ȂꎞIɃoCi[[h
   int old_mode = 0 ;
   if ( fisatty ( stream ) ) {
      old_mode = fsetmode ( stream, _O_BINARY ) ;
      if ( old_mode == _O_TEXT ) is_text_mode = 1 ;
   }


   // \r ޏꍇɔ
   if ( is_text_mode ) end -- ;


   while ( current < end ) {

      int c ;

      if ( ( c = fgetwc_internal ( stream, is_unicode_mode, codepage ) ) < 0 ) break ;

      if ( c == CTRLZ && is_first_in_line && fisatty ( stream ) ) {
         while ( ( c = fgetwc_internal ( stream, is_unicode_mode, codepage ) ) >= 0 && c != '\n' ) ;
         fseteof ( stream ) ;
         break ;
      }

      if ( c == 0 && is_text_mode ) continue ;

      if ( c == '\r' && is_text_mode ) {
         c = fgetwc_internal ( stream, is_unicode_mode, codepage ) ;
         if ( c != '\n' ) *current ++ = '\r' ;
         if ( c < 0 ) break ;
      }

      if ( is_text_mode && ( c == BYTE_ORDER_MARK || c == WEOF ) ) continue ;

      *current ++ = c ;

      if ( c == '\n' ) is_first_in_line = 1 ;
      else             is_first_in_line = 0 ;

      if ( c == stop_char ) break ;
   }


   if ( fisatty ( stream ) ) fsetmode ( stream, old_mode ) ;
   return current - string ;
}



static int fgetc_internal ( FILE *stream, int is_unicode_mode, int codepage ) {

   if ( ! is_unicode_mode && codepage == CP_ACP ) {

      int c ;
      if ( ( c = fgetc ( stream ) ) < 0 ) return EOF ;

      if ( ismbblead ( c ) ) {
         int c2 ;
         if ( ( c2 = fgetc ( stream ) ) < 0 ) return EOF ;
         c = ( c << 8 ) + c2 ;
      }

      return c ;
   }
   else {

      char sz [ MB_LEN_MAX ] ;
      wchar_t wsz [ 1 ] ;
      int c ;

      while ( ( c = fgetwc_internal ( stream, is_unicode_mode, codepage ) ) == BYTE_ORDER_MARK || c == WEOF ) ;

      if ( c < 0 ) return EOF ;

      if ( isascii ( c ) ) return c ;     // ̂

      wsz [ 0 ] = c ;

      int size = WideCharToMultiByte ( CP_ACP, 0, wsz, 1, sz, MB_LEN_MAX, NULL, NULL ) ;
      if ( ! size ) return EOF ;

      if ( size == 2 ) {
         int c1 = (unsigned char) *sz ;
         int c2 = (unsigned char) *( sz + 1 ) ;
         return ( c1 << 8 ) + c2 ;
      }
      else {
         return (unsigned char) *sz ;
      }
   }
}



static int fgetwc_internal ( FILE *stream, int is_unicode_mode, int codepage ) {

   if ( fisatty ( stream ) ) {
      if ( IsNT () ) {

         HANDLE hConsole = fget_osfhandle ( stream ) ;
         unsigned long dwDummy ;

         if ( GetConsoleMode ( hConsole, & dwDummy ) ) {

            wchar_t wsz [ 1 ] ;
            unsigned long dwCharRead = 0 ;

            if ( ReadConsoleW ( hConsole, wsz, 1, & dwCharRead, NULL ) && dwCharRead ) return *wsz ;

            fseterror ( stream ) ;
            return EOF ;
         }

      }
   }

   if ( is_unicode_mode ) {

      return fgetwc_straight ( stream ) ;

   }
   else {

      char sz [ MB_LEN_MAX ] ;
      wchar_t wsz [ 1 ] ;
      int len ;
      int c ;

      if ( ( c = fgetc ( stream ) ) < 0 ) return EOF ;

      if ( isascii ( c ) ) return c ;     // ̂

      if ( IsDBCSLeadByteEx ( codepage, c ) ) {
         sz [ 0 ] = c ;
         if ( ( c = fgetc ( stream ) ) < 0 ) return EOF ;
         sz [ 1 ] = c ;
         len = 2 ;
      }
      else {
         sz [ 0 ] = c ;
         len = 1 ;
      }

      int size = MultiByteToWideChar ( codepage, 0, sz, len, wsz, 1 ) ;
      if ( ! size ) return EOF ;

      return *wsz ;
   }
}



#ifdef __BORLANDC__
#define _flag  flags
#define _IOEOF _F_EOF
#define _IOERR _F_ERR
#endif

#ifdef __WATCOMC__
#define _IOEOF _EOF
#define _IOERR _SFERR
#endif



static inline void fseteof ( FILE *stream ) {
   stream->_flag |= _IOEOF ;
}



static inline void fseterror ( FILE *stream ) {
   stream->_flag |= _IOERR ;
}



/////////////////////////////
//         ֐        //
/////////////////////////////



static int fputwc_straight ( int c, FILE *stream ) {
   if ( fputc ( (unsigned char) c, stream ) < 0 ) return EOF ;
   if ( fputc ( (unsigned char)( c >> 8 ), stream ) < 0 ) return EOF ;
   return c ;
}



static int fgetwc_straight ( FILE *stream ) {
   int c1, c2 ;
   if ( ( c1 = fgetc ( stream ) ) < 0 ) return EOF ;
   if ( ( c2 = fgetc ( stream ) ) < 0 ) return EOF ;
   return ( c2 << 8 ) + c1 ;
}



/////////////////////////////////////
//       R\[ɂPs\      //
/////////////////////////////////////



// R\[ɂPŝݕ\
// R\[łȂΉȂ
// \Ԃ
int fputs_line ( const char *string, FILE *stream ) {

   if ( ! fisatty ( stream ) ) return 0 ;

   HANDLE hConsole = fget_osfhandle ( stream ) ;
   if ( hConsole == INVALID_HANDLE_VALUE ) return 0 ;

   CONSOLE_SCREEN_BUFFER_INFO ConsoleInfo ;
   if ( ! GetConsoleScreenBufferInfo ( hConsole, & ConsoleInfo ) ) return 0 ;
   int width = ConsoleInfo.dwSize.X - ConsoleInfo.dwCursorPosition.X ;

   const char *current = string ;
   const char *start = string ;

   while ( *current ) {

      int char_width = 1 ;
      int isdoublebyte = ismbblead ( *current ) ;

      if ( *current == '\n' || *current == '\f' || *current == '\v' ) break ;
      if ( *current == '\t' ) char_width = 8 ;
      if ( *current == '\r' || *current == '\b' || *current == '\a' ) char_width = 0 ;
      if ( isdoublebyte ) char_width = 2 ;

      width -= char_width ;

      if ( width < 1 ) {

         fwrites ( string, current - string, stream ) ;
         string = current ;

         CONSOLE_SCREEN_BUFFER_INFO ConsoleInfo ;
         if ( ! GetConsoleScreenBufferInfo ( hConsole, & ConsoleInfo ) ) break ;
         width = ConsoleInfo.dwSize.X - ConsoleInfo.dwCursorPosition.X ;
         width -= char_width ;

         if ( width < 1 ) break ;
      }

      if ( isdoublebyte && *( current + 1 ) ) current ++ ;
      current ++ ;
   }

   if ( width >= 1 ) fwrites ( string, current - string, stream ) ;

   return (int) ( current - start ) ;
}



// R\[ɂPŝݕ\
// R\[łȂΉȂ
// \Ԃ
int fputws_line ( const wchar_t *string, FILE *stream ) {

   if ( ! fisatty ( stream ) ) return 0 ;

   HANDLE hConsole = fget_osfhandle ( stream ) ;
   if ( hConsole == INVALID_HANDLE_VALUE ) return 0 ;

   CONSOLE_SCREEN_BUFFER_INFO ConsoleInfo ;
   if ( ! GetConsoleScreenBufferInfo ( hConsole, & ConsoleInfo ) ) return 0 ;
   int width = ConsoleInfo.dwSize.X - ConsoleInfo.dwCursorPosition.X ;

   const wchar_t *current = string ;
   const wchar_t *start = string ;

   while ( *current ) {

      int char_width = 1 ;
      int isdoublebyte = ! isascii ( *current ) ;

      if ( *current == '\n' || *current == '\f' || *current == '\v' ) break ;
      if ( *current == '\t' ) char_width = 8 ;
      if ( *current == '\r' || *current == '\b' || *current == '\a' ) char_width = 0 ;
      if ( isdoublebyte ) char_width = 2 ;

      width -= char_width ;

      if ( width < 1 ) {

         fwritews ( string, current - string, stream ) ;
         string = current ;

         CONSOLE_SCREEN_BUFFER_INFO ConsoleInfo ;
         if ( ! GetConsoleScreenBufferInfo ( hConsole, & ConsoleInfo ) ) break ;
         width = ConsoleInfo.dwSize.X - ConsoleInfo.dwCursorPosition.X ;
         width -= char_width ;

         if ( width < 1 ) break ;
      }

      current ++ ;
   }

   if ( width >= 1 ) fwritews ( string, current - string, stream ) ;

   return (int) ( current - start ) ;
}



