// oemio.h

#ifndef OEMIO_H
#define OEMIO_H

#ifdef __cplusplus
extern "C" {
#endif


int __cdecl oem_printf ( const char *format,... ) ;
int __cdecl oem_fprintf ( FILE *stream, const char *format,... ) ;
int __cdecl oem_vfprintf ( FILE *stream, const char *format, va_list args ) ;
int __cdecl oem_fputs ( const char *string, FILE *stream ) ;
size_t __cdecl oem_fwrites ( const char *string, size_t len, FILE *stream ) ;


int __cdecl oem_wprintf ( const wchar_t *format,... ) ;
int __cdecl oem_fwprintf ( FILE *stream, const wchar_t *format,... ) ;
int __cdecl oem_vfwprintf ( FILE *stream, const wchar_t *format, va_list args ) ;
int __cdecl oem_fputws ( const wchar_t *string, FILE *stream ) ;
size_t __cdecl oem_fwritews ( const wchar_t *string, size_t len, FILE *stream ) ;


char *__cdecl oem_fgets ( char *string, int count, FILE *stream ) ;
size_t __cdecl oem_freads ( char *string, size_t count, FILE *stream ) ;
wchar_t *__cdecl oem_fgetws ( wchar_t *string, int len, FILE *stream ) ;
size_t __cdecl oem_freadws ( wchar_t *string, size_t count, FILE *stream ) ;


int fsetmode_unicode ( FILE *stream, int mode ) ;
int fsetmode_unicode_auto ( FILE *stream ) ;
int fgetmode_unicode ( FILE *stream ) ;
int fwide ( FILE *stream, int mode ) ;

int fsetmode_text ( FILE *stream, int mode ) ;
int fgetmode_text ( FILE *stream ) ;


int fputs_line ( const char *string, FILE *stream ) ;
int fputws_line ( const wchar_t *string, FILE *stream ) ;



#define printf oem_printf
#define fprintf oem_fprintf
#define vfprintf oem_vfprintf
#define fputs oem_fputs
#define fwrites oem_fwrites

#define wprintf oem_wprintf
#define fwprintf oem_fwprintf
#define vfwprintf oem_vfwprintf
#define fputws oem_fputws
#define fwritews oem_fwritews

#define fgets oem_fgets
#define freads oem_freads
#define fgetws oem_fgetws
#define freadws oem_freadws



// Byte Order Mark

#ifndef BYTE_ORDER_MARK
#define BYTE_ORDER_MARK       0xFEFF
#endif


#ifdef __cplusplus
}
#endif

#endif


