// res.cpp

#include <windows.h>
#include <stdlib.h>
#include <string.h>
#include "msc.h"
#include "osver.h"
#include "res.h"


////////////////////////////////////////
//       \[X̃CX^X       //
////////////////////////////////////////



static HINSTANCE hInstance ;



// \[X INSTANCE 
static void InitResourceInstance ( void ) {
   if ( IsNT () ) hInstance = GetModuleHandleW ( NULL ) ;
   else           hInstance = GetModuleHandleA ( NULL ) ;
#if defined _CONSOLE && ! defined NOCRT
   if ( GetConsoleOutputCP () != GetOEMCP () ) SetResourceLanguageToEnglish () ;
#endif
}



// \[X INSTANCE ύX
// hCurrentInstance  NULL w肷ƁAƂɖ߂
HINSTANCE SetResourceInstance ( HINSTANCE hNewInstance ) {
   if ( ! hInstance ) InitResourceInstance () ;
   if ( ! hNewInstance ) {
      if ( IsNT () ) hNewInstance = GetModuleHandleW ( NULL ) ;
      else           hNewInstance = GetModuleHandleA ( NULL ) ;
   }
   HINSTANCE hPrevInstance = hInstance ;
   hInstance = hNewInstance ;
   return hPrevInstance ;
}



#if ! defined NOCRT
////////////////////////////////////////
//          \[X̌            //
////////////////////////////////////////



static int nResourceLangId ;     // for Win95/98/Me or _MT


// XbȟꃍP[擾
int GetResourceLanguage ( void ) {
#ifndef _MT
   if ( IsNT () ) {
      return (LANGID) GetThreadLocale () ;
   }
   else {
#endif // _MT
      if ( ! nResourceLangId ) nResourceLangId = (LANGID) GetThreadLocale () ;
      return nResourceLangId ;
#ifndef _MT
   }
#endif // _MT
}



// XbȟꃍP[ύX
// ȑǑꃍP[Ԃ
int SetResourceLanguage ( int nLangId ) {
#ifndef _MT
   if ( IsNT () ) {
      int nPrevLangId = (LANGID) GetThreadLocale () ;
      SetThreadLocale ( nLangId ) ;
      return nPrevLangId ;
   }
   else {
#endif // _MT
      int nPrevLangId = nResourceLangId ;
      if ( ! nPrevLangId ) nPrevLangId = (LANGID) GetThreadLocale () ;
      nResourceLangId = nLangId ;
      return nPrevLangId ;
#ifndef _MT
   }
#endif // _MT
}



// XbȟꃍP[pɕύX
// SetResourceLanguage ̕ԂlԂ
int SetResourceLanguageToEnglish ( void ) {
   return SetResourceLanguage ( MAKELANGID ( LANG_ENGLISH, SUBLANG_ENGLISH_US ) ) ;
}



// SetResourceLanguageToNonEnglish ̉֐
static BOOL CALLBACK EnumResLangProcA ( HINSTANCE hInstance, const char *szType, const char *szName, unsigned short wLangId, LPARAM lParam ) {
   if ( wLangId == MAKELCID ( MAKELANGID ( LANG_ENGLISH, SUBLANG_ENGLISH_US ), SORT_DEFAULT ) ) return TRUE ;
   *(int*) lParam = wLangId ;
   return FALSE ;
}



// SetResourceLanguageToNonEnglish ̉֐
static BOOL CALLBACK EnumResLangProcW ( HINSTANCE hInstance, const wchar_t *szType, const wchar_t *szName, unsigned short wLangId, LPARAM lParam ) {
   if ( wLangId == MAKELCID ( MAKELANGID ( LANG_ENGLISH, SUBLANG_ENGLISH_US ), SORT_DEFAULT ) ) return TRUE ;
   *(int*) lParam = wLangId ;
   return FALSE ;
}



// XbȟꃍP[\[X̔p̌ɕύX
// SetResourceLanguage ̕ԂlԂ
int SetResourceLanguageToNonEnglish ( const void *nResourceType, int nResourceId ) {
   int nLangId = MAKELANGID ( LANG_ENGLISH, SUBLANG_ENGLISH_US ) ;
   if ( ! hInstance ) InitResourceInstance () ;
#if ! defined _MSC_VER || _MSC_VER < 1300
   EnumResourceLanguagesA ( hInstance, MAKEINTRESOURCEA ( nResourceType ), MAKEINTRESOURCEA ( nResourceId ), EnumResLangProcA, (LPARAM) & nLangId ) ;
#else
   if ( IsNT () ) EnumResourceLanguagesW ( hInstance, MAKEINTRESOURCEW ( nResourceType ), MAKEINTRESOURCEW ( nResourceId ), EnumResLangProcW, (LPARAM) & nLangId ) ;
   else           EnumResourceLanguagesA ( hInstance, MAKEINTRESOURCEA ( nResourceType ), MAKEINTRESOURCEA ( nResourceId ), EnumResLangProcA, (LPARAM) & nLangId ) ;
#endif
   return SetResourceLanguage ( nLangId ) ;
}



////////////////////////////////////////
//           񃊃\[X           //
////////////////////////////////////////



// LoadStringEx ̉֐
//  0 As 1 Ԃ
static int GetStringTableData ( int nId, const wchar_t **pVsString, int *pLength ) {

   HRSRC hRsrc ;
   HGLOBAL hGlobal = NULL ;
   const wchar_t *pStringTable = NULL ;

   if ( ! hInstance ) InitResourceInstance () ;
   if ( IsNT () ) {
      if ( nResourceLangId ) hRsrc = FindResourceExW ( hInstance, MAKEINTRESOURCEW ( RT_STRING ), MAKEINTRESOURCEW ( ( nId / 0x10 + 1 ) ), (LANGID) nResourceLangId ) ;
      else                   hRsrc = FindResourceExW ( hInstance, MAKEINTRESOURCEW ( RT_STRING ), MAKEINTRESOURCEW ( ( nId / 0x10 + 1 ) ), MAKELANGID ( LANG_NEUTRAL, SUBLANG_NEUTRAL ) ) ;
   }
   else {
      if ( nResourceLangId ) hRsrc = FindResourceExA ( hInstance, MAKEINTRESOURCEA ( RT_STRING ), MAKEINTRESOURCEA ( ( nId / 0x10 + 1 ) ), (LANGID) nResourceLangId ) ;
      else                   hRsrc = FindResourceExA ( hInstance, MAKEINTRESOURCEA ( RT_STRING ), MAKEINTRESOURCEA ( ( nId / 0x10 + 1 ) ), MAKELANGID ( LANG_NEUTRAL, SUBLANG_NEUTRAL ) ) ;
   }
   if ( hRsrc ) hGlobal = LoadResource ( hInstance, hRsrc ) ;
   if ( hGlobal ) pStringTable = (const wchar_t*) LockResource ( hGlobal ) ;

   if ( pStringTable ) {
      for ( int nCount = nId % 0x10 ; nCount >= 0 ; nCount -- ) {
         *pLength = *pStringTable ;
         *pVsString = pStringTable + 1 ;
         pStringTable = *pVsString + *pLength ;
      }
      return 0 ;
   }

   return 1 ;
}



// w肵ĕ񃊃\[Xobt@ɃRs[ (ANSI)
// Rs[̒Ԃ
int LoadStringExA ( int nId, char *szBuffer, int nBufferSize ) {

   if ( ! szBuffer ) return 0 ;
   if ( ! nBufferSize ) return 0 ;
   *szBuffer = 0 ;

   const wchar_t *szString ;
   int nLength ;
   if ( GetStringTableData ( nId, & szString, & nLength ) ) return 0 ;

   int nResult = WideCharToMultiByte ( CP_ACP, 0, szString, nLength, NULL, 0, NULL, NULL ) ;
   int nCopyLength = ( nResult < nBufferSize ) ? nResult : nBufferSize - 1 ;
   memset ( szBuffer, 0, ( nCopyLength + 1 ) * sizeof(char) ) ;
   WideCharToMultiByte ( CP_ACP, 0, szString, nLength, szBuffer, nCopyLength, NULL, NULL ) ;

   return (int) strlen ( szBuffer ) ;
}



// w肵ĕ񃊃\[Xobt@ɃRs[ (UNICODE)
// Rs[̒Ԃ
// Win95/98/Me łgp
int LoadStringExW ( int nId, wchar_t *szBuffer, int nBufferSize ) {

   if ( ! szBuffer ) return 0 ;
   if ( ! nBufferSize ) return 0 ;
   *szBuffer = 0 ;

   const wchar_t *szString ;
   int nLength ;
   if ( GetStringTableData ( nId, & szString, & nLength ) ) return 0 ;

   int nCopyLength = ( nLength < nBufferSize ) ? nLength : nBufferSize - 1 ;
   memmove ( szBuffer, szString, nCopyLength * sizeof(wchar_t) ) ;
   szBuffer [ nCopyLength ] = 0 ;
   return nCopyLength ;
}



static void *pGetStringBuffer ;        // for Long Strings
static void __cdecl GetStringExitProc ( void ) ;
static int IsGetStringExitProcRegistered ;


#define INT_BUFSIZE  0x100

static union {                         // for Short Strings
   char     sz [ INT_BUFSIZE ] ;
   wchar_t  wsz [ INT_BUFSIZE ] ;
} GetStringBuffer ;



// 񃊃\[Xobt@ɃRs[ (ANSI)
// ܂ꂽ͎ɂ̊֐Ă΂܂ŗL
char *GetStringA ( int nId ) {

   free ( pGetStringBuffer ) ;
   pGetStringBuffer = NULL ;

   char *szBuffer = GetStringBuffer.sz ;
   *szBuffer = 0 ;

   const wchar_t *szString ;
   int nLength ;
   if ( GetStringTableData ( nId, & szString, & nLength ) ) return szBuffer ;

   int nTmpLength = WideCharToMultiByte ( CP_ACP, 0, szString, nLength, NULL, 0, NULL, NULL ) ;
   if ( nTmpLength >= INT_BUFSIZE ) {
      if ( ! ( pGetStringBuffer = malloc ( ( nTmpLength + 1 ) * sizeof(char) ) ) ) return szBuffer ;
      if ( ! IsGetStringExitProcRegistered ) { atexit ( GetStringExitProc ) ; IsGetStringExitProcRegistered = 1 ; }
      szBuffer = (char*) pGetStringBuffer ;
   }
   nTmpLength = WideCharToMultiByte ( CP_ACP, 0, szString, nLength, szBuffer, nTmpLength, NULL, NULL ) ;

   szBuffer [ nTmpLength ] = 0 ;
   return szBuffer ;
}



// 񃊃\[Xobt@ɃRs[ (UNICODE)
// ܂ꂽ͎ɂ̊֐Ă΂܂ŗL
// Win95/98/Me łgp
wchar_t *GetStringW ( int nId ) {

   free ( pGetStringBuffer ) ;
   pGetStringBuffer = NULL ;

   wchar_t *szBuffer = GetStringBuffer.wsz ;
   *szBuffer = 0 ;

   const wchar_t *szString ;
   int nLength ;
   if ( GetStringTableData ( nId, & szString, & nLength ) ) return szBuffer ;

   if ( nLength >= INT_BUFSIZE ) {
      if ( ! ( pGetStringBuffer = malloc ( ( nLength + 1 ) * sizeof(wchar_t) ) ) ) return szBuffer ;
      if ( ! IsGetStringExitProcRegistered ) { atexit ( GetStringExitProc ) ; IsGetStringExitProcRegistered = 1 ; }
      szBuffer = (wchar_t*) pGetStringBuffer ;
   }

   memmove ( szBuffer, szString, nLength * sizeof(wchar_t) ) ;
   szBuffer [ nLength ] = 0 ;
   return szBuffer ;
}



static void __cdecl GetStringExitProc ( void ) {
   free ( pGetStringBuffer ) ;
   pGetStringBuffer = NULL ;
}



#endif // ! defined NOCRT
////////////////////////////////////////
//         o[W\[X         //
////////////////////////////////////////



// VS_VERSIONINFO, StringFileInfo, StringTable, String,...etc
#pragma pack(2)
typedef struct {
   unsigned short wLength ;
   unsigned short wValueLength ;
   unsigned short wType ;
   wchar_t szKey [ 1 ] ;
   // ȉȗ
} VS_TABLE ;
#pragma pack()



#define RoundUp(n,r)       (((n)+(r)-1)&~((r)-1))           //  2 ̙p r ̔{ɐ؂グ
#define RoundUpLong(Size)  RoundUp ( Size, sizeof(long) )   // 32rbgEɐ؂グ

#define GetVsValue(pVs)    ( (const void*)     ( (pVs->wValueLength) ? ( (char*)pVs + RoundUpLong ( (char*)( wcsend ( pVs->szKey ) + 1 ) - (char*)pVs ) ) : NULL ) )
#define GetVsChildren(pVs) ( (const VS_TABLE*) ( (char*)pVs + RoundUpLong ( (char*)( wcsend ( pVs->szKey ) + 1 ) - (char*)pVs ) + RoundUpLong ( pVs->wValueLength << ( (pVs->wType)? 1 : 0 ) ) ) )
#define GetVsNext(pVs)     ( (const VS_TABLE*) ( (char*)pVs + RoundUpLong ( pVs->wLength ) ) )
#define GetVsEnd(pVs)      ( (const VS_TABLE*) ( (char*)pVs + pVs->wLength ) )



// \[X VS_TABLE ւ̃|C^擾
// o[W\[XȂ NULL Ԃ
static const VS_TABLE *GetVersionInfo ( void ) {

   HRSRC hRsrc ;
   HGLOBAL hGlobal = NULL ;
   const VS_TABLE *pVsVersionInfo = NULL ;

   if ( ! hInstance ) InitResourceInstance () ;
   if ( IsNT () ) hRsrc = FindResourceExW ( hInstance, MAKEINTRESOURCEW ( RT_VERSION ), MAKEINTRESOURCEW ( VS_VERSION_INFO ), MAKELANGID ( LANG_NEUTRAL, SUBLANG_NEUTRAL ) ) ;
   else           hRsrc = FindResourceExA ( hInstance, MAKEINTRESOURCEA ( RT_VERSION ), MAKEINTRESOURCEA ( VS_VERSION_INFO ), MAKELANGID ( LANG_NEUTRAL, SUBLANG_NEUTRAL ) ) ;
   if ( hRsrc ) hGlobal = LoadResource ( hInstance, hRsrc ) ;
   if ( hGlobal ) pVsVersionInfo = (const VS_TABLE*) LockResource ( hGlobal ) ;

   return pVsVersionInfo ;
}



// o[W擾
//  0 As 0 ȊOԂ
int GetFileVersion ( FILEVERSION *pFileVersion ) {

   const VS_TABLE *pVsVersionInfo = GetVersionInfo () ;
   if ( ! pVsVersionInfo ) return 1 ;

   const VS_FIXEDFILEINFO *pFixedFileInfo = (const VS_FIXEDFILEINFO*) GetVsValue ( pVsVersionInfo ) ;
   if ( ! pFixedFileInfo ) return 1 ;

   pFileVersion->wMajor = HIWORD ( pFixedFileInfo->dwProductVersionMS ) ;
   pFileVersion->wMinor = LOWORD ( pFixedFileInfo->dwProductVersionMS ) ;
   pFileVersion->wBuild = HIWORD ( pFixedFileInfo->dwProductVersionLS ) ;
   pFileVersion->wPrivate = LOWORD ( pFixedFileInfo->dwProductVersionLS ) ;

   return 0 ;
}



// o[Wr
int CompareFileVersion ( FILEVERSION *pFileVersion1, FILEVERSION *pFileVersion2 ) {

   if ( pFileVersion1->wMajor != pFileVersion2->wMajor ) return (short) ( pFileVersion1->wMajor - pFileVersion2->wMajor ) ;
   if ( pFileVersion1->wMinor != pFileVersion2->wMinor ) return (short) ( pFileVersion1->wMinor - pFileVersion2->wMinor ) ;
   if ( pFileVersion1->wBuild != pFileVersion2->wBuild ) return (short) ( pFileVersion1->wBuild - pFileVersion2->wBuild ) ;
   if ( pFileVersion1->wPrivate != pFileVersion2->wPrivate ) return (short) ( pFileVersion1->wPrivate - pFileVersion2->wPrivate ) ;

   return 0 ;
}



////////////////////////////////////////
//      o[W\[X ()     //
////////////////////////////////////////



// R[obN֐ 0 ԂA񋓂~
//                    0 ȊOԂA񋓂p
// szKey  NULL Ȃ pValue ɂ 32rbg̐
//     łȂȂ pValue ɂ Unicode  ܂ NULL 
static int EnumVsTable ( int nLevel, const VS_TABLE *pVsTable, int ( CALLBACK *Callback ) ( int nLevel, const wchar_t *szKey, const wchar_t *szValue, const long *pValue, size_t nLength, LPARAM lParam ), LPARAM lParam ) {

   if ( pVsTable->wType ) {
      if ( ! Callback ( nLevel, pVsTable->szKey, (const wchar_t*) GetVsValue ( pVsTable ), NULL, pVsTable->wValueLength, lParam ) ) return 0 ;
   }
   else {
      if ( ! Callback ( nLevel, pVsTable->szKey, NULL, (const long*) GetVsValue ( pVsTable ), ( pVsTable->wValueLength / sizeof(long) ), lParam ) ) return 0 ;
   }

   const VS_TABLE *pChildStart = GetVsChildren ( pVsTable ) ;
   const VS_TABLE *pChildEnd = GetVsEnd ( pVsTable ) ;

   for ( const VS_TABLE *pChild = pChildStart ; pChild < pChildEnd ; pChild = GetVsNext ( pChild ) ) {
      if ( ! EnumVsTable ( nLevel + 1, pChild, Callback, lParam ) ) return 0 ;
   }

   return 1 ;
}



// o[W
//  0 As 0 ȊOԂ
int EnumVersionInfo ( int ( CALLBACK *Callback ) ( int nLevel, const wchar_t *szKey, const wchar_t *szValue, const long *pValue, size_t nLength, LPARAM lParam ), LPARAM lParam ) {

   const VS_TABLE *pVsVersionInfo = GetVersionInfo () ;
   if ( ! pVsVersionInfo ) return 1 ;

   EnumVsTable ( 0, pVsVersionInfo, Callback, lParam ) ;

   return 0 ;
}



#if ! defined NOCRT
////////////////////////////////////////
//   o[W\[X (쌠\)  //
////////////////////////////////////////



static void __cdecl CopyrightExitProc ( void ) ;
static int IsCopyrightExitProcRegistered ;
static char *szCopyrightA ;



// \[X̒쌠\擾 (ANSI)
// ̌̏񂪂΁Aŏ̌̏Ԃ
// o[W\[XȂ΁A[̕Ԃ
const char *GetVersionCopyrightA ( void ) {

   free ( szCopyrightA ) ;
   szCopyrightA = NULL ;

   const wchar_t *szString = GetVersionCopyrightW () ;

   int nLength ;

   if ( ! ( nLength = WideCharToMultiByte ( CP_ACP, 0, szString, -1, NULL, 0, NULL, NULL ) ) ) return "" ;
   if ( ! ( szCopyrightA = (char*) malloc ( nLength * sizeof(char) ) ) ) return "" ;
   if ( ! IsCopyrightExitProcRegistered ) { atexit ( CopyrightExitProc ) ; IsCopyrightExitProcRegistered = 1 ; }
   if ( ! ( nLength = WideCharToMultiByte ( CP_ACP, 0, szString, -1, szCopyrightA, nLength, NULL, NULL ) ) ) return "" ;

   return szCopyrightA ;
}



static void __cdecl CopyrightExitProc ( void ) {
   free ( szCopyrightA ) ;
   szCopyrightA = NULL ;
}



typedef struct {
   int IsStringFileInfo ;
   const wchar_t *szResult ;
} SEARCH_COPYRIGHT_INFO ;



static int CALLBACK CallbackSearchCopyRight ( int nLevel, const wchar_t *szKey, const wchar_t *szValue, const long *pValue, size_t nLength, LPARAM lParam ) {

   SEARCH_COPYRIGHT_INFO *pSearchCopyrightInfo = (SEARCH_COPYRIGHT_INFO*) lParam ;

   if ( ! szKey ) return 1 ;

   if ( nLevel == 1 ) {
      if ( ! wcscmp ( szKey, L"StringFileInfo" ) ) pSearchCopyrightInfo->IsStringFileInfo = 1 ;
      else                                         pSearchCopyrightInfo->IsStringFileInfo = 0 ;
   }

   if ( nLevel == 3 ) {
      if ( pSearchCopyrightInfo->IsStringFileInfo && ! wcscmp ( szKey, L"LegalCopyright" ) ) {
         pSearchCopyrightInfo->szResult = (const wchar_t*) szValue ;
         return 0 ;
      }
   }

   return 1 ;
}



// \[X̒쌠\擾 (UNICODE)
// ̌̏񂪂΁Aŏ̌̏Ԃ
// o[W\[XȂ΁A[̕Ԃ
const wchar_t *GetVersionCopyrightW ( void ) {

   SEARCH_COPYRIGHT_INFO SearchCopyrightInfo = { 0 } ;
   EnumVersionInfo ( CallbackSearchCopyRight, (LPARAM) & SearchCopyrightInfo ) ;
   if ( ! SearchCopyrightInfo.szResult ) return L"" ;

   return SearchCopyrightInfo.szResult ;
}



#endif // ! defined NOCRT



#if ( ! defined _CONSOLE && ! defined _USRDLL || defined LOAD_USER32_DLL ) && ! defined NOCRT
////////////////////////////////////////
//          ACR\[X          //
////////////////////////////////////////



// ACRԂ
HICON LoadIconEx ( int nId ) {
   if ( ! hInstance ) InitResourceInstance () ;
   if ( IsNT () ) return LoadIconW ( hInstance, MAKEINTRESOURCEW ( nId ) ) ;
   else           return LoadIconA ( hInstance, MAKEINTRESOURCEA ( nId ) ) ;
}



// VXeACRԂ
HICON LoadSystemIcon ( const void *nId ) {
   if ( IsNT () ) return LoadIconW ( NULL, MAKEINTRESOURCEW ( nId ) ) ;
   else           return LoadIconA ( NULL, MAKEINTRESOURCEA ( nId ) ) ;
}



////////////////////////////////////////
//         _CAO\[X         //
////////////////////////////////////////



#pragma pack(2)
typedef struct {
   unsigned short dlgVer ;
   unsigned short signature ;
   unsigned long helpID ;
   unsigned long exStyle ;
   unsigned long style ;
   unsigned short cDlgItems ;
   short x ;
   short y ;
   short cx ;
   short cy ;
   // ȉȗ
} DLGTEMPLATEEX ;
#pragma pack()



// \[X̃_CAOev[g̃AhX擾
// pSize Ƀev[g̃TCYi[
// _CAOȂ NULL Ԃ
static const DLGTEMPLATE *GetDialog ( int nTemplate ) {

   HRSRC hRsrc ;
   HGLOBAL hGlobal = NULL ;
   const DLGTEMPLATE *pDlg = NULL ;

   if ( ! hInstance ) InitResourceInstance () ;
   if ( IsNT () ) {
      if ( nResourceLangId ) hRsrc = FindResourceExW ( hInstance, MAKEINTRESOURCEW ( RT_DIALOG ), MAKEINTRESOURCEW ( nTemplate ), (LANGID) nResourceLangId ) ;
      else                   hRsrc = FindResourceExW ( hInstance, MAKEINTRESOURCEW ( RT_DIALOG ), MAKEINTRESOURCEW ( nTemplate ), MAKELANGID ( LANG_NEUTRAL, SUBLANG_NEUTRAL ) ) ;
   }
   else {
      if ( nResourceLangId ) hRsrc = FindResourceExA ( hInstance, MAKEINTRESOURCEA ( RT_DIALOG ), MAKEINTRESOURCEA ( nTemplate ), (LANGID) nResourceLangId ) ;
      else                   hRsrc = FindResourceExA ( hInstance, MAKEINTRESOURCEA ( RT_DIALOG ), MAKEINTRESOURCEA ( nTemplate ), MAKELANGID ( LANG_NEUTRAL, SUBLANG_NEUTRAL ) ) ;
   }
   if ( hRsrc ) hGlobal = LoadResource ( hInstance, hRsrc ) ;
   if ( hGlobal ) pDlg = (const DLGTEMPLATE*) LockResource ( hGlobal ) ;

   return pDlg ;
}



// _CAÕev[gtHg̃AhX擾
//  0 As 1 Ԃ
static int GetDialogFontInfo ( int nTemplate, int *pFontSize, const wchar_t **pFontName ) {

   const wchar_t *szMenu ;
   const wchar_t *szClass ;
   const wchar_t *szTitle ;
   const wchar_t *szFontSize ;

   const DLGTEMPLATE *pDlg = GetDialog ( nTemplate ) ;
   if ( pDlg == NULL ) return 1 ;

   const DLGTEMPLATEEX *pDlgEx = (const DLGTEMPLATEEX*) pDlg ;
   if ( pDlgEx->signature != 0xFFFF ) pDlgEx = NULL ;

   if ( pDlgEx ) {
      if ( ! ( pDlgEx->style & DS_SETFONT ) ) return 1 ;
      szMenu = (const wchar_t*) ( pDlgEx + 1 ) ;
   }
   else {
      if ( ! ( pDlg->style & DS_SETFONT ) ) return 1 ;
      szMenu = (const wchar_t*) ( pDlg + 1 ) ;
   }

   if ( *szMenu == 0xFFFF ) szClass = szMenu + 2 ;
   else                     szClass = wcsend ( szMenu ) + 1 ;

   if ( *szClass == 0xFFFF ) szTitle = szClass + 2 ;
   else                      szTitle = wcsend ( szClass ) + 1 ;

   szFontSize = wcsend ( szTitle ) + 1 ;

   if ( pFontSize ) *pFontSize = *szFontSize ;
   if ( pFontName ) *pFontName = szFontSize + ( pDlgEx ? 3 : 1 ) ;

   return 0 ;
}



// _CAÕev[gtHg擾 (ANSI)
// tHgTCYAs 0 Ԃ
int GetDialogFontA ( int nTemplate, char *szFontName, int nBufferSize ) {

   if ( szFontName && nBufferSize ) *szFontName = 0 ;

   int nSize ;
   const wchar_t *szString ;
   if ( GetDialogFontInfo ( nTemplate, & nSize, & szString ) ) return 0 ;

   if ( szFontName && nBufferSize ) {

      size_t STRING_LENGTH = wcslen ( szString ) ;
      int nLength = ( STRING_LENGTH >= LF_FACESIZE ) ? LF_FACESIZE - 1 : (int) STRING_LENGTH ;

      int nResult = WideCharToMultiByte ( CP_ACP, 0, szString, nLength, NULL, 0, NULL, NULL ) ;
      int nCopyLength = ( nResult < nBufferSize ) ? nResult : nBufferSize - 1 ;
      memset ( szFontName, 0, ( nCopyLength + 1 ) * sizeof(char) ) ;
      WideCharToMultiByte ( CP_ACP, 0, szString, nLength, szFontName, nCopyLength, NULL, NULL ) ;
   }

   return nSize ;
}



// _CAÕev[gtHg擾 (UNICODE)
// tHgTCYAs 0 Ԃ
int GetDialogFontW ( int nTemplate, wchar_t *szFontName, int nBufferSize ) {

   if ( szFontName && nBufferSize ) *szFontName = 0 ;

   int nSize ;
   const wchar_t *szString ;
   if ( GetDialogFontInfo ( nTemplate, & nSize, & szString ) ) return 0 ;

   if ( szFontName && nBufferSize ) {

      size_t STRING_LENGTH = wcslen ( szString ) ;
      int nLength = ( STRING_LENGTH >= LF_FACESIZE ) ? LF_FACESIZE - 1 : (int) STRING_LENGTH ;

      int nCopyLength = ( nLength < nBufferSize ) ? nLength : nBufferSize - 1 ;
      memmove ( szFontName, szString, nCopyLength * sizeof(wchar_t) ) ;
      szFontName [ nCopyLength ] = 0 ;
   }

   return nSize ;
}



////////////////////////////////////////
//      _CAŐN (PARAM)      //
////////////////////////////////////////



// P[ɉă_CAON (ANSI)
INT_PTR DialogBoxParamExA ( int nTemplate, HWND hWnd, DLGPROC pDialogProc, LPARAM lParam ) {

   const DLGTEMPLATE *pDlg = GetDialog ( nTemplate ) ;
   if ( ! pDlg ) return -1 ;

   return DialogBoxIndirectParamA ( hInstance, pDlg, hWnd, pDialogProc, lParam ) ;
}



// P[ɉă_CAON (UNICODE)
INT_PTR DialogBoxParamExW ( int nTemplate, HWND hWnd, DLGPROC pDialogProc, LPARAM lParam ) {

   const DLGTEMPLATE *pDlg = GetDialog ( nTemplate ) ;
   if ( ! pDlg ) return -1 ;

   return DialogBoxIndirectParamW ( hInstance, pDlg, hWnd, pDialogProc, lParam ) ;
}



// P[ɉă[hX_CAON (ANSI)
HWND CreateDialogParamExA ( int nTemplate, HWND hParent, DLGPROC pDialogProc, LPARAM lParam ) {

   const DLGTEMPLATE *pDlg = GetDialog ( nTemplate ) ;
   if ( ! pDlg ) return NULL ;

   return CreateDialogIndirectParamA ( hInstance, pDlg, hParent, pDialogProc, lParam ) ;
}



// P[ɉă[hX_CAON (UNICODE)
HWND CreateDialogParamExW ( int nTemplate, HWND hParent, DLGPROC pDialogProc, LPARAM lParam ) {

   const DLGTEMPLATE *pDlg = GetDialog ( nTemplate ) ;
   if ( ! pDlg ) return NULL ;

   return CreateDialogIndirectParamW ( hInstance, pDlg, hParent, pDialogProc, lParam ) ;
}



////////////////////////////////////////
//          _CAŐN          //
////////////////////////////////////////



// P[ɉă_CAON (ANSI)
INT_PTR DialogBoxExA ( int nTemplate, HWND hWnd, DLGPROC pDialogProc ) {
   return DialogBoxParamExA ( nTemplate, hWnd, pDialogProc, 0 ) ;
}



// P[ɉă_CAON (UNICODE)
INT_PTR DialogBoxExW ( int nTemplate, HWND hWnd, DLGPROC pDialogProc ) {
   return DialogBoxParamExW ( nTemplate, hWnd, pDialogProc, 0 ) ;
}



// P[ɉă[hX_CAON (ANSI)
HWND CreateDialogExA ( int nTemplate, HWND hParent, DLGPROC pDialogProc ) {
   return CreateDialogParamExA ( nTemplate, hParent, pDialogProc, 0 ) ;
}



// P[ɉă[hX_CAON (UNICODE)
HWND CreateDialogExW ( int nTemplate, HWND hParent, DLGPROC pDialogProc ) {
   return CreateDialogParamExW ( nTemplate, hParent, pDialogProc, 0 ) ;
}



#endif // ( ! defined _CONSOLE && ! defined _USRDLL || defined LOAD_USER32_DLL ) && ! defined NOCRT



