// res.h

#ifndef RES_H
#define RES_H

#ifdef __cplusplus
extern "C" {
#endif


HINSTANCE SetResourceInstance ( HINSTANCE hNewInstance ) ;
int GetResourceLanguage ( void ) ;
int SetResourceLanguage ( int nLangId ) ;
int SetResourceLanguageToEnglish ( void ) ;
int SetResourceLanguageToNonEnglish ( const void *nResourceType, int nResourceId ) ;


char *GetStringA ( int nId ) ;
wchar_t *GetStringW ( int nId ) ;
int LoadStringExA ( int nId, char *szBuffer, int nBufferSize ) ;
int LoadStringExW ( int nId, wchar_t *szBuffer, int nBufferSize ) ;


HICON LoadIconEx ( int nId ) ;
HICON LoadSystemIcon ( const void *nId ) ;


int GetDialogFontA ( int nTemplate, char *szFontName, int nBufferSize ) ;
int GetDialogFontW ( int nTemplate, wchar_t *szFontName, int nBufferSize ) ;


INT_PTR DialogBoxParamExA ( int nTemplate, HWND hWnd, DLGPROC pDialogProc, LPARAM lParam ) ;
INT_PTR DialogBoxParamExW ( int nTemplate, HWND hWnd, DLGPROC pDialogProc, LPARAM lParam ) ;
HWND CreateDialogParamExA ( int nTemplate, HWND hParent, DLGPROC pDialogProc, LPARAM lParam ) ;
HWND CreateDialogParamExW ( int nTemplate, HWND hParent, DLGPROC pDialogProc, LPARAM lParam ) ;


INT_PTR DialogBoxExA ( int nTemplate, HWND hWnd, DLGPROC pDialogProc ) ;
INT_PTR DialogBoxExW ( int nTemplate, HWND hWnd, DLGPROC pDialogProc ) ;
HWND CreateDialogExA ( int nTemplate, HWND hParent, DLGPROC pDialogProc ) ;
HWND CreateDialogExW ( int nTemplate, HWND hParent, DLGPROC pDialogProc ) ;


typedef struct {
   unsigned short wMajor ;
   unsigned short wMinor ;
   unsigned short wBuild ;
   unsigned short wPrivate ;
} FILEVERSION ;


int GetFileVersion ( FILEVERSION *pFileVersion ) ;
int CompareFileVersion ( FILEVERSION *pFileVersion1, FILEVERSION *pFileVersion2 ) ;
int EnumVersionInfo ( int ( CALLBACK *Callback ) ( int nLevel, const wchar_t *szKey, const wchar_t *szValue, const long *pValue, size_t ValueLength, LPARAM lParam ), LPARAM lParam ) ;
const char *GetVersionCopyrightA ( void ) ;
const wchar_t *GetVersionCopyrightW ( void ) ;



#ifdef UNICODE
#define GetString GetStringW
#define LoadStringEx LoadStringExW
#define GetDialogFont GetDialogFontW
#define DialogBoxParamEx DialogBoxParamExW
#define CreateDialogParamEx CreateDialogParamExW
#define DialogBoxEx DialogBoxExW
#define CreateDialogEx CreateDialogExW
#define GetVersionCopyright GetVersionCopyrightW
#else
#define GetString GetStringA
#define LoadStringEx LoadStringExA
#define GetDialogFont GetDialogFontA
#define DialogBoxParamEx DialogBoxParamExA
#define CreateDialogParamEx CreateDialogParamExA
#define DialogBoxEx DialogBoxExA
#define CreateDialogEx CreateDialogExA
#define GetVersionCopyright GetVersionCopyrightA
#endif


#ifdef __cplusplus
}
#endif

#endif


