// storestr.cpp

#include <windows.h>
#include <stdlib.h>
#include <string.h>
#include "msc.h"
#include "storestr.h"

#define DEBUG_STORESTR  0

#if DEBUG_STORESTR
#include <stdio.h>
#endif


// obt@TCY
#define INIT_BUFFER_SIZE 0x400

// PKoCg
#define ONE_MEGA_BYTE 0x100000



/////////////////////////////
//         ANSI          //
/////////////////////////////



// obt@ɂ߂ (ANSI)
// obt@̊mۂɎsƂ́Aobt@NA -1 Ԃ
// nhɂ FreeStoredStrings () Ăяo
// oɂ GetFirstString ()  GetNextString () Ăяo
// vf̌ GetStringCount () т
// nh܂ł́Aǉ邱Ƃł
STOREDSTRINGSA *StoreStringsA ( STOREDSTRINGSA *StoredStrings, const char *szString ) {

   if ( StoredStrings == (STOREDSTRINGSA*) -1 ) return (STOREDSTRINGSA*) -1 ;

   if ( ! StoredStrings ) {
      StoredStrings = (STOREDSTRINGSA*) malloc ( sizeof(STOREDSTRINGSA) ) ;
      if ( ! StoredStrings ) return (STOREDSTRINGSA*) -1 ;
      memset ( StoredStrings, 0, sizeof(STOREDSTRINGSA) ) ;
   }

   if ( szString ) {

      size_t nStringLen = strlen ( szString ) ;
      if ( ! nStringLen ) return StoredStrings ;
      size_t dwRequiredBufferSize = ( StoredStrings->szWrite - StoredStrings->szStart + nStringLen + 2 ) * sizeof(char) ;

      if ( StoredStrings->dwBufferSize < dwRequiredBufferSize ) {

         size_t dwNewBufferSize ;
         if ( ! StoredStrings->dwBufferSize )                    dwNewBufferSize = INIT_BUFFER_SIZE ;
         else if ( StoredStrings->dwBufferSize < ONE_MEGA_BYTE ) dwNewBufferSize = StoredStrings->dwBufferSize * 4 ;
         else                                                    dwNewBufferSize = StoredStrings->dwBufferSize + ONE_MEGA_BYTE ;

         if ( dwNewBufferSize < dwRequiredBufferSize ) dwNewBufferSize = dwRequiredBufferSize ;

#if DEBUG_STORESTR
         FILE *Fout = fopen ( "storestr.debug.txt", "ac" ) ;
         fprintf ( Fout, "%X,%X,%s\n", StoredStrings->dwBufferSize, dwNewBufferSize, szString ) ;
         fclose ( Fout ) ;
#endif

         char *szNewBuffer = (char*) realloc ( StoredStrings->szStart, dwNewBufferSize ) ;

         if ( ! szNewBuffer || StoredStrings->dwBufferSize > dwNewBufferSize ) {
            FreeStoredStringsA ( StoredStrings ) ;
            return (STOREDSTRINGSA*) -1 ;
         }

         char *szOldBuffer = StoredStrings->szStart ;
         StoredStrings->szStart = szNewBuffer ;
         StoredStrings->szWrite += szNewBuffer - szOldBuffer ;
         StoredStrings->szRead += szNewBuffer - szOldBuffer ;
         StoredStrings->szSortStart += szNewBuffer - szOldBuffer ;
         StoredStrings->dwBufferSize = dwNewBufferSize ;
      }

      strcpy ( StoredStrings->szWrite, szString ) ;
      StoredStrings->szWrite += nStringLen + 1 ;
      *( StoredStrings->szWrite ) = 0 ;
      StoredStrings->nCount ++ ;
   }

   return StoredStrings ;
}



// obt@ (ANSI)
void FreeStoredStringsA ( STOREDSTRINGSA *StoredStrings ) {
   if ( ! StoredStrings || StoredStrings == (STOREDSTRINGSA*) -1 ) return ;
   free ( StoredStrings->szStart ) ;
   free ( StoredStrings ) ;
   return ;
}



// obt@ŏ̕Ԃ (ANSI)
// 񂪂Ȃ΁ANULL Ԃ
char *GetFirstStringA ( STOREDSTRINGSA *StoredStrings ) {
   if ( ! StoredStrings || StoredStrings == (STOREDSTRINGSA*) -1 ) return NULL ;
   return StoredStrings->szRead = StoredStrings->szStart ;
}



// obt@玟̕Ԃ (ANSI)
// 񂪂Ȃ΁ANULL Ԃ
// GetFirstString () ĂяoOȂ΁A͕s
char *GetNextStringA ( STOREDSTRINGSA *StoredStrings ) {
   if ( ! StoredStrings || StoredStrings == (STOREDSTRINGSA*) -1 ) return NULL ;
   char *szNext = strend ( StoredStrings->szRead ) + 1 ;
   if ( *szNext ) return StoredStrings->szRead = szNext ;
   return NULL ;
}



// obt@̌̕Ԃ (ANSI)
size_t GetStringCountA ( STOREDSTRINGSA *StoredStrings ) {
   if ( ! StoredStrings || StoredStrings == (STOREDSTRINGSA*) -1 ) return 0 ;
   return StoredStrings->nCount ;
}



static int __cdecl StoredStringsCompareA ( const void *pArg1, const void *pArg2 ) ;
static int __cdecl StoredStringsCompareReverseA ( const void *pArg1, const void *pArg2 ) ;



// obt@̕\[g (ANSI)
// CompareFuntion ɂ SORT_STOREDSTRINGS_NORMAL, SORT_STOREDSTRINGS_REVERSE ܂̓[U`̔r֐w
// O MarkSortStart () ǂݏoꂽAȍ~ɒǉꂽ̂݃\[g
int SortStoredStringsA ( STOREDSTRINGSA *StoredStrings, int (__cdecl *CompareFunction )(const void *, const void *) ) {

   STOREDSTRINGSA *StoredStringsTmp = NULL ;
   size_t nCount ;
   int nResult = 1 ;

   char *szStart ;
   size_t nItem ;

   if ( ! StoredStrings ) return 0 ;

   if ( ! CompareFunction ) return 1 ;
   else if ( CompareFunction == SORT_STOREDSTRINGS_NORMAL ) CompareFunction = StoredStringsCompareA ;
   else if ( CompareFunction == SORT_STOREDSTRINGS_REVERSE ) CompareFunction = StoredStringsCompareReverseA ;

   if ( StoredStrings->szSortStart ) {
      szStart = StoredStrings->szSortStart ;
      nItem = StoredStrings->nCount - StoredStrings->nSortStartCount ;
   }
   else {
      szStart = StoredStrings->szStart ;
      nItem = StoredStrings->nCount ;
   }

   if ( nItem <= 1 ) return 0 ;

   char **pPointerToName = (char**) malloc ( ( nItem ) * sizeof(char*) ) ;
   if ( ! pPointerToName ) return 1 ;

   char *szStringGet = szStart ;
   for ( nCount = 0 ; nCount < nItem ; nCount ++ ) {
      pPointerToName [ nCount ] = szStringGet ;
      szStringGet = strend ( szStringGet ) + 1 ;
   }

   qsort ( pPointerToName, nItem, sizeof(char*), CompareFunction ) ;

   for ( nCount = 0 ; nCount < nItem ; nCount ++ ) {
      StoredStringsTmp = StoreStringsA ( StoredStringsTmp, pPointerToName [ nCount ] ) ;
      if ( StoredStringsTmp == (STOREDSTRINGSA*) -1 ) break ;
   }
   if ( StoredStringsTmp && StoredStringsTmp != (STOREDSTRINGSA*) -1 ) {
      memmove ( szStart, GetFirstStringA ( StoredStringsTmp ), ( szStringGet - szStart ) * sizeof(char) ) ;
      FreeStoredStringsA ( StoredStringsTmp ) ;
      nResult = 0 ;
   }

   free ( pPointerToName ) ;
   return nResult ;
}



// Ń\[g
static int __cdecl StoredStringsCompareA ( const void *pArg1, const void *pArg2 ) {
   return CompareStringA ( LOCALE_SYSTEM_DEFAULT, 0, *(const char**)pArg1, -1, *(const char**)pArg2, -1 ) - 2 ;
}



// tŃ\[g
static int __cdecl StoredStringsCompareReverseA ( const void *pArg1, const void *pArg2 ) {
   return - ( CompareStringA ( LOCALE_SYSTEM_DEFAULT, 0, *(const char**)pArg1, -1, *(const char**)pArg2, -1 ) - 2 ) ;
}



// ȍ~ɒǉꂽ̂ SortStoredStrings () Ń\[g (ANSI)
int MarkSortStartA ( STOREDSTRINGSA *StoredStrings ) {
   if ( ! StoredStrings || StoredStrings == (STOREDSTRINGSA*) -1 ) return NULL ;
   StoredStrings->szSortStart = StoredStrings->szWrite ;
   StoredStrings->nSortStartCount = StoredStrings->nCount ;
   return 0 ;
}



// MarkSortStartŎw肳ꂽ}[N (ANSI)
int UnmarkSortStartA ( STOREDSTRINGSA *StoredStrings ) {
   if ( ! StoredStrings || StoredStrings == (STOREDSTRINGSA*) -1 ) return NULL ;
   StoredStrings->szSortStart = NULL ;
   StoredStrings->nSortStartCount = 0 ;
   return 0 ;
}



// obt@}[Nꂽŏ̕Ԃ (ANSI)
// 񂪂Ȃ΁ANULL Ԃ
char *GetFirstMarkedStringA ( STOREDSTRINGSA *StoredStrings ) {
   if ( ! StoredStrings || StoredStrings == (STOREDSTRINGSA*) -1 ) return NULL ;
   if ( StoredStrings->szSortStart ) return StoredStrings->szRead = StoredStrings->szSortStart ;
   else                              return StoredStrings->szRead = StoredStrings->szStart ;
}



/////////////////////////////
//       UNICODE         //
/////////////////////////////



// obt@ɂ߂ (UNICODE)
// obt@̊mۂɎsƂ́Aobt@NA -1 Ԃ
// nhɂ FreeStoredStrings () Ăяo
// oɂ GetFirstString ()  GetNextString () Ăяo
// vf̌ GetStringCount () т
// nh܂ł́Aǉ邱Ƃł
STOREDSTRINGSW *StoreStringsW ( STOREDSTRINGSW *StoredStrings, const wchar_t *szString ) {

   if ( StoredStrings == (STOREDSTRINGSW*) -1 ) return (STOREDSTRINGSW*) -1 ;

   if ( ! StoredStrings ) {
      StoredStrings = (STOREDSTRINGSW*) malloc ( sizeof(STOREDSTRINGSW) ) ;
      if ( ! StoredStrings ) return (STOREDSTRINGSW*) -1 ;
      memset ( StoredStrings, 0, sizeof(STOREDSTRINGSW) ) ;
   }

   if ( szString ) {

      size_t nStringLen = wcslen ( szString ) ;
      if ( ! nStringLen ) return StoredStrings ;
      size_t dwRequiredBufferSize = ( StoredStrings->szWrite - StoredStrings->szStart + nStringLen + 2 ) * sizeof(wchar_t) ;

      if ( StoredStrings->dwBufferSize < dwRequiredBufferSize ) {

         size_t dwNewBufferSize ;
         if ( ! StoredStrings->dwBufferSize )                    dwNewBufferSize = INIT_BUFFER_SIZE ;
         else if ( StoredStrings->dwBufferSize < ONE_MEGA_BYTE ) dwNewBufferSize = StoredStrings->dwBufferSize * 4 ;
         else                                                    dwNewBufferSize = StoredStrings->dwBufferSize + ONE_MEGA_BYTE ;

         if ( dwNewBufferSize < dwRequiredBufferSize ) dwNewBufferSize = dwRequiredBufferSize ;

#if DEBUG_STORESTR
         FILE *Fout = fopen ( "storestr.debug.txt", "ac" ) ;
         fprintf ( Fout, "%X,%X,%s\n", StoredStrings->dwBufferSize, dwNewBufferSize, szString ) ;
         fclose ( Fout ) ;
#endif

         wchar_t *szNewBuffer = (wchar_t*) realloc ( StoredStrings->szStart, dwNewBufferSize ) ;

         if ( ! szNewBuffer || StoredStrings->dwBufferSize > dwNewBufferSize ) {
            FreeStoredStringsW ( StoredStrings ) ;
            return (STOREDSTRINGSW*) -1 ;
         }

         wchar_t *szOldBuffer = StoredStrings->szStart ;
         StoredStrings->szStart = szNewBuffer ;
         StoredStrings->szWrite += szNewBuffer - szOldBuffer ;
         StoredStrings->szRead += szNewBuffer - szOldBuffer ;
         StoredStrings->szSortStart += szNewBuffer - szOldBuffer ;
         StoredStrings->dwBufferSize = dwNewBufferSize ;
      }

      wcscpy ( StoredStrings->szWrite, szString ) ;
      StoredStrings->szWrite += nStringLen + 1 ;
      *( StoredStrings->szWrite ) = 0 ;
      StoredStrings->nCount ++ ;
   }

   return StoredStrings ;
}



// obt@
void FreeStoredStringsW ( STOREDSTRINGSW *StoredStrings ) {
   if ( ! StoredStrings || StoredStrings == (STOREDSTRINGSW*) -1 ) return ;
   free ( StoredStrings->szStart ) ;
   free ( StoredStrings ) ;
   return ;
}



// obt@ŏ̕Ԃ (UNICODE)
// 񂪂Ȃ΁ANULL Ԃ
wchar_t *GetFirstStringW ( STOREDSTRINGSW *StoredStrings ) {
   if ( ! StoredStrings || StoredStrings == (STOREDSTRINGSW*) -1 ) return NULL ;
   return StoredStrings->szRead = StoredStrings->szStart ;
}



// obt@玟̕Ԃ (UNICODE)
// 񂪂Ȃ΁ANULL Ԃ
// GetFirstString () ĂяoOȂ΁A͕s
wchar_t *GetNextStringW ( STOREDSTRINGSW *StoredStrings ) {
   if ( ! StoredStrings || StoredStrings == (STOREDSTRINGSW*) -1 ) return NULL ;
   wchar_t *szNext = wcsend ( StoredStrings->szRead ) + 1 ;
   if ( *szNext ) return StoredStrings->szRead = szNext ;
   return NULL ;
}



// obt@̌̕Ԃ (UNICODE)
size_t GetStringCountW ( STOREDSTRINGSW *StoredStrings ) {
   if ( ! StoredStrings || StoredStrings == (STOREDSTRINGSW*) -1 ) return 0 ;
   return StoredStrings->nCount ;
}



static int __cdecl StoredStringsCompareW ( const void *pArg1, const void *pArg2 ) ;
static int __cdecl StoredStringsCompareReverseW ( const void *pArg1, const void *pArg2 ) ;



// obt@̕\[g (UNICODE)
// CompareFuntion ɂ SORT_STOREDSTRINGS_NORMAL, SORT_STOREDSTRINGS_REVERSE ܂̓[U`̔r֐w
// O MarkSortStart () ǂݏoꂽAȍ~ɒǉꂽ̂݃\[g
int SortStoredStringsW ( STOREDSTRINGSW *StoredStrings, int (__cdecl *CompareFunction )(const void *, const void *) ) {


   STOREDSTRINGSW *StoredStringsTmp = NULL ;
   size_t nCount ;
   int nResult = 1 ;

   wchar_t *szStart ;
   size_t nItem ;

   if ( ! StoredStrings ) return 0 ;

   if ( ! CompareFunction ) return 1 ;
   else if ( CompareFunction == SORT_STOREDSTRINGS_NORMAL ) CompareFunction = StoredStringsCompareW ;
   else if ( CompareFunction == SORT_STOREDSTRINGS_REVERSE ) CompareFunction = StoredStringsCompareReverseW ;

   if ( StoredStrings->szSortStart ) {
      szStart = StoredStrings->szSortStart ;
      nItem = StoredStrings->nCount - StoredStrings->nSortStartCount ;
   }
   else {
      szStart = StoredStrings->szStart ;
      nItem = StoredStrings->nCount ;
   }

   if ( nItem <= 1 ) return 0 ;

   wchar_t **pPointerToName = (wchar_t**) malloc ( ( nItem ) * sizeof(wchar_t*) ) ;
   if ( ! pPointerToName ) return 1 ;

   wchar_t *szStringGet = szStart ;
   for ( nCount = 0 ; nCount < nItem ; nCount ++ ) {
      pPointerToName [ nCount ] = szStringGet ;
      szStringGet = wcsend ( szStringGet ) + 1 ;
   }

   qsort ( pPointerToName, nItem, sizeof(wchar_t*), CompareFunction ) ;

   for ( nCount = 0 ; nCount < nItem ; nCount ++ ) {
      StoredStringsTmp = StoreStringsW ( StoredStringsTmp, pPointerToName [ nCount ] ) ;
      if ( StoredStringsTmp == (STOREDSTRINGSW*) -1 ) break ;
   }
   if ( StoredStringsTmp && StoredStringsTmp != (STOREDSTRINGSW*) -1 ) {
      memmove ( szStart, GetFirstStringW ( StoredStringsTmp ), ( szStringGet - szStart ) * sizeof(wchar_t) ) ;
      FreeStoredStringsW ( StoredStringsTmp ) ;
      nResult = 0 ;
   }

   free ( pPointerToName ) ;
   return nResult ;
}



// Ń\[g
static int __cdecl StoredStringsCompareW ( const void *pArg1, const void *pArg2 ) {
   return CompareStringW ( LOCALE_SYSTEM_DEFAULT, 0, *(const wchar_t**)pArg1, -1, *(const wchar_t**)pArg2, -1 ) - 2 ;
}



// tŃ\[g
static int __cdecl StoredStringsCompareReverseW ( const void *pArg1, const void *pArg2 ) {
   return - ( CompareStringW ( LOCALE_SYSTEM_DEFAULT, 0, *(const wchar_t**)pArg1, -1, *(const wchar_t**)pArg2, -1 ) - 2 ) ;
}



// ȍ~ɒǉꂽ̂ SortStoredStrings () Ń\[g (UNICODE)
int MarkSortStartW ( STOREDSTRINGSW *StoredStrings ) {
   if ( ! StoredStrings || StoredStrings == (STOREDSTRINGSW*) -1 ) return NULL ;
   StoredStrings->szSortStart = StoredStrings->szWrite ;
   StoredStrings->nSortStartCount = StoredStrings->nCount ;
   return 0 ;
}



// MarkSortStartŎw肳ꂽ}[N (UNICODE)
int UnmarkSortStartW ( STOREDSTRINGSW *StoredStrings ) {
   if ( ! StoredStrings || StoredStrings == (STOREDSTRINGSW*) -1 ) return NULL ;
   StoredStrings->szSortStart = NULL ;
   StoredStrings->nSortStartCount = 0 ;
   return 0 ;
}



// obt@}[Nꂽŏ̕Ԃ (UNICODE)
// 񂪂Ȃ΁ANULL Ԃ
wchar_t *GetFirstMarkedStringW ( STOREDSTRINGSW *StoredStrings ) {
   if ( ! StoredStrings || StoredStrings == (STOREDSTRINGSW*) -1 ) return NULL ;
   if ( StoredStrings->szSortStart ) return StoredStrings->szRead = StoredStrings->szSortStart ;
   else                              return StoredStrings->szRead = StoredStrings->szStart ;
}



