// storestr.h

#ifndef STORESTR_H
#define STORESTR_H


#ifdef __cplusplus
extern "C" {
#endif


// STOREDSTRINGS \ (ANSI)
typedef struct {
   char           *szStart ;        // obt@̐擪AhX
   char           *szRead ;         // obt@̓ǂݏop̃AhX
   char           *szWrite ;        // obt@̏ݗp̃AhX
   size_t         dwBufferSize ;    // mۂobt@̃TCYioCgj
   size_t         nCount ;          // vf̌
   char           *szSortStart ;    // \[gn߂ʒu
   size_t         nSortStartCount ; // \[gn߂ʒu܂ł̗vf̐
} STOREDSTRINGSA ;


// STOREDSTRINGS \ (UNICODE)
typedef struct {
   wchar_t        *szStart ;        // obt@̐擪AhX
   wchar_t        *szRead ;         // obt@̓ǂݏop̃AhX
   wchar_t        *szWrite ;        // obt@̏ݗp̃AhX
   size_t         dwBufferSize ;    // mۂobt@̃TCYioCgj
   size_t         nCount ;          // vf̌
   wchar_t        *szSortStart ;    // \[gn߂ʒu
   size_t         nSortStartCount ; // \[gn߂ʒu܂ł̗vf̐
} STOREDSTRINGSW ;


STOREDSTRINGSA *StoreStringsA ( STOREDSTRINGSA *StoredStrings, const char *szString ) ;
void FreeStoredStringsA ( STOREDSTRINGSA *StoredStrings ) ;
char *GetFirstStringA ( STOREDSTRINGSA *StoredStrings ) ;
char *GetNextStringA ( STOREDSTRINGSA *StoredStrings ) ;
size_t GetStringCountA ( STOREDSTRINGSA *StoredStrings ) ;
int SortStoredStringsA ( STOREDSTRINGSA *StoredStrings, int (__cdecl *CompareFunction )(const void *, const void *) ) ;
int MarkSortStartA ( STOREDSTRINGSA *StoredStrings ) ;
int UnmarkSortStartA ( STOREDSTRINGSA *StoredStrings ) ;
char *GetFirstMarkedStringA ( STOREDSTRINGSA *StoredStrings ) ;

STOREDSTRINGSW *StoreStringsW ( STOREDSTRINGSW *StoredStrings, const wchar_t *szString ) ;
void FreeStoredStringsW ( STOREDSTRINGSW *StoredStrings ) ;
wchar_t *GetFirstStringW ( STOREDSTRINGSW *StoredStrings ) ;
wchar_t *GetNextStringW ( STOREDSTRINGSW *StoredStrings ) ;
size_t GetStringCountW ( STOREDSTRINGSW *StoredStrings ) ;
int SortStoredStringsW ( STOREDSTRINGSW *StoredStrings, int (__cdecl *CompareFunction )(const void *, const void *) ) ;
int MarkSortStartW ( STOREDSTRINGSW *StoredStrings ) ;
int UnmarkSortStartW ( STOREDSTRINGSW *StoredStrings ) ;
wchar_t *GetFirstMarkedStringW ( STOREDSTRINGSW *StoredStrings ) ;


#ifdef UNICODE
#define STOREDSTRINGS      STOREDSTRINGSW
#define StoreStrings       StoreStringsW
#define FreeStoredStrings  FreeStoredStringsW
#define GetFirstString     GetFirstStringW
#define GetNextString      GetNextStringW
#define GetStringCount     GetStringCountW
#define SortStoredStrings  SortStoredStringsW
#define MarkSortStart      MarkSortStartW
#define UnmarkSortStart    UnmarkSortStartW
#define GetFirstMarkedString  GetFirstMarkedStringW
#else
#define STOREDSTRINGS      STOREDSTRINGSA
#define StoreStrings       StoreStringsA
#define FreeStoredStrings  FreeStoredStringsA
#define GetFirstString     GetFirstStringA
#define GetNextString      GetNextStringA
#define GetStringCount     GetStringCountA
#define SortStoredStrings  SortStoredStringsA
#define MarkSortStart      MarkSortStartA
#define UnmarkSortStart    UnmarkSortStartA
#define GetFirstMarkedString  GetFirstMarkedStringA
#endif


#define SORT_STOREDSTRINGS_NORMAL   ((int (__cdecl *)(const void *, const void *)) 1 )
#define SORT_STOREDSTRINGS_REVERSE  ((int (__cdecl *)(const void *, const void *)) 2 )


#ifdef __cplusplus
}
#endif

#endif


