// stringex.cpp

#include <string.h>
#include <ctype.h>
#include <mbctype.h>
#include <limits.h>
#include "msc.h"

#undef DEBUG_CONST_STRING
#include "stringex.h"



////////////////////////////////////////////
//               strlcpy ()               //
////////////////////////////////////////////



// w肳ꂽ܂ŕRs[iANSIŁj
// bufsiz  dst Ɏ߂邱Ƃ̂łő̕iI[k܂ށj
// src ̕ԂiI[k܂܂Ȃj
size_t strlcpy ( char *dst, const char *src, size_t bufsiz ) {

   size_t srclen = strlen ( src ) ;

   if ( bufsiz ) {
      size_t cpylen = ( srclen < bufsiz ) ? srclen : bufsiz - 1 ;
      memmove ( dst, src, cpylen * sizeof(char) ) ;
      dst [ cpylen ] = 0 ;
   }

   return srclen ;
}



// w肳ꂽ܂ŕRs[iUNICODEŁj
// bufsiz  dst Ɏ߂邱Ƃ̂łő̕iI[k܂ށj
// src ̕ԂiI[k܂܂Ȃj
size_t wcslcpy ( wchar_t *dst, const wchar_t *src, size_t bufsiz ) {

   size_t srclen = wcslen ( src ) ;

   if ( bufsiz ) {
      size_t cpylen = ( srclen < bufsiz ) ? srclen : bufsiz - 1 ;
      memmove ( dst, src, cpylen * sizeof(wchar_t) ) ;
      dst [ cpylen ] = 0 ;
   }

   return srclen ;
}



// w肳ꂽ܂ŕRs[iMULTIBYTEŁj
// bufsiz  dst Ɏ߂邱Ƃ̂łő̕iI[k܂ށj
// src ̕ԂiI[k܂܂Ȃj
size_t mbslcpy ( char *dst, const char *src, size_t bufsiz ) {

   size_t srclen = strlen ( src ) ;

   if ( bufsiz ) {
      size_t cpylen = ( srclen < bufsiz ) ? srclen : bufsiz - 1 ;
      memmove ( dst, src, cpylen * sizeof(char) ) ;
      mbstrunc ( dst, cpylen ) ;
   }

   return srclen ;
}



////////////////////////////////////////////
//               strlcat ()               //
////////////////////////////////////////////



// w肳ꂽ܂ŕAiANSIŁj
// bufsiz  dst Ɏ߂邱Ƃ̂łő̕iI[k܂ށj
// src  dst ̍̕vԂiI[k܂܂Ȃj
size_t strlcat ( char *dst, const char *src, size_t bufsiz ) {

   size_t srclen = strlen ( src ) ;
   size_t dstlen = strlen ( dst ) ;

   if ( bufsiz > dstlen ) {
      size_t cpylen = ( srclen < bufsiz - dstlen ) ? srclen : bufsiz - dstlen - 1 ;
      memmove ( dst + dstlen, src, cpylen * sizeof(char) ) ;
      ( dst + dstlen ) [ cpylen ] = 0 ;
   }

   return srclen + dstlen ;
}



// w肳ꂽ܂ŕAiUNICODEŁj
// bufsiz  dst Ɏ߂邱Ƃ̂łő̕iI[k܂ށj
// src  dst ̍̕vԂiI[k܂܂Ȃj
size_t wcslcat ( wchar_t *dst, const wchar_t *src, size_t bufsiz ) {

   size_t srclen = wcslen ( src ) ;
   size_t dstlen = wcslen ( dst ) ;

   if ( bufsiz > dstlen ) {
      size_t cpylen = ( srclen < bufsiz - dstlen ) ? srclen : bufsiz - dstlen - 1 ;
      memmove ( dst + dstlen, src, cpylen * sizeof(wchar_t) ) ;
      ( dst + dstlen ) [ cpylen ] = 0 ;
   }

   return srclen + dstlen ;
}



// w肳ꂽ܂ŕAiMULTIBYTEŁj
// bufsiz  dst Ɏ߂邱Ƃ̂łő̕iI[k܂ށj
// src  dst ̍̕vԂiI[k܂܂Ȃj
size_t mbslcat ( char *dst, const char *src, size_t bufsiz ) {

   size_t srclen = strlen ( src ) ;
   size_t dstlen = strlen ( dst ) ;

   if ( bufsiz > dstlen ) {
      size_t cpylen = ( srclen < bufsiz - dstlen ) ? srclen : bufsiz - dstlen - 1 ;
      memmove ( dst + dstlen, src, cpylen * sizeof(char) ) ;
      mbstrunc ( dst, dstlen + cpylen ) ;
   }

   return srclen + dstlen ;
}



////////////////////////////////////////////
//               strmove ()               //
////////////////////////////////////////////



// Rs[iANSIŁj
// src  dst ̗̈悪dȂĂĂ
char *strmove ( char *dst, const char *src ) {

   return (char*) memmove ( dst, src, ( strlen ( src ) + 1 ) * sizeof(char) ) ;
}



// Rs[iUNICODEŁj
// src  dst ̗̈悪dȂĂĂ
wchar_t *wcsmove ( wchar_t *dst, const wchar_t *src ) {

   return (wchar_t*) memmove ( dst, src, ( wcslen ( src ) + 1 ) * sizeof(wchar_t) ) ;
}



////////////////////////////////////////////
//              strinsert ()              //
////////////////////////////////////////////



// }iANSIŁj
// }̖̃AhXԂ
char *strinsert ( char *dst, const char *src ) {

   size_t srclen = strlen ( src ) ;

   memmove ( dst + srclen, dst, ( strlen ( dst ) + 1 ) * sizeof(char) ) ;
   memmove ( dst, src, srclen * sizeof(char) ) ;

   return dst + srclen ;
}



// }iUNICODEŁj
// }̖̃AhXԂ
wchar_t *wcsinsert ( wchar_t *dst, const wchar_t *src ) {

   size_t srclen = wcslen ( src ) ;

   memmove ( dst + srclen, dst, ( wcslen ( dst ) + 1 ) * sizeof(wchar_t) ) ;
   memmove ( dst, src, srclen * sizeof(wchar_t) ) ;

   return dst + srclen ;
}



////////////////////////////////////////////
//               strlset ()               //
////////////////////////////////////////////



// obt@𕶎Ŗ߂iANSIŁj
// bufsiz  dst Ɏ߂邱Ƃ̂łő̕iI[k܂ށj
// ̍Ōɂ̓kt
char *strlset ( char *dst, int c, size_t bufsiz ) {

   char *start = dst ;
   char *end = dst + bufsiz - 1 ;

   if ( bufsiz ) {
      while ( dst < end ) *dst ++ = c ;
      *dst = 0 ;
   }

   return start ;
}



// obt@𕶎Ŗ߂iUNICODEŁj
// bufsiz  dst Ɏ߂邱Ƃ̂łő̕iI[k܂ށj
// ̍Ōɂ̓kt
wchar_t *wcslset ( wchar_t *dst, int c, size_t bufsiz ) {

   wchar_t *start = dst ;
   wchar_t *end = dst + bufsiz - 1 ;

   if ( bufsiz ) {
      while ( dst < end ) *dst ++ = c ;
      *dst = 0 ;
   }

   return start ;
}



// obt@𕶎Ŗ߂iMULTIBYTEŁj
// bufsiz  dst Ɏ߂邱Ƃ̂łő̕iI[k܂ށj
// ̍Ōɂ̓kt
char *mbslset ( char *dst, int c, size_t bufsiz ) {

   char *start = dst ;
   char *end = dst + bufsiz - 1 ;

   if ( bufsiz ) {
      if ( c < 0x100 ) {
         while ( dst < end ) *dst ++ = c ;
         *dst = 0 ;
      }
      else {
         while ( dst < end - 1 ) {
            *dst ++ = ( c >> 8 ) & 0xFF ;
            *dst ++ = c & 0xFF ;
         }
         *dst = 0 ;
      }
   }

   return start ;
}



////////////////////////////////////////////
//               stricmp ()               //
////////////////////////////////////////////



//  ignore case ŔriANSIŁj
int stricmp ( const char *string1, const char *string2 ) {
   return strnicmp ( string1, string2, SIZE_MAX ) ;
}



//  ignore case ŔriUNICODEŁj
int wcsicmp ( const wchar_t *string1, const wchar_t *string2 ) {
   return wcsnicmp ( string1, string2, SIZE_MAX ) ;
}



//  ignore case ŔriMULTIBYTEŁj
int mbsicmp ( const char *string1, const char *string2 ) {
   return mbsnicmp ( string1, string2, SIZE_MAX ) ;
}



////////////////////////////////////////////
//               strnicmp ()              //
////////////////////////////////////////////



//  count  ignore case ŔriANSIŁj
int strnicmp ( const char *string1, const char *string2, size_t count ) {

   int c1, c2 ;

   while ( 1 ) {
      if ( ! count ) return 0 ;
      c1 = tolower ( (unsigned char) *string1 ) ;
      c2 = tolower ( (unsigned char) *string2 ) ;
      if ( ! c1 || c1 != c2 ) break ;
      string1 ++ ;
      string2 ++ ;
      count -- ;
   }

   return c1 - c2 ;
}



//  count  ignore case ŔriUNICODEŁj
int wcsnicmp ( const wchar_t *string1, const wchar_t *string2, size_t count ) {

   int c1, c2 ;

   while ( 1 ) {
      if ( ! count ) return 0 ;
      c1 = tolower ( *string1 ) ;
      c2 = tolower ( *string2 ) ;
      if ( ! c1 || c1 != c2 ) break ;
      string1 ++ ;
      string2 ++ ;
      count -- ;
   }

   return c1 - c2 ;
}



//  count  ignore case ŔriMULTIBYTEŁj
int mbsnicmp ( const char *string1, const char *string2, size_t count ) {

   int c1, c2 ;
   int isprevlead1 = 0, isprevlead2 = 0 ;

   while ( 1 ) {
      if ( ! count ) return 0 ;
      c1 = (unsigned char) *string1 ;
      if ( isprevlead1 ) isprevlead1 = 0 ;
      else {
         if ( ismbblead ( c1 ) ) isprevlead1 = 1 ;
         else                    c1 = tolower ( c1 ) ;
      }
      c2 = (unsigned char) *string2 ;
      if ( isprevlead2 ) isprevlead2 = 0 ;
      else {
         if ( ismbblead ( c2 ) ) isprevlead2 = 1 ;
         else                    c2 = tolower ( c2 ) ;
      }
      if ( ! c1 || c1 != c2 ) break ;
      string1 ++ ;
      string2 ++ ;
      count -- ;
   }

   return c1 - c2 ;
}



////////////////////////////////////////////
//               strrcmp ()               //
////////////////////////////////////////////



// 𖖔riANSIŁj
int strrcmp ( const char *string1, const char *string2 ) {
   return strrncmp ( string1, string2, SIZE_MAX ) ;
}



// 𖖔riUNICODEŁj
int wcsrcmp ( const wchar_t *string1, const wchar_t *string2 ) {
   return wcsrncmp ( string1, string2, SIZE_MAX ) ;
}



// 𖖔riMULTIBYTEŁj
int mbsrcmp ( const char *string1, const char *string2 ) {
   return mbsrncmp ( string1, string2, SIZE_MAX ) ;
}



////////////////////////////////////////////
//               strricmp ()              //
////////////////////////////////////////////



// 𖖔 ignore case ŔriANSIŁj
int strricmp ( const char *string1, const char *string2 ) {
   return strrnicmp ( string1, string2, SIZE_MAX ) ;
}



// 𖖔 ignore case ŔriUNICODEŁj
int wcsricmp ( const wchar_t *string1, const wchar_t *string2 ) {
   return wcsrnicmp ( string1, string2, SIZE_MAX ) ;
}



// 𖖔 ignore case ŔriMULTIBYTEŁj
int mbsricmp ( const char *string1, const char *string2 ) {
   return mbsrnicmp ( string1, string2, SIZE_MAX ) ;
}



////////////////////////////////////////////
//               strrncmp ()              //
////////////////////////////////////////////



// 𖖔riANSIŁj
int strrncmp ( const char *string1, const char *string2, size_t count ) {

   int c1, c2 ;

   const char *current1 = strend ( string1 ) - 1 ;
   const char *current2 = strend ( string2 ) - 1 ;

   while ( 1 ) {
      if ( ! count ) return 0 ;
      if ( current1 >= string1 ) c1 = (unsigned char) *current1 ;
      else                       c1 = 0 ;
      if ( current2 >= string2 ) c2 = (unsigned char) *current2 ;
      else                       c2 = 0 ;
      if ( ! c1 || c1 != c2 ) break ;
      current1 -- ;
      current2 -- ;
      count -- ;
   }

   return c1 - c2 ;
}



// 𖖔riUNICODEŁj
int wcsrncmp ( const wchar_t *string1, const wchar_t *string2, size_t count ) {

   int c1, c2 ;

   const wchar_t *current1 = wcsend ( string1 ) - 1 ;
   const wchar_t *current2 = wcsend ( string2 ) - 1 ;

   while ( 1 ) {
      if ( ! count ) return 0 ;
      if ( current1 >= string1 ) c1 = *current1 ;
      else                       c1 = 0 ;
      if ( current2 >= string2 ) c2 = *current2 ;
      else                       c2 = 0 ;
      if ( ! c1 || c1 != c2 ) break ;
      current1 -- ;
      current2 -- ;
      count -- ;
   }

   return c1 - c2 ;
}



// 𖖔riMULTIBYTEŁj
int mbsrncmp ( const char *string1, const char *string2, size_t count ) {

   int c1, c2 ;

   const char *current1 = strend ( string1 ) - 1 ;
   const char *current2 = strend ( string2 ) - 1 ;

   while ( 1 ) {
      if ( ! count ) return 0 ;
      if ( current1 >= string1 ) {
         c1 = (unsigned char) *current1 ;
         if ( ismbstrail ( string1, current1 ) ) c1 += 0x100 ;
      }
      else {
         c1 = 0 ;
      }
      if ( current2 >= string2 ) {
         c2 = (unsigned char) *current2 ;
         if ( ismbstrail ( string2, current2 ) ) c2 += 0x100 ;
      }
      else {
         c2 = 0 ;
      }
      if ( ! c1 || c1 != c2 ) break ;
      current1 -- ;
      current2 -- ;
      count -- ;
   }

   return c1 - c2 ;
}



////////////////////////////////////////////
//               strrnicmp ()             //
////////////////////////////////////////////



// 𖖔 ignore case ŔriANSIŁj
int strrnicmp ( const char *string1, const char *string2, size_t count ) {

   int c1, c2 ;

   const char *current1 = strend ( string1 ) - 1 ;
   const char *current2 = strend ( string2 ) - 1 ;

   while ( 1 ) {
      if ( ! count ) return 0 ;
      if ( current1 >= string1 ) c1 = tolower ( (unsigned char) *current1 ) ;
      else                       c1 = 0 ;
      if ( current2 >= string2 ) c2 = tolower ( (unsigned char) *current2 ) ;
      else                       c2 = 0 ;
      if ( ! c1 || c1 != c2 ) break ;
      current1 -- ;
      current2 -- ;
      count -- ;
   }

   return c1 - c2 ;
}



// 𖖔 ignore case ŔriUNICODEŁj
int wcsrnicmp ( const wchar_t *string1, const wchar_t *string2, size_t count ) {

   int c1, c2 ;

   const wchar_t *current1 = wcsend ( string1 ) - 1 ;
   const wchar_t *current2 = wcsend ( string2 ) - 1 ;

   while ( 1 ) {
      if ( ! count ) return 0 ;
      if ( current1 >= string1 ) c1 = tolower ( *current1 ) ;
      else                       c1 = 0 ;
      if ( current2 >= string2 ) c2 = tolower ( *current2 ) ;
      else                       c2 = 0 ;
      if ( ! c1 || c1 != c2 ) break ;
      current1 -- ;
      current2 -- ;
      count -- ;
   }

   return c1 - c2 ;
}



// 𖖔 ignore case ŔriMULTIBYTEŁj
int mbsrnicmp ( const char *string1, const char *string2, size_t count ) {

   int c1, c2 ;

   const char *current1 = strend ( string1 ) - 1 ;
   const char *current2 = strend ( string2 ) - 1 ;

   while ( 1 ) {
      if ( ! count ) return 0 ;
      if ( current1 >= string1 ) {
         c1 = (unsigned char) *current1 ;
         if ( ismbstrail ( string1, current1 ) ) c1 += 0x100 ;
         c1 = tolower ( c1 ) ;
      }
      else {
         c1 = 0 ;
      }
      if ( current2 >= string2 ) {
         c2 = (unsigned char) *current2 ;
         if ( ismbstrail ( string2, current2 ) ) c2 += 0x100 ;
         c2 = tolower ( c2 ) ;
      }
      else {
         c2 = 0 ;
      }
      if ( ! c1 || c1 != c2 ) break ;
      current1 -- ;
      current2 -- ;
      count -- ;
   }

   return c1 - c2 ;
}



////////////////////////////////////////////
//              strheadcmp ()             //
////////////////////////////////////////////



// ̐擪riANSIŁj
int strheadcmp ( const char *string, const char *head ) {
   return strncmp ( string, head, strlen ( head ) ) ;
}



// ̐擪riUNICODEŁj
int wcsheadcmp ( const wchar_t *string, const wchar_t *head ) {
   return wcsncmp ( string, head, wcslen ( head ) ) ;
}



////////////////////////////////////////////
//              strheadicmp ()            //
////////////////////////////////////////////



// ̐擪 ignore case ŔriANSIŁj
int strheadicmp ( const char *string, const char *head ) {
   return strnicmp ( string, head, strlen ( head ) ) ;
}



// ̐擪 ignore case ŔriUNICODEŁj
int wcsheadicmp ( const wchar_t *string, const wchar_t *head ) {
   return wcsnicmp ( string, head, wcslen ( head ) ) ;
}



// ̐擪 ignore case ŔriMULTIBYTEŁj
int mbsheadicmp ( const char *string, const char *head ) {
   return mbsnicmp ( string, head, strlen ( head ) ) ;
}



////////////////////////////////////////////
//              strtailcmp ()             //
////////////////////////////////////////////



// ̖riANSIŁj
int strtailcmp ( const char *string, const char *tail ) {
   return strrncmp ( string, tail, strlen ( tail ) ) ;
}



// ̖riUNICODEŁj
int wcstailcmp ( const wchar_t *string, const wchar_t *tail ) {
   return wcsrncmp ( string, tail, wcslen ( tail ) ) ;
}



// ̖riMULTIBYTEŁj
int mbstailcmp ( const char *string, const char *tail ) {
   return mbsrncmp ( string, tail, strlen ( tail ) ) ;
}



////////////////////////////////////////////
//              strtailicmp ()            //
////////////////////////////////////////////



// ̖ ignore case ŔriANSIŁj
int strtailicmp ( const char *string, const char *tail ) {
   return strrnicmp ( string, tail, strlen ( tail ) ) ;
}



// ̖ ignore case ŔriUNICODEŁj
int wcstailicmp ( const wchar_t *string, const wchar_t *tail ) {
   return wcsrnicmp ( string, tail, wcslen ( tail ) ) ;
}



// ̖ ignore case ŔriMULTIBYTEŁj
int mbstailicmp ( const char *string, const char *tail ) {
   return mbsrnicmp ( string, tail, strlen ( tail ) ) ;
}



////////////////////////////////////////////
//               strstr ()                //
////////////////////////////////////////////



// 񂩂當iMULTIBYTEŁj
char *mbsstr ( const char *string1, const char *string2 ) {

   size_t length1 = strlen ( string1 ) ;
   size_t length2 = strlen ( string2 ) ;

   if ( ! length2 ) return (char*) string1 ;

   const char *tail = string1 + length1 - length2 ;
   int c2 = (unsigned char) *string2 ;

   while ( string1 <= tail ) {
      int c1 = (unsigned char) *string1 ;
      if ( c1 == c2 && ! strncmp ( string1, string2, length2 ) ) return (char*) string1 ;
      if ( ismbblead ( (unsigned char) *string1 ) && *( string1 + 1 ) ) string1 ++ ;
      string1 ++ ;
   }

   return NULL ;
}



////////////////////////////////////////////
//               strstri ()               //
////////////////////////////////////////////



// 񂩂 ignore case ŕiANSIŁj
char *strstri ( const char *string1, const char *string2 ) {

   size_t length1 = strlen ( string1 ) ;
   size_t length2 = strlen ( string2 ) ;

   if ( ! length2 ) return (char*) string1 ;

   const char *tail = string1 + length1 - length2 ;
   int c2 = tolower ( (unsigned char) *string2 ) ;

   while ( string1 <= tail ) {
      int c1 = tolower ( (unsigned char) *string1 ) ;
      if ( c1 == c2 && ! strnicmp ( string1, string2, length2 ) ) return (char*) string1 ;
      string1 ++ ;
   }

   return NULL ;
}



// 񂩂 ignore case ŕiUNICODEŁj
wchar_t *wcsstri ( const wchar_t *string1, const wchar_t *string2 ) {

   size_t length1 = wcslen ( string1 ) ;
   size_t length2 = wcslen ( string2 ) ;

   if ( ! length2 ) return (wchar_t*) string1 ;

   const wchar_t *tail = string1 + length1 - length2 ;
   int c2 = tolower ( *string2 ) ;

   while ( string1 <= tail ) {
      int c1 = tolower ( *string1 ) ;
      if ( c1 == c2 && ! wcsnicmp ( string1, string2, length2 ) ) return (wchar_t*) string1 ;
      string1 ++ ;
   }

   return NULL ;
}



// 񂩂 ignore case ŕiMULTIBYTEŁj
char *mbsstri ( const char *string1, const char *string2 ) {

   size_t length1 = strlen ( string1 ) ;
   size_t length2 = strlen ( string2 ) ;

   if ( ! length2 ) return (char*) string1 ;

   const char *tail = string1 + length1 - length2 ;
   int c2 = tolower ( (unsigned char) *string2 ) ;

   while ( string1 <= tail ) {
      int c1 = tolower ( (unsigned char) *string1 ) ;
      if ( c1 == c2 && ! mbsnicmp ( string1, string2, length2 ) ) return (char*) string1 ;
      if ( ismbblead ( (unsigned char) *string1 ) && *( string1 + 1 ) ) string1 ++ ;
      string1 ++ ;
   }

   return NULL ;
}



////////////////////////////////////////////
//               strrstr ()               //
////////////////////////////////////////////



// ̖當iANSIŁj
char *strrstr ( const char *string1, const char *string2 ) {

   const char *result = NULL ;

   size_t length1 = strlen ( string1 ) ;
   size_t length2 = strlen ( string2 ) ;

   if ( ! length2 ) return (char*) string1 ;

   const char *tail = string1 + length1 - length2 ;
   int c2 = (unsigned char) *string2 ;

   while ( string1 <= tail ) {
      int c1 = (unsigned char) *string1 ;
      if ( c1 == c2 && ! strncmp ( string1, string2, length2 ) ) result = string1 ;
      string1 ++ ;
   }

   return (char*) result ;
}



// ̖當iUNICODEŁj
wchar_t *wcsrstr ( const wchar_t *string1, const wchar_t *string2 ) {

   const wchar_t *result = NULL ;

   size_t length1 = wcslen ( string1 ) ;
   size_t length2 = wcslen ( string2 ) ;

   if ( ! length2 ) return (wchar_t*) string1 ;

   const wchar_t *tail = string1 + length1 - length2 ;
   int c2 = *string2 ;

   while ( string1 <= tail ) {
      int c1 = *string1 ;
      if ( c1 == c2 && ! wcsncmp ( string1, string2, length2 ) ) result = string1 ;
      string1 ++ ;
   }

   return (wchar_t*) result ;
}



// ̖當iMULTIBYTEŁj
char *mbsrstr ( const char *string1, const char *string2 ) {

   const char *result = NULL ;

   size_t length1 = strlen ( string1 ) ;
   size_t length2 = strlen ( string2 ) ;

   if ( ! length2 ) return (char*) string1 ;

   const char *tail = string1 + length1 - length2 ;
   int c2 = (unsigned char) *string2 ;

   while ( string1 <= tail ) {
      int c1 = (unsigned char) *string1 ;
      if ( c1 == c2 && ! strncmp ( string1, string2, length2 ) ) result = string1 ;
      if ( ismbblead ( (unsigned char) *string1 ) && *( string1 + 1 ) ) string1 ++ ;
      string1 ++ ;
   }

   return (char*) result ;
}



////////////////////////////////////////////
//               strrstri ()              //
////////////////////////////////////////////



// ̖ ignore case ŕiANSIŁj
char *strrstri ( const char *string1, const char *string2 ) {

   const char *result = NULL ;

   size_t length1 = strlen ( string1 ) ;
   size_t length2 = strlen ( string2 ) ;

   if ( ! length2 ) return (char*) string1 ;

   const char *tail = string1 + length1 - length2 ;
   int c2 = tolower ( (unsigned char) *string2 ) ;

   while ( string1 <= tail ) {
      int c1 = tolower ( (unsigned char) *string1 ) ;
      if ( c1 == c2 && ! strnicmp ( string1, string2, length2 ) ) result = string1 ;
      string1 ++ ;
   }

   return (char*) result ;
}



// ̖ ignore case ŕiUNICODEŁj
wchar_t *wcsrstri ( const wchar_t *string1, const wchar_t *string2 ) {

   const wchar_t *result = NULL ;

   size_t length1 = wcslen ( string1 ) ;
   size_t length2 = wcslen ( string2 ) ;

   if ( ! length2 ) return (wchar_t*) string1 ;

   const wchar_t *tail = string1 + length1 - length2 ;
   int c2 = tolower ( *string2 ) ;

   while ( string1 <= tail ) {
      int c1 = tolower ( *string1 ) ;
      if ( c1 == c2 && ! wcsnicmp ( string1, string2, length2 ) ) result = string1 ;
      string1 ++ ;
   }

   return (wchar_t*) result ;
}



// ̖ ignore case ŕiMULTIBYTEŁj
char *mbsrstri ( const char *string1, const char *string2 ) {

   const char *result = NULL ;

   size_t length1 = strlen ( string1 ) ;
   size_t length2 = strlen ( string2 ) ;

   if ( ! length2 ) return (char*) string1 ;

   const char *tail = string1 + length1 - length2 ;
   int c2 = tolower ( (unsigned char) *string2 ) ;

   while ( string1 <= tail ) {
      int c1 = tolower ( (unsigned char) *string1 ) ;
      if ( c1 == c2 && ! mbsnicmp ( string1, string2, length2 ) ) result = string1 ;
      if ( ismbblead ( (unsigned char) *string1 ) && *( string1 + 1 ) ) string1 ++ ;
      string1 ++ ;
   }

   return (char*) result ;
}



////////////////////////////////////////////
//               strchr ()                //
////////////////////////////////////////////



// 񂩂當iMULTIBYTEŁj
char *mbschr ( const char *string, int c ) {

   while ( *string ) {
      if ( ismbblead ( (unsigned char) *string ) ) {
         if ( ! *( string + 1 ) ) break ;
         if ( c == ( ( (unsigned char) *string << 8 ) | (unsigned char) *( string + 1 ) ) ) return (char*) string ;
         string ++ ;
         string ++ ;
      }
      else {
         if ( c == (unsigned char) *string ) return (char*) string ;
         string ++ ;
      }
   }

   return NULL ;
}



////////////////////////////////////////////
//               strchri ()               //
////////////////////////////////////////////



// 񂩂 ignore case iANSIŁj
char *strchri ( const char *string, int c ) {

   c = tolower ( c ) ;

   while ( *string ) {
      if ( c == tolower ( (unsigned char) *string ) ) return (char*) string ;
      string ++ ;
   }

   return NULL ;
}



// 񂩂 ignore case iUNICODEŁj
wchar_t *wcschri ( const wchar_t *string, int c ) {

   c = tolower ( c ) ;

   while ( *string ) {
      if ( c == tolower ( *string ) ) return (wchar_t*) string ;
      string ++ ;
   }

   return NULL ;
}



// 񂩂 ignore case iMULTIBYTEŁj
char *mbschri ( const char *string, int c ) {

   c = tolower ( c ) ;

   while ( *string ) {
      if ( ismbblead ( (unsigned char) *string ) ) {
         if ( ! *( string + 1 ) ) break ;
         if ( c == ( ( (unsigned char) *string << 8 ) | (unsigned char) *( string + 1 ) ) ) return (char*) string ;
         string ++ ;
         string ++ ;
      }
      else {
         if ( c == tolower ( (unsigned char) *string ) ) return (char*) string ;
         string ++ ;
      }
   }

   return NULL ;
}



////////////////////////////////////////////
//               strrchr ()               //
////////////////////////////////////////////



// ̖當iMULTIBYTEŁj
char *mbsrchr ( const char *string, int c ) {

   const char *result = NULL ;

   while ( *string ) {
      if ( ismbblead ( (unsigned char) *string ) ) {
         if ( ! *( string + 1 ) ) break ;
         if ( c == ( ( (unsigned char) *string << 8 ) | (unsigned char) *( string + 1 ) ) ) result = string ;
         string ++ ;
         string ++ ;
      }
      else {
         if ( c == (unsigned char) *string ) result = string ;
         string ++ ;
      }
   }

   return (char*) result ;
}



////////////////////////////////////////////
//               strrchri ()              //
////////////////////////////////////////////



// ̖ ignore case ŕiANSIŁj
char *strrchri ( const char *string, int c ) {

   const char *result = NULL ;

   c = tolower ( c ) ;

   while ( *string ) {
      if ( c == tolower ( (unsigned char) *string ) ) result = string ;
      string ++ ;
   }

   return (char*) result ;
}



// ̖ ignore case ŕiUNICODEŁj
wchar_t *wcsrchri ( const wchar_t *string, int c ) {

   const wchar_t *result = NULL ;

   c = tolower ( c ) ;

   while ( *string ) {
      if ( c == tolower ( *string ) ) result = string ;
      string ++ ;
   }

   return (wchar_t*) result ;
}



// ̖ ignore case ŕiMULTIBYTEŁj
char *mbsrchri ( const char *string, int c ) {

   const char *result = NULL ;

   c = tolower ( c ) ;

   while ( *string ) {
      if ( ismbblead ( (unsigned char) *string ) ) {
         if ( ! *( string + 1 ) ) break ;
         if ( c == ( ( (unsigned char) *string << 8 ) | (unsigned char) *( string + 1 ) ) ) result = string ;
         string ++ ;
         string ++ ;
      }
      else {
         if ( c == tolower ( (unsigned char) *string ) ) result = string ;
         string ++ ;
      }
   }

   return (char*) result ;
}



////////////////////////////////////////////
//          strspn (), strcspn ()         //
////////////////////////////////////////////



// string2 ɑȂ string1 ōŏɏoʒuԂiMULTIBYTEŁj
// ȂΖԂ
size_t mbsspn ( const char *string1, const char *string2 ) {

   int c ;
   const char *current ;

   for ( current = string1 ; *current ; current ++ ) {
      int islead = ismbblead ( (unsigned char) *current ) ;
      if ( islead ) c = ( (unsigned char) *current << 8 ) | (unsigned char) *( current + 1 ) ;
      else          c = *current ;
      if ( ! mbschr ( string2, c ) ) break ;
      if ( islead && *( current + 1 ) ) current ++ ;
   }

   return current - string1 ;
}



// string2 ɑ string1 ōŏɏoʒuԂiMULTIBYTEŁj
// ȂΖԂ
size_t mbscspn ( const char *string1, const char *string2 ) {

   int c ;
   const char *current ;

   for ( current = string1 ; *current ; current ++ ) {
      int islead = ismbblead ( (unsigned char) *current ) ;
      if ( islead ) c = ( (unsigned char) *current << 8 ) | (unsigned char) *( current + 1 ) ;
      else          c = *current ;
      if ( mbschr ( string2, c ) ) break ;
      if ( islead && *( current + 1 ) ) current ++ ;
   }

   return current - string1 ;
}



////////////////////////////////////////////
//         strspnp (), strpbrk ()         //
////////////////////////////////////////////



// string2 ɑȂ string1 ōŏɏoʒuԂiANSIŁj
// Ȃ NULL Ԃ
char *strspnp ( const char *string1, const char *string2 ) {
   const char *result = string1 + strspn ( string1, string2 ) ;
   return *result ? (char*) result : NULL ;
}



// string2 ɑȂ string1 ōŏɏoʒuԂiUNICODEŁj
// Ȃ NULL Ԃ
wchar_t *wcsspnp ( const wchar_t *string1, const wchar_t *string2 ) {
   const wchar_t *result = string1 + wcsspn ( string1, string2 ) ;
   return *result ? (wchar_t*) result : NULL ;
}



// string2 ɑȂ string1 ōŏɏoʒuԂiMULTIBYTEŁj
// Ȃ NULL Ԃ
char *mbsspnp ( const char *string1, const char *string2 ) {
   const char *result = string1 + mbsspn ( string1, string2 ) ;
   return *result ? (char*) result : NULL ;
}



// string2 ɑ string1 ōŏɏoʒuԂiMULTIBYTEŁj
// Ȃ NULL Ԃ
char *mbspbrk ( const char *string1, const char *string2 ) {
   const char *result = string1 + mbscspn ( string1, string2 ) ;
   return *result ? (char*) result : NULL ;
}



////////////////////////////////////////////
//               strlwr ()                //
////////////////////////////////////////////



// ɁiANSIŁj
char *strlwr ( char *string ) {

   for ( char *current = string ; *current ; current ++ ) {
      if ( *current >= 'A' && *current <= 'Z' ) *current -= 'A' - 'a' ;
   }

   return string ;
}



// ɁiUNICODEŁj
wchar_t *wcslwr ( wchar_t *string ) {

   for ( wchar_t *current = string ; *current ; current ++ ) {
      if ( *current >= 'A' && *current <= 'Z' ) *current -= 'A' - 'a' ;
   }

   return string ;
}



// ɁiMULTIBYTEŁj
char *mbslwr ( char *string ) {

   for ( char *current = string ; *current ; current ++ ) {
      if ( *current >= 'A' && *current <= 'Z' ) *current -= 'A' - 'a' ;
      if ( ismbblead ( (unsigned char) *current ) && *( current + 1 ) ) current ++ ;
   }

   return string ;
}



////////////////////////////////////////////
//               strupr ()                //
////////////////////////////////////////////



// 啶ɁiANSIŁj
char *strupr ( char *string ) {

   for ( char *current = string ; *current ; current ++ ) {
      if ( *current >= 'a' && *current <= 'z' ) *current += 'A' - 'a' ;
   }

   return string ;
}



// 啶ɁiUNICODEŁj
wchar_t *wcsupr ( wchar_t *string ) {

   for ( wchar_t *current = string ; *current ; current ++ ) {
      if ( *current >= 'a' && *current <= 'z' ) *current += 'A' - 'a' ;
   }

   return string ;
}



// 啶ɁiMULTIBYTEŁj
char *mbsupr ( char *string ) {

   for ( char *current = string ; *current ; current ++ ) {
      if ( *current >= 'a' && *current <= 'z' ) *current += 'A' - 'a' ;
      if ( ismbblead ( (unsigned char) *current ) && *( current + 1 ) ) current ++ ;
   }

   return string ;
}



////////////////////////////////////////////
//               strrev ()                //
////////////////////////////////////////////



// t]iMULTIBYTEŁj
char *mbsrev ( char *string ) {

   for ( char *current = string ; *current ; current ++ ) {
      if ( ismbblead ( (unsigned char) *current ) ) {
         if ( *( current + 1 ) ) {
            char c = *( current + 1 ) ;
            *( current + 1 ) = *current ;
            *current = c ;
            current ++ ;
            continue ;
         }
         else {
            *current = 0 ;
            break ;
         }
      }
   }

   return strrev ( string ) ;
}



////////////////////////////////////////////
//               strtrunc ()              //
////////////////////////////////////////////



// ZkiANSIŁj
// len ͍ő厚iI[k܂܂Ȃj
char *strtrunc ( char *string, size_t len ) {

   char *end = string + len ;

   for ( char *current = string ; *current ; current ++ ) {
      if ( current >= end ) {
         *current = 0 ;
         break ;
      }
   }

   return string ;
}



// ZkiUNICODEŁj
// len ͍ő厚iI[k܂܂Ȃj
wchar_t *wcstrunc ( wchar_t *string, size_t len ) {

   wchar_t *end = string + len ;

   for ( wchar_t *current = string ; *current ; current ++ ) {
      if ( current >= end ) {
         *current = 0 ;
         break ;
      }
   }

   return string ;
}



// ZkiMULTIBYTEŁj
// len ͍ő厚iI[k܂܂Ȃj
char *mbstrunc ( char *string, size_t len ) {

   char *end = string + len ;

   for ( char *current = string ; *current ; current ++ ) {
      if ( ismbblead ( (unsigned char) *current ) ) {
         if ( current >= end - 1 || ! *( current + 1 ) ) {
            *current = 0 ;
            break ;
         }
         current ++ ;
      }
      else {
         if ( current >= end ) {
            *current = 0 ;
            break ;
         }
      }
   }

   return string ;
}



////////////////////////////////////////////
//                strlen ()               //
////////////////////////////////////////////



// ԂiMULTIBYTEŁj
// QoCg͂PƂĐ
size_t mbslen ( const char *string ) {

   size_t n ;

   for ( n = 0 ; *string ; n ++, string ++ ) {
      if ( ismbblead ( (unsigned char) *string ) && *( string + 1 ) ) string ++ ;
   }

   return n ;
}



////////////////////////////////////////////
//               mbsbtype ()              //
////////////////////////////////////////////



// }`oCg𔻒
int mbsbtype ( const char *string, size_t count ) {

   int isprevlead = 0 ;

   for ( const char *current = string ; *current ; current ++ ) {
      if ( size_t ( current - string ) == count ) {
         if ( isprevlead ) {
            if ( ismbbtrail ( (unsigned char) *current ) ) return _MBC_TRAIL ;
            else                                           return _MBC_ILLEGAL ;
         }
         else {
            if ( ismbblead ( (unsigned char) *current ) ) return _MBC_LEAD ;
            else if ( *current )                          return _MBC_SINGLE ;
            else                                          return _MBC_ILLEGAL ;
         }
      }
      if ( ! isprevlead && ismbblead ( (unsigned char) *current ) ) isprevlead = 1 ;
      else                                                          isprevlead = 0 ;
   }

   return _MBC_ILLEGAL ;
}



// }`oCg𔻒
int ismbslead ( const char *string, const char *current ) {
   if ( mbsbtype ( string, current - string ) == _MBC_LEAD ) return -1 ;
   return 0 ;
}



// }`oCg𔻒
int ismbstrail ( const char *string, const char *current ) {
   if ( mbsbtype ( string, current - string ) == _MBC_TRAIL ) return -1 ;
   return 0 ;
}



////////////////////////////////////////////
//               strtokex ()              //
////////////////////////////////////////////



// 󔒕Ő؂蕪iANSIŁj
// dpF
// next  NULL ł
// ؂蕪Ԃ
char *strtokex ( char *string, char **next ) {

   if ( ! string ) {
      if ( next ) *next = NULL ;
      return NULL ;
   }

   while ( *string && isascii ( *string ) && isspace ( *string ) ) string ++ ;
   if ( ! *string ) {
      if ( next ) *next = NULL ;
      return NULL ;
   }

   int mode = 0 ;
   size_t countquote = 0 ;
   char *start ;

   for ( start = string ; *string ; string ++ ) {
      if ( *string == '\"' ) {
         mode = ! mode ;
         if ( string == start ) start ++ ;
         else                   countquote ++ ;
      }
      if ( ! mode && isascii ( *string ) && isspace ( *string ) ) break ;
   }

   if ( *string ) { if ( next ) *next = string + 1 ; }
   else           { if ( next ) *next = NULL ; }
   *string = 0 ;

   for ( string = start ; *string && countquote ; string ++ ) {
      if ( *string == '\"' ) {
         if ( *( string + 1 ) ) memmove ( string, string + 1, ( strlen ( string + 1 ) + 1 ) * sizeof(char) ) ;
         else                   *string = 0 ;
         string -- ;
         countquote -- ;
      }
   }

   return start ;
}



// 󔒕Ő؂蕪iUNICODEŁj
// dpF
// next  NULL ł
// ؂蕪Ԃ
wchar_t *wcstokex ( wchar_t *string, wchar_t **next ) {

   if ( ! string ) {
      if ( next ) *next = NULL ;
      return NULL ;
   }

   while ( *string && isascii ( *string ) && isspace ( *string ) ) string ++ ;
   if ( ! *string ) {
      if ( next ) *next = NULL ;
      return NULL ;
   }

   int mode = 0 ;
   size_t countquote = 0 ;
   wchar_t *start ;

   for ( start = string ; *string ; string ++ ) {
      if ( *string == '\"' ) {
         mode = ! mode ;
         if ( string == start ) start ++ ;
         else                   countquote ++ ;
      }
      if ( ! mode && isascii ( *string ) && isspace ( *string ) ) break ;
   }

   if ( *string ) { if ( next ) *next = string + 1 ; }
   else           { if ( next ) *next = NULL ; }
   *string = 0 ;

   for ( string = start ; *string && countquote ; string ++ ) {
      if ( *string == '\"' ) {
         if ( *( string + 1 ) ) memmove ( string, string + 1, ( wcslen ( string + 1 ) + 1 ) * sizeof(wchar_t) ) ;
         else                   *string = 0 ;
         string -- ;
         countquote -- ;
      }
   }

   return start ;
}



////////////////////////////////////////////
//               memchr ()                //
////////////////////////////////////////////



// [當iUNICODEŁj
wchar_t *wmemchr ( const wchar_t *string, int c, size_t count ) {

   while ( count ) {
      if ( c == *string ) return (wchar_t*) string ;
      string ++ ;
      count -- ;
   }

   return NULL ;
}



// [當iMULTIBYTEŁj
char *mbsmemchr ( const char *string, int c, size_t count ) {

   while ( count ) {
      if ( ismbblead ( (unsigned char) *string ) ) {
         if ( count <= 1 ) break ;
         if ( c == ( ( (unsigned char) *string << 8 ) | (unsigned char) *( string + 1 ) ) ) return (char*) string ;
         string ++ ;
         string ++ ;
         count -- ;
         count -- ;
      }
      else {
         if ( c == (unsigned char) *string ) return (char*) string ;
         string ++ ;
         count -- ;
      }
   }

   return NULL ;
}



////////////////////////////////////////////
//               memrchr ()               //
////////////////////////////////////////////



// [̖當iANSIŁj
void *memrchr ( const void *string, int c, size_t count ) {

   const void *result = NULL ;

   while ( count ) {
      if ( c == (unsigned char) *(char*)string ) result = string ;
      string = (char*) string + 1 ;
      count -- ;
   }

   return (void*) result ;
}



// [̖當iUNICODEŁj
wchar_t *wmemrchr ( const wchar_t *string, int c, size_t count ) {

   const wchar_t *result = NULL ;

   while ( count ) {
      if ( c == *string ) result = string ;
      string = string + 1 ;
      count -- ;
   }

   return (wchar_t*) result ;
}



// [̖當iMULTIBYTEŁj
char *mbsmemrchr ( const char *string, int c, size_t count ) {

   const char *result = NULL ;

   while ( count ) {
      if ( ismbblead ( (unsigned char) *string ) ) {
         if ( count <= 1 ) break ;
         if ( c == ( ( (unsigned char) *string << 8 ) | (unsigned char) *( string + 1 ) ) ) result = string ;
         string ++ ;
         string ++ ;
         count -- ;
         count -- ;
      }
      else {
         if ( c == (unsigned char) *string ) result = string ;
         string ++ ;
         count -- ;
      }
   }

   return (char*) result ;
}



////////////////////////////////////////////
//               memcmp ()                //
////////////////////////////////////////////



// [ count riUNICODEŁj
int wmemcmp ( const wchar_t *string1, const wchar_t *string2, size_t count ) {

   int c1, c2 ;

   while ( 1 ) {
      if ( ! count ) return 0 ;
      c1 = *string1 ;
      c2 = *string2 ;
      if ( c1 != c2 ) break ;
      string1 ++ ;
      string2 ++ ;
      count -- ;
   }

   return c1 - c2 ;
}



////////////////////////////////////////////
//               memicmp ()               //
////////////////////////////////////////////



// [ count  ignore case ŔriANSIŁj
int memicmp ( const void *string1, const void *string2, size_t count ) {

   int c1, c2 ;

   while ( 1 ) {
      if ( ! count ) return 0 ;
      c1 = tolower ( (unsigned char) *(char*)string1 ) ;
      c2 = tolower ( (unsigned char) *(char*)string2 ) ;
      if ( c1 != c2 ) break ;
      string1 = (char*) string1 + 1 ;
      string2 = (char*) string2 + 1 ;
      count -- ;
   }

   return c1 - c2 ;
}



// [ count  ignore case ŔriUNICODEŁj
int wmemicmp ( const wchar_t *string1, const wchar_t *string2, size_t count ) {

   int c1, c2 ;

   while ( 1 ) {
      if ( ! count ) return 0 ;
      c1 = tolower ( *string1 ) ;
      c2 = tolower ( *string2 ) ;
      if ( c1 != c2 ) break ;
      string1 ++ ;
      string2 ++ ;
      count -- ;
   }

   return c1 - c2 ;
}



// [ count  ignore case ŔriMULTIBYTEŁj
int mbsmemicmp ( const char *string1, const char *string2, size_t count ) {

   int c1, c2 ;
   int isprevlead1 = 0, isprevlead2 = 0 ;

   while ( 1 ) {
      if ( ! count ) return 0 ;
      c1 = (unsigned char) *string1 ;
      if ( isprevlead1 ) isprevlead1 = 0 ;
      else {
         if ( ismbblead ( c1 ) ) isprevlead1 = 1 ;
         else                    c1 = tolower ( c1 ) ;
      }
      c2 = (unsigned char) *string2 ;
      if ( isprevlead2 ) isprevlead2 = 0 ;
      else {
         if ( ismbblead ( c2 ) ) isprevlead2 = 1 ;
         else                    c2 = tolower ( c2 ) ;
      }
      if ( c1 != c2 ) break ;
      string1 ++ ;
      string2 ++ ;
      count -- ;
   }

   return c1 - c2 ;
}



////////////////////////////////////////////
//               memset ()                //
////////////////////////////////////////////



// obt@𕶎Ŗ߂iUNICODEŁj
// bufsiz  dst Ɏ߂邱Ƃ̂łő̕
wchar_t *wmemset ( wchar_t *dst, int c, size_t bufsiz ) {

   wchar_t *start = dst ;
   wchar_t *end = dst + bufsiz ;

   if ( bufsiz ) {
      while ( dst < end ) *dst ++ = c ;
   }

   return start ;
}



