// wildcard.cpp

#include <windows.h>
#include <stdlib.h>
#include <string.h>
#include "msc.h"
#include "filename.h"
#include "osver.h"
#include "storestr.h"
#include "wildcard.h"


static volatile int IsAborted ;

#ifndef _CONSOLE
static int PeekMessageProc ( void ) ;
#endif


// MAX_PATH 𒴂pX
#define MAX_LONG_PATH   0x7FFF   // max len of "\\?\C:\<path>", "\\?\UNC\<server>\<share>"



// This function is not supported in Win95
#define GETPROCADDRESS(dll,type,function) ( ! dll || ! function && ( function = (type) GetProcAddress ( dll, #function ) ) == NULL )
#define StrCmpLogicalW StrCmpLogicalW_
typedef int ( WINAPI *STRCMPLOGICALW ) ( LPCWSTR psz1, LPCWSTR psz2 ) ;
static HINSTANCE hShlwapi  ;
static STRCMPLOGICALW StrCmpLogicalW ;
static void __cdecl ExitProc ( void ) ;



/////////////////////////////
//         ANSI          //
/////////////////////////////



// ֐
static WILDCARDA *DoSearchWildcardA ( WILDCARDA *Wildcard, const char *szSearchPath, unsigned long dwFlags, int ( CALLBACK *Callback ) ( const char *szSearchPath, WIN32_FIND_DATAA *FindData, int nDepth, LPARAM lParam ), LPARAM lParam, WIN32_FIND_DATAA *pFindData, int nDepth, int ( __cdecl *CompareFunction ) ( const void *, const void * ) ) ;
static int __cdecl CompareStringXpStyleA ( const void *pArg1, const void *pArg2 ) ;
static int __cdecl CompareStringXpStyleReverseA ( const void *pArg1, const void *pArg2 ) ;
static int StrCmpLogicalA ( const char *string1, const char *string2 ) ;
static int IsHaveAnyFileA ( const char *szFileName, int IsSearchHidden ) ;
static int IsNotHaveAnyFileA ( const char *szFileName, int IsSearchHidden ) ;
static int IsValidAnsiLongFileName ( const char *szLongPathName, const char *szShortFileName ) ;



// ChJ[ht@Cobt@Ƀt@Co͂ (ANSI)
// nhɂ CloseWildcard () Ăяo
// t@Coɂ GetFirstFile ()  GetNextFile () Ăяo
// vf̌ GetFileCount () т
// nh܂ł́At@CǉČ邱Ƃł

// Wildcard : ChJ[hnhi NULL ̂Ƃ͐VɊ蓖āj
// szSearchPath : t@CiChJ[hуpX܂މj
// szSearchMode Ɍ[hw肷iڍׂ wildcard.h j
// R[obN֐̖߂l 0 ȂrAlȂ璆~
// ChJ[hnhԂ
// t@CȂƂ NULL Ԃ
// obt@̊mۂɎsƂA܂ AbortWildcard ɂ蒆~ꂽƂ́A
//   obt@NA -1 Ԃ
WILDCARDA *WINAPI SearchWildcardA ( WILDCARDA *Wildcard, const char *szSearchPath, unsigned long dwFlags, int ( CALLBACK *Callback ) ( const char *szSearchPath, WIN32_FIND_DATAA *FindData, int nDepth, LPARAM lParam ), LPARAM lParam ) {

   WIN32_FIND_DATAA FindData ;   // ߖ񂷂邽

   if ( ! GetFileNameA ( szSearchPath ) ) return Wildcard ;

   IsAborted = 0 ;

   // t@CtH_̎w肪Ȃ΃t@Cw
   if ( ! ( dwFlags & WILD_SEARCH_FILE ) && ! ( dwFlags & WILD_SEARCH_FOLDER ) ) dwFlags |= WILD_SEARCH_FILE ;

   if ( ( dwFlags & WILD_NO_EMPTY_DIR ) && ( dwFlags & WILD_ONLY_EMPTY_DIR ) ) dwFlags &= ~ ( WILD_NO_EMPTY_DIR | WILD_ONLY_EMPTY_DIR ) ;

   // \[gp֐I
   if ( dwFlags & WILD_XP_STYLE && dwFlags & ( WILD_SORT | WILD_SORT_REVERSE ) ) {
      if ( ! hShlwapi && ( hShlwapi = LoadLibraryA ( "SHLWAPI.DLL" ) ) ) atexit ( ExitProc ) ;
      if ( GETPROCADDRESS ( hShlwapi, STRCMPLOGICALW, StrCmpLogicalW ) ) dwFlags &= ~ WILD_XP_STYLE ;
   }

   int ( __cdecl *CompareFunction ) ( const void *, const void * ) = NULL ;
   if ( dwFlags & WILD_XP_STYLE ) {
      if ( dwFlags & WILD_SORT )         CompareFunction = CompareStringXpStyleA ;
      if ( dwFlags & WILD_SORT_REVERSE ) CompareFunction = CompareStringXpStyleReverseA ;
   }
   else {
      if ( dwFlags & WILD_SORT )         CompareFunction = SORT_STOREDSTRINGS_NORMAL ;
      if ( dwFlags & WILD_SORT_REVERSE ) CompareFunction = SORT_STOREDSTRINGS_REVERSE ;
   }

   return DoSearchWildcardA ( Wildcard, szSearchPath, dwFlags, Callback, lParam, & FindData, 0, CompareFunction ) ;
}



// SearchWildcardA() ̉֐
// ċAĂяo
static WILDCARDA *DoSearchWildcardA ( WILDCARDA *Wildcard, const char *szSearchPath, unsigned long dwFlags, int ( CALLBACK *Callback ) ( const char *szSearchPath, WIN32_FIND_DATAA *FindData, int nDepth, LPARAM lParam ), LPARAM lParam, WIN32_FIND_DATAA *pFindData, int nDepth, int ( __cdecl *CompareFunction ) ( const void *, const void * ) ) {

#ifndef _CONSOLE
   static int nCountAll ;
#endif

   if ( Wildcard == (WILDCARDA*) -1 ) return (WILDCARDA*) -1 ;


   int IsNoMoreSearchSub = 0 ;


   size_t nSearchPathLength = strlen ( szSearchPath ) ;
   if ( nSearchPathLength > MAX_PATH ) {
      CloseWildcardA ( Wildcard ) ;
      return (WILDCARDA*) -1 ;
   }


   char *szFileName = (char*) malloc ( ( nSearchPathLength + MAX_PATH ) * sizeof(char) ) ;
   if ( ! szFileName ) {
      CloseWildcardA ( Wildcard ) ;
      return (WILDCARDA*) -1 ;
   }


   // ̃tH_̃t@C
   HANDLE hFindFile = FindFirstFileA ( szSearchPath, pFindData ) ;
   if ( hFindFile != INVALID_HANDLE_VALUE ) {

      int IsFirst = 1 ;
      int IsErrorInLoop = 0 ;

      do {

#ifndef _CONSOLE
         if ( ! ( ++ nCountAll & 0xFF ) ) {
            if ( dwFlags & WILD_PEEKMESSAGE ) PeekMessageProc () ;
         }
#endif
         if ( IsAborted ) { IsErrorInLoop = 1 ; break ; }

         if ( ! strcmp ( pFindData->cFileName, "." ) || ! strcmp ( pFindData->cFileName, ".." ) ) {
            if ( ! ( dwFlags & WILD_SEARCH_CURDIR ) ) continue ;
         }
         else {
            if ( pFindData->dwFileAttributes & ( FILE_ATTRIBUTE_HIDDEN | FILE_ATTRIBUTE_SYSTEM ) ) {
               if ( ! ( dwFlags & WILD_SEARCH_HIDDEN ) ) continue ;
            }
            if ( pFindData->dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY ) {
               if ( ! ( dwFlags & WILD_SEARCH_FOLDER ) ) continue ;
            }
            else {
               if ( ! ( dwFlags & WILD_SEARCH_FILE ) ) continue ;
            }
         }

         // Ot@CƃV[gt@ĈǂD
         char *szPriorName = ( dwFlags & WILD_SHORTNAME ) ? pFindData->cAlternateFileName : pFindData->cFileName ;
         char *szAlternateName = ( dwFlags & WILD_SHORTNAME ) ? pFindData->cFileName : pFindData->cAlternateFileName ;

         // Ot@CƃV[gt@C
         if ( ! *szPriorName && *szAlternateName ) szPriorName = szAlternateName ;

         // WȊO̕R[hgĂȂ
         if ( ! ( dwFlags & WILD_SHORTNAME ) && *szAlternateName ) {
            if ( strchr ( szPriorName, '?' ) ) szPriorName = szAlternateName ;
            else if ( ! IsNT () && strchr ( szPriorName, '_' ) ) {
               ChangeFileNameA ( szFileName, szPriorName ) ;
               if ( ! IsValidAnsiLongFileName ( szFileName, szAlternateName ) ) szPriorName = szAlternateName ;
            }
         }

         // ̃fBNg
         if ( pFindData->dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY ) {
            if ( dwFlags & ( WILD_NO_EMPTY_DIR | WILD_ONLY_EMPTY_DIR ) ) {
               strcpy ( szFileName, szSearchPath ) ;
               ChangeFileNameA ( szFileName, szPriorName ) ;
               if ( ( dwFlags & WILD_NO_EMPTY_DIR ) && IsNotHaveAnyFileA ( szFileName, dwFlags & WILD_SEARCH_HIDDEN ) ) continue ;
               if ( ( dwFlags & WILD_ONLY_EMPTY_DIR ) && IsHaveAnyFileA ( szFileName, dwFlags & WILD_SEARCH_HIDDEN ) ) continue ;
            }
         }

         // R[obN֐Ăяo
         if ( Callback ) {
            int nCallbackRetvalue = Callback ( szSearchPath, pFindData, nDepth, lParam ) ;
            if ( nCallbackRetvalue == 0 ) continue ;
            if ( nCallbackRetvalue < 0 ) { IsNoMoreSearchSub = 1 ; break ; }
         }

         // ChJ[h\̂̃m
         if ( ! Wildcard ) {
            Wildcard = (WILDCARDA*) malloc ( sizeof(WILDCARDA) ) ;
            if ( ! Wildcard ) { IsErrorInLoop = 1 ; break ; }
            memset ( Wildcard, 0, sizeof(WILDCARDA) ) ;
         }

         // tH_o
         if ( IsFirst ) {
            IsFirst = 0 ;
            strcpy ( szFileName, szSearchPath ) ;
            if ( ! ( dwFlags & WILD_NO_PIVOT_DIR ) ) {
               ChangeFileNameA ( szFileName, NULL ) ;
               if ( ! ( dwFlags & WILD_WITHPATH ) ) {
                  if ( ! *szFileName && Wildcard->StoredNames ) Wildcard->StoredNames = StoreStringsA ( Wildcard->StoredNames, ".\\" ) ;
                  else                                          Wildcard->StoredNames = StoreStringsA ( Wildcard->StoredNames, szFileName ) ;
                  if ( Wildcard->StoredNames == (STOREDSTRINGSA*) -1 ) { IsErrorInLoop = 1 ; break ; }
               }
            }
            MarkSortStartA ( Wildcard->StoredNames ) ;
         }

         // pXo͂ꍇ
         if ( dwFlags & WILD_WITHPATH ) {
            ChangeFileNameA ( szFileName, szPriorName ) ;
            // vt@Co
            Wildcard->StoredNames = StoreStringsA ( Wildcard->StoredNames, szFileName ) ;
         }
         // pXo͂Ȃꍇ
         else {
            // vt@Co
            Wildcard->StoredNames = StoreStringsA ( Wildcard->StoredNames, szPriorName ) ;
         }

         if ( Wildcard->StoredNames == (STOREDSTRINGSA*) -1 ) { IsErrorInLoop = 1 ; break ; }

      } while ( FindNextFileA ( hFindFile, pFindData ) ) ;

      FindClose ( hFindFile ) ;

      // G[܂͒~
      if ( IsErrorInLoop ) {
         CloseWildcardA ( Wildcard ) ;
         free ( szFileName ) ;
         return (WILDCARDA*) -1 ;
      }

      // t@C\[g
      if ( Wildcard && CompareFunction && SortStoredStringsA ( Wildcard->StoredNames, CompareFunction ) ) {
         CloseWildcardA ( Wildcard ) ;
         free ( szFileName ) ;
         return (WILDCARDA*) -1 ;
      }
   }



   // TufBNgAċAĂяosȂ
   if ( dwFlags & WILD_SEARCH_SUB && ! IsNoMoreSearchSub ) {

      strcpy ( szFileName, szSearchPath ) ;
      ChangeFileNameA ( szFileName, "*" ) ;

      WILDCARDA *WildcardSub = DoSearchWildcardA ( NULL, szFileName, WILD_SEARCH_FOLDER | WILD_NO_PIVOT_DIR | ( dwFlags & WILD_SHORTNAME ) | ( ( dwFlags & WILD_SEARCH_HIDDENSUB ) ? WILD_SEARCH_HIDDEN : 0 ), NULL, NULL, pFindData, 0, CompareFunction ) ;

      if ( WildcardSub == (WILDCARDA*) -1 ) {
         CloseWildcardA ( Wildcard ) ;
         free ( szFileName ) ;
         return (WILDCARDA*) -1 ;
      }

      // tH_݂ꍇ
      if ( WildcardSub ) {

         for ( char *szString = GetFirstFileA ( WildcardSub ) ; szString ; szString = GetNextFileA ( WildcardSub ) ) {

            strcpy ( szFileName, szSearchPath ) ;
            ChangeFileNameA ( szFileName, szString ) ;
            strcat ( szFileName, "\\" ) ;
            strcat ( szFileName, GetFileNameA ( szSearchPath ) ) ;

            // ċAĂяo
            Wildcard = DoSearchWildcardA ( Wildcard, szFileName, dwFlags, Callback, lParam, pFindData, nDepth + 1, CompareFunction ) ;
            if ( Wildcard == (WILDCARDA*) -1 ) break ;
         }

         CloseWildcardA ( WildcardSub ) ;
      }
   }

   free ( szFileName ) ;
   return Wildcard ;
}



// t@Cobt@ (ANSI)
// SearchWildcard () gƂ̓vZX̏I܂łɕK CloseWildcard () Ăяo
void WINAPI CloseWildcardA ( WILDCARDA *Wildcard ) {
   if ( ! Wildcard || Wildcard == (WILDCARDA*) -1 ) return ;
   if ( Wildcard->StoredNames && Wildcard->StoredNames != (STOREDSTRINGSA*) -1 ) FreeStoredStringsA ( Wildcard->StoredNames ) ;
   free ( Wildcard ) ;
   return ;
}



// t@Cobt@̃t@ČԂ (ANSI)
size_t WINAPI GetFileCountA ( WILDCARDA *Wildcard ) {
   if ( Wildcard == NULL || Wildcard == (WILDCARDA*) -1 ) return 0 ;
   return GetStringCountA ( Wildcard->StoredNames ) ;
}



// t@Cobt@ŏ̃t@CԂ (ANSI)
// t@CȂ΁ANULL Ԃ
char *WINAPI GetFirstFileA ( WILDCARDA *Wildcard ) {
   if ( Wildcard == NULL || Wildcard == (WILDCARDA*) -1 ) return NULL ;
   return GetFirstStringA ( Wildcard->StoredNames ) ;
}



// t@Cobt@玟̃t@CԂ (ANSI)
// t@CȂ΁ANULL Ԃ
// GetFirstFile () ĂяoOȂ΁A͕s
char *WINAPI GetNextFileA ( WILDCARDA *Wildcard ) {
   if ( Wildcard == NULL || Wildcard == (WILDCARDA*) -1 ) return NULL ;
   return GetNextStringA ( Wildcard->StoredNames ) ;
}



// Ń\[g (XPX^C)
static int __cdecl CompareStringXpStyleA ( const void *pArg1, const void *pArg2 ) {
   return StrCmpLogicalA ( *(const char**)pArg1, *(const char**)pArg2 ) ;
}



// tŃ\[g (XPX^C)
static int __cdecl CompareStringXpStyleReverseA ( const void *pArg1, const void *pArg2 ) {
   return - StrCmpLogicalA ( *(const char**)pArg1, *(const char**)pArg2 ) ;
}



// StrCmpLogicalW()  ANSI
static int StrCmpLogicalA ( const char *string1, const char *string2 ) {

   int result = 0 ;
   wchar_t *sz1 = NULL, *sz2 = NULL ;
   int len ;

   if ( ! ( len = MultiByteToWideChar ( CP_ACP, 0, string1, -1, NULL, 0 ) ) ) goto CAUGHT_ERROR ;
   if ( ! ( sz1 = (wchar_t*) malloc ( len * sizeof(wchar_t) ) ) ) goto CAUGHT_ERROR ;
   if ( ! ( len = MultiByteToWideChar ( CP_ACP, 0, string1, -1, sz1, len ) ) ) goto CAUGHT_ERROR ;

   if ( ! ( len = MultiByteToWideChar ( CP_ACP, 0, string2, -1, NULL, 0 ) ) ) goto CAUGHT_ERROR ;
   if ( ! ( sz2 = (wchar_t*) malloc ( len * sizeof(wchar_t) ) ) ) goto CAUGHT_ERROR ;
   if ( ! ( len = MultiByteToWideChar ( CP_ACP, 0, string2, -1, sz2, len ) ) ) goto CAUGHT_ERROR ;

   result = StrCmpLogicalW ( sz1, sz2 ) ;

   CAUGHT_ERROR :
   free ( sz1 ) ;
   free ( sz2 ) ;

   return result ;
}



// t@CfBNgȂ 1 AȂ 0 Ԃ
static int IsHaveAnyFileA ( const char *szFileName, int IsSearchHidden ) {

   int nResult = 0 ;

   char *szSearchPath = (char*) malloc ( ( strlen ( szFileName ) + 0x10 ) * sizeof(char) ) ;
   if ( ! szSearchPath ) return nResult ;

   strcpy ( szSearchPath, szFileName ) ;
   strcat ( szSearchPath, "\\*" ) ;

   WIN32_FIND_DATAA FindData ;

   HANDLE hFindFile = FindFirstFileA ( szSearchPath, & FindData ) ;
   if ( hFindFile != INVALID_HANDLE_VALUE ) {

      do {

         if ( ! IsSearchHidden && FindData.dwFileAttributes & ( FILE_ATTRIBUTE_HIDDEN | FILE_ATTRIBUTE_SYSTEM ) ) continue ;
         if ( ! strcmp ( FindData.cFileName, "." ) || ! strcmp ( FindData.cFileName, ".." ) ) continue ;

         nResult = 1 ;
         break ;

      } while ( FindNextFileA ( hFindFile, & FindData ) ) ;

      FindClose ( hFindFile ) ;
   }

   free ( szSearchPath ) ;

   return nResult ;
}



// t@CȂ 0 AȂ 1 Ԃ
static int IsNotHaveAnyFileA ( const char *szFileName, int IsSearchHidden ) {

   int nResult = 1 ;

   char *szSearchPath = (char*) malloc ( ( strlen ( szFileName ) + 0x10 ) * sizeof(char) ) ;
   if ( ! szSearchPath ) return nResult ;

   strcpy ( szSearchPath, szFileName ) ;
   strcat ( szSearchPath, "\\*" ) ;

   WIN32_FIND_DATAA FindData ;

   HANDLE hFindFile = FindFirstFileA ( szSearchPath, & FindData ) ;
   if ( hFindFile != INVALID_HANDLE_VALUE ) {

      do {

         if ( FindData.dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY ) continue ;
         if ( ! IsSearchHidden && FindData.dwFileAttributes & ( FILE_ATTRIBUTE_HIDDEN | FILE_ATTRIBUTE_SYSTEM ) ) continue ;
         if ( ! strcmp ( FindData.cFileName, "." ) || ! strcmp ( FindData.cFileName, ".." ) ) continue ;

         nResult = 0 ;
         break ;

      } while ( FindNextFileA ( hFindFile, & FindData ) ) ;

      FindClose ( hFindFile ) ;
   }

   free ( szSearchPath ) ;

   return nResult ;
}



// Ot@CLǂ
// szLongPathName ̓pXtŁAszShortFileName ̓t@Ĉ݂Ŏw
static int IsValidAnsiLongFileName ( const char *szLongPathName, const char *szShortFileName ) {

   WIN32_FIND_DATAA FindData ;
   int nRetValue = 0 ;

   HANDLE hFindFile = FindFirstFileA ( szLongPathName, & FindData ) ;
   if ( hFindFile != INVALID_HANDLE_VALUE ) {
      if ( ! strcmp ( FindData.cAlternateFileName, szShortFileName ) ) nRetValue = 1 ;
      if ( FindNextFileA ( hFindFile, & FindData ) ) nRetValue = 0 ;
      FindClose ( hFindFile ) ;
   }

   return nRetValue ;
}



/////////////////////////////
//       UNICODE         //
/////////////////////////////



// ֐
static WILDCARDW *DoSearchWildcardW ( WILDCARDW *Wildcard, const wchar_t *szSearchPath, unsigned long dwFlags, int ( CALLBACK *Callback ) ( const wchar_t *szSearchPath, WIN32_FIND_DATAW *FindData, int nDepth, LPARAM lParam ), LPARAM lParam, WIN32_FIND_DATAW *pFindData, int nDepth, int ( __cdecl *CompareFunction ) ( const void *, const void * ) ) ;
static int __cdecl CompareStringXpStyleW ( const void *pArg1, const void *pArg2 ) ;
static int __cdecl CompareStringXpStyleReverseW ( const void *pArg1, const void *pArg2 ) ;
static int IsHaveAnyFileW ( const wchar_t *szFileName, int IsSearchHidden ) ;
static int IsNotHaveAnyFileW ( const wchar_t *szFileName, int IsSearchHidden ) ;



// ChJ[ht@Cobt@Ƀt@Co͂ (UNICODE)
// nhɂ CloseWildcard () Ăяo
// t@Coɂ GetFirstFile ()  GetNextFile () Ăяo
// vf̌ GetFileCount () т
// nh܂ł́At@CǉČ邱Ƃł

// Wildcard : ChJ[hnhi NULL ̂Ƃ͐VɊ蓖āj
// szSearchPath : t@CiChJ[hуpX܂މj
// szSearchMode Ɍ[hw肷iڍׂ wildcard.h j
// R[obN֐̖߂l 0 ȂrAlȂ璆~
// ChJ[hnhԂ
// t@CȂƂ NULL Ԃ
// obt@̊mۂɎsƂA܂ AbortWildcard ɂ蒆~ꂽƂ́A
//   obt@NA -1 Ԃ
WILDCARDW *WINAPI SearchWildcardW ( WILDCARDW *Wildcard, const wchar_t *szSearchPath, unsigned long dwFlags, int ( CALLBACK *Callback ) ( const wchar_t *szSearchPath, WIN32_FIND_DATAW *FindData, int nDepth, LPARAM lParam ), LPARAM lParam ) {

   WIN32_FIND_DATAW FindData ;   // ߖ񂷂邽

   if ( ! GetFileNameW ( szSearchPath ) ) return Wildcard ;

   IsAborted = 0 ;

   // t@CtH_̎w肪Ȃ΃t@Cw
   if ( ! ( dwFlags & WILD_SEARCH_FILE ) && ! ( dwFlags & WILD_SEARCH_FOLDER ) ) dwFlags |= WILD_SEARCH_FILE ;

   if ( ( dwFlags & WILD_NO_EMPTY_DIR ) && ( dwFlags & WILD_ONLY_EMPTY_DIR ) ) dwFlags &= ~ ( WILD_NO_EMPTY_DIR | WILD_ONLY_EMPTY_DIR ) ;

   // \[gp֐I
   if ( dwFlags & WILD_XP_STYLE && dwFlags & ( WILD_SORT | WILD_SORT_REVERSE ) ) {
      if ( ! hShlwapi && ( hShlwapi = LoadLibraryW ( L"SHLWAPI.DLL" ) ) ) atexit ( ExitProc ) ;
      if ( GETPROCADDRESS ( hShlwapi, STRCMPLOGICALW, StrCmpLogicalW ) ) dwFlags &= ~ WILD_XP_STYLE ;
   }

   int ( __cdecl *CompareFunction ) ( const void *, const void * ) = NULL ;
   if ( dwFlags & WILD_XP_STYLE ) {
      if ( dwFlags & WILD_SORT )         CompareFunction = CompareStringXpStyleW ;
      if ( dwFlags & WILD_SORT_REVERSE ) CompareFunction = CompareStringXpStyleReverseW ;
   }
   else {
      if ( dwFlags & WILD_SORT )         CompareFunction = SORT_STOREDSTRINGS_NORMAL ;
      if ( dwFlags & WILD_SORT_REVERSE ) CompareFunction = SORT_STOREDSTRINGS_REVERSE ;
   }

   return DoSearchWildcardW ( Wildcard, szSearchPath, dwFlags, Callback, lParam, & FindData, 0, CompareFunction ) ;
}



// SearchWildcardW() ̉֐
// ċAĂяo
static WILDCARDW *DoSearchWildcardW ( WILDCARDW *Wildcard, const wchar_t *szSearchPath, unsigned long dwFlags, int ( CALLBACK *Callback ) ( const wchar_t *szSearchPath, WIN32_FIND_DATAW *FindData, int nDepth, LPARAM lParam ), LPARAM lParam, WIN32_FIND_DATAW *pFindData, int nDepth, int ( __cdecl *CompareFunction ) ( const void *, const void * ) ) {

#ifndef _CONSOLE
   static int nCountAll ;
#endif

   if ( Wildcard == (WILDCARDW*) -1 ) return (WILDCARDW*) -1 ;


   int IsNoMoreSearchSub = 0 ;


   size_t nSearchPathLength = wcslen ( szSearchPath ) ;
   if ( nSearchPathLength > MAX_LONG_PATH ) {
      CloseWildcardW ( Wildcard ) ;
      return (WILDCARDW*) -1 ;
   }


   wchar_t *szFileName = (wchar_t*) malloc ( ( nSearchPathLength + MAX_PATH ) * sizeof(wchar_t) ) ;
   if ( ! szFileName ) {
      CloseWildcardW ( Wildcard ) ;
      return (WILDCARDW*) -1 ;
   }


   // ̃tH_̃t@C
   HANDLE hFindFile = FindFirstFileW ( szSearchPath, pFindData ) ;
   if ( hFindFile != INVALID_HANDLE_VALUE ) {

      int IsFirst = 1 ;
      int IsErrorInLoop = 0 ;

      do {

#ifndef _CONSOLE
         if ( ! ( ++ nCountAll & 0xFF ) ) {
            if ( dwFlags & WILD_PEEKMESSAGE ) PeekMessageProc () ;
         }
#endif
         if ( IsAborted ) { IsErrorInLoop = 1 ; break ; }

         if ( ! wcscmp ( pFindData->cFileName, L"." ) || ! wcscmp ( pFindData->cFileName, L".." ) ) {
            if ( ! ( dwFlags & WILD_SEARCH_CURDIR ) ) continue ;
         }
         else {
            if ( pFindData->dwFileAttributes & ( FILE_ATTRIBUTE_HIDDEN | FILE_ATTRIBUTE_SYSTEM ) ) {
               if ( ! ( dwFlags & WILD_SEARCH_HIDDEN ) ) continue ;
            }
            if ( pFindData->dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY ) {
               if ( ! ( dwFlags & WILD_SEARCH_FOLDER ) ) continue ;
            }
            else {
               if ( ! ( dwFlags & WILD_SEARCH_FILE ) ) continue ;
            }
         }

         // Ot@CƃV[gt@ĈǂD
         wchar_t *szPriorName = ( dwFlags & WILD_SHORTNAME ) ? pFindData->cAlternateFileName : pFindData->cFileName ;
         wchar_t *szAlternateName = ( dwFlags & WILD_SHORTNAME ) ? pFindData->cFileName : pFindData->cAlternateFileName ;

         // Ot@CƃV[gt@C
         if ( ! *szPriorName && *szAlternateName ) szPriorName = szAlternateName ;

         // ̃fBNg
         if ( pFindData->dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY ) {
            if ( dwFlags & ( WILD_NO_EMPTY_DIR | WILD_ONLY_EMPTY_DIR ) ) {
               wcscpy ( szFileName, szSearchPath ) ;
               ChangeFileNameW ( szFileName, szPriorName ) ;
               if ( ( dwFlags & WILD_NO_EMPTY_DIR ) && IsNotHaveAnyFileW ( szFileName, dwFlags & WILD_SEARCH_HIDDEN ) ) continue ;
               if ( ( dwFlags & WILD_ONLY_EMPTY_DIR ) && IsHaveAnyFileW ( szFileName, dwFlags & WILD_SEARCH_HIDDEN ) ) continue ;
            }
         }

         // R[obN֐Ăяo
         if ( Callback ) {
            int nCallbackRetvalue = Callback ( szSearchPath, pFindData, nDepth, lParam ) ;
            if ( nCallbackRetvalue == 0 ) continue ;
            if ( nCallbackRetvalue < 0 ) { IsNoMoreSearchSub = 1 ; break ; }
         }

         // ChJ[h\̂̃m
         if ( ! Wildcard ) {
            Wildcard = (WILDCARDW*) malloc ( sizeof(WILDCARDW) ) ;
            if ( ! Wildcard ) { IsErrorInLoop = 1 ; break ; }
            memset ( Wildcard, 0, sizeof(WILDCARDW) ) ;
         }

         // tH_o
         if ( IsFirst ) {
            IsFirst = 0 ;
            wcscpy ( szFileName, szSearchPath ) ;
            if ( ! ( dwFlags & WILD_NO_PIVOT_DIR ) ) {
               ChangeFileNameW ( szFileName, NULL ) ;
               if ( ! ( dwFlags & WILD_WITHPATH ) ) {
                  if ( ! *szFileName && Wildcard->StoredNames ) Wildcard->StoredNames = StoreStringsW ( Wildcard->StoredNames, L".\\" ) ;
                  else                                          Wildcard->StoredNames = StoreStringsW ( Wildcard->StoredNames, szFileName ) ;
                  if ( Wildcard->StoredNames == (STOREDSTRINGSW*) -1 ) { IsErrorInLoop = 1 ; break ; }
               }
            }
            MarkSortStartW ( Wildcard->StoredNames ) ;
         }

         // pXo͂ꍇ
         if ( dwFlags & WILD_WITHPATH ) {
            ChangeFileNameW ( szFileName, szPriorName ) ;
            // vt@Co
            Wildcard->StoredNames = StoreStringsW ( Wildcard->StoredNames, szFileName ) ;
         }
         // pXo͂Ȃꍇ
         else {
            // vt@Co
            Wildcard->StoredNames = StoreStringsW ( Wildcard->StoredNames, szPriorName ) ;
         }
         if ( Wildcard->StoredNames == (STOREDSTRINGSW*) -1 ) { IsErrorInLoop = 1 ; break ; }

      } while ( FindNextFileW ( hFindFile, pFindData ) ) ;

      FindClose ( hFindFile ) ;

      // G[܂͒~
      if ( IsErrorInLoop ) {
         CloseWildcardW ( Wildcard ) ;
         free ( szFileName ) ;
         return (WILDCARDW*) -1 ;
      }

      // t@C\[g
      if ( Wildcard && CompareFunction && SortStoredStringsW ( Wildcard->StoredNames, CompareFunction ) ) {
         CloseWildcardW ( Wildcard ) ;
         free ( szFileName ) ;
         return (WILDCARDW*) -1 ;
      }
   }



   // TufBNgAċAĂяosȂ
   if ( dwFlags & WILD_SEARCH_SUB && ! IsNoMoreSearchSub ) {

      wcscpy ( szFileName, szSearchPath ) ;
      ChangeFileNameW ( szFileName, L"*" ) ;

      WILDCARDW *WildcardSub = DoSearchWildcardW ( NULL, szFileName, WILD_SEARCH_FOLDER | WILD_NO_PIVOT_DIR | ( dwFlags & WILD_SHORTNAME ) | ( ( dwFlags & WILD_SEARCH_HIDDENSUB ) ? WILD_SEARCH_HIDDEN : 0 ), NULL, NULL, pFindData, 0, CompareFunction ) ;

      if ( WildcardSub == (WILDCARDW*) -1 ) {
         CloseWildcardW ( Wildcard ) ;
         free ( szFileName ) ;
         return (WILDCARDW*) -1 ;
      }

      // tH_݂ꍇ
      if ( WildcardSub ) {

         for ( wchar_t *szString = GetFirstFileW ( WildcardSub ) ; szString ; szString = GetNextFileW ( WildcardSub ) ) {

            wcscpy ( szFileName, szSearchPath ) ;
            ChangeFileNameW ( szFileName, szString ) ;
            wcscat ( szFileName, L"\\" ) ;
            wcscat ( szFileName, GetFileNameW ( szSearchPath ) ) ;

            // ċAĂяo
            Wildcard = DoSearchWildcardW ( Wildcard, szFileName, dwFlags, Callback, lParam, pFindData, nDepth + 1, CompareFunction ) ;
            if ( Wildcard == (WILDCARDW*) -1 ) break ;
         }

         CloseWildcardW ( WildcardSub ) ;
      }
   }

   free ( szFileName ) ;
   return Wildcard ;
}



// t@Cobt@ (UNICODE)
// SearchWildcard () gƂ̓vZX̏I܂łɕK CloseWildcard () Ăяo
void WINAPI CloseWildcardW ( WILDCARDW *Wildcard ) {
   if ( ! Wildcard || Wildcard == (WILDCARDW*) -1 ) return ;
   if ( Wildcard->StoredNames && Wildcard->StoredNames != (STOREDSTRINGSW*) -1 ) FreeStoredStringsW ( Wildcard->StoredNames ) ;
   free ( Wildcard ) ;
   return ;
}



// t@Cobt@̃t@ČԂ (UNICODE)
size_t WINAPI GetFileCountW ( WILDCARDW *Wildcard ) {
   if ( Wildcard == NULL || Wildcard == (WILDCARDW*) -1 ) return 0 ;
   return GetStringCountW ( Wildcard->StoredNames ) ;
}



// t@Cobt@ŏ̃t@CԂ (UNICODE)
// t@CȂ΁ANULL Ԃ
wchar_t *WINAPI GetFirstFileW ( WILDCARDW *Wildcard ) {
   if ( Wildcard == NULL || Wildcard == (WILDCARDW*) -1 ) return NULL ;
   return GetFirstStringW ( Wildcard->StoredNames ) ;
}



// t@Cobt@玟̃t@CԂ (UNICODE)
// t@CȂ΁ANULL Ԃ
// GetFirstFile () ĂяoOȂ΁A͕s
wchar_t *WINAPI GetNextFileW ( WILDCARDW *Wildcard ) {
   if ( Wildcard == NULL || Wildcard == (WILDCARDW*) -1 ) return NULL ;
   return GetNextStringW ( Wildcard->StoredNames ) ;
}



// Ń\[g (XPX^C)
static int __cdecl CompareStringXpStyleW ( const void *pArg1, const void *pArg2 ) {
   return StrCmpLogicalW ( *(const wchar_t**)pArg1, *(const wchar_t**)pArg2 ) ;
}



// tŃ\[g (XPX^C)
static int __cdecl CompareStringXpStyleReverseW ( const void *pArg1, const void *pArg2 ) {
   return - StrCmpLogicalW ( *(const wchar_t**)pArg1, *(const wchar_t**)pArg2 ) ;
}



// t@CfBNgȂ 1 AȂ 0 Ԃ
static int IsHaveAnyFileW ( const wchar_t *szFileName, int IsSearchHidden ) {

   int nResult = 0 ;

   wchar_t *szSearchPath = (wchar_t*) malloc ( ( wcslen ( szFileName ) + 0x10 ) * sizeof(wchar_t) ) ;
   if ( ! szSearchPath ) return nResult ;

   wcscpy ( szSearchPath, szFileName ) ;
   wcscat ( szSearchPath, L"\\*" ) ;

   WIN32_FIND_DATAW FindData ;

   HANDLE hFindFile = FindFirstFileW ( szSearchPath, & FindData ) ;
   if ( hFindFile != INVALID_HANDLE_VALUE ) {

      do {

         if ( ! IsSearchHidden && FindData.dwFileAttributes & ( FILE_ATTRIBUTE_HIDDEN | FILE_ATTRIBUTE_SYSTEM ) ) continue ;
         if ( ! wcscmp ( FindData.cFileName, L"." ) || ! wcscmp ( FindData.cFileName, L".." ) ) continue ;

         nResult = 1 ;
         break ;

      } while ( FindNextFileW ( hFindFile, & FindData ) ) ;

      FindClose ( hFindFile ) ;
   }

   free ( szSearchPath ) ;

   return nResult ;
}



// t@CȂ 0 AȂ 1 Ԃ
static int IsNotHaveAnyFileW ( const wchar_t *szFileName, int IsSearchHidden ) {

   int nResult = 1 ;

   wchar_t *szSearchPath = (wchar_t*) malloc ( ( wcslen ( szFileName ) + 0x10 ) * sizeof(wchar_t) ) ;
   if ( ! szSearchPath ) return nResult ;

   wcscpy ( szSearchPath, szFileName ) ;
   wcscat ( szSearchPath, L"\\*" ) ;

   WIN32_FIND_DATAW FindData ;

   HANDLE hFindFile = FindFirstFileW ( szSearchPath, & FindData ) ;
   if ( hFindFile != INVALID_HANDLE_VALUE ) {

      do {

         if ( FindData.dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY ) continue ;
         if ( ! IsSearchHidden && FindData.dwFileAttributes & ( FILE_ATTRIBUTE_HIDDEN | FILE_ATTRIBUTE_SYSTEM ) ) continue ;
         if ( ! wcscmp ( FindData.cFileName, L"." ) || ! wcscmp ( FindData.cFileName, L".." ) ) continue ;

         nResult = 0 ;
         break ;

      } while ( FindNextFileW ( hFindFile, & FindData ) ) ;

      FindClose ( hFindFile ) ;
   }

   free ( szSearchPath ) ;

   return nResult ;
}



////////////////////////////////////////////
//             PEEK MESSAGE               //
////////////////////////////////////////////


#ifndef _CONSOLE


static HWND hDialog ;
static int IsPeekMessageUnicode ;
static int IsPeekMessageInitialized ;


// bZ[W[vŃL[{[h͂߂邽߂̃_CAOnhw
//  0 As 1 Ԃ
int WINAPI SetWildcardDialogWindow ( HWND hWnd, int IsDialog ) {

   IsPeekMessageInitialized = 1 ;

   if ( hWnd ) {
      if ( IsDialog ) hDialog = hWnd ;
      else            hDialog = NULL ;
      IsPeekMessageUnicode = IsWindowUnicode ( hWnd ) ;
   }
   else {
      hDialog = NULL ;
      IsPeekMessageUnicode = IsNT () ;
   }

   return 0 ;
}


// bZ[W[v܂킷
static int PeekMessageProc ( void ) {

   if ( ! IsPeekMessageInitialized ) SetWildcardDialogWindow ( NULL, 0 ) ;

   MSG Msg ;
   if ( IsPeekMessageUnicode ) {
      while ( PeekMessageW ( & Msg, NULL, 0, 0, PM_REMOVE ) ) {
         if ( ! hDialog || ! IsDialogMessageW ( hDialog, & Msg ) ) {
            TranslateMessage ( & Msg ) ;
            DispatchMessageW ( & Msg ) ;
         }
      }
   }
   else {
      while ( PeekMessageA ( & Msg, NULL, 0, 0, PM_REMOVE ) ) {
         if ( ! hDialog || ! IsDialogMessageA ( hDialog, & Msg ) ) {
            TranslateMessage ( & Msg ) ;
            DispatchMessageA ( & Msg ) ;
         }
      }
   }
   return 0 ;
}


#endif


/////////////////////////////
//         ʊ֐        //
/////////////////////////////



// ~𖽂
int WINAPI AbortWildcard ( void ) {
   IsAborted = 1 ;
   return 0 ;
}



static void __cdecl ExitProc ( void ) {
   if ( hShlwapi ) FreeLibrary ( hShlwapi ) ;
}



